#!/usr/bin/perl

use strict;

my $pathiso = "/var/lib/vz/template/iso";
my $path = ".";
my $iso = "iso";
my $file = "avtest";

my $extended = shift;

my %keys = ("192.168.0.2" => "192.168.2.1",
            "192.168.0.2" => "192.168.2.1",
						"192.168.0.141" => "192.168.2.141",
						"192.168.0.142" => "192.168.2.142",
						"192.168.0.143" => "192.168.2.143",
						"255.255.255.0" => "255.255.255.0");

my %cluster = ("192.168.0.141,142,143" => "192.168.2.141,142,143");

foreach my $nr ("1","2","3") {
  my $cmd = "mkdir $path/$iso$nr";
  doit($cmd) if !-e "$path/$iso$nr";
	my $file0 = "$pathiso/$file"."0.iso";
  $cmd = "mount -o loop $file0 $path/$iso$nr",
  doit($cmd);
}

my $c1=1;

foreach my $c ("141","142","143") {
  my $cmd = "mkdir $c";
	doit($cmd) if !-e $c;
  $cmd = "rm -f $path/$c/*";
	doit($cmd);
  $cmd = "cp -rpf $path/$iso$c1/* $path/$c";
	doit($cmd);
	my $file = "isolinux.$c";
  $cmd = "cp $path/$file $path/$c/isolinux.cfg";
  doit($cmd);
	my $file = "$path/$c/isolinux.cfg";
	adjustip($file,%keys) if $extended==1;
  $cmd = "cp $path/$c/isolinux.cfg $path/$c/syslinux.cfg";
  doit($cmd);
  $cmd = "cp $path/postproc.sh $path/$c";
  doit($cmd);
	$file = "$path/$c/postproc.sh";
	adjustip($file,%cluster) if $extended==1;
  $cmd = "cp $path/postrun.sh $path/$c";
  doit($cmd);
  $cmd="genisoimage -o $pathiso/avtest$c.iso -r -J -no-emul-boot ".
	             "-boot-load-size 4 ".
               "-boot-info-table -b isolinux.bin -c boot.cat $path/$c";
  doit($cmd);
	$c1++;
}
foreach my $nr ("1","2","3") {
  my $cmd = "umount $path/$iso$nr";
  doit($cmd);
}


sub doit {
  my ($cmd) = @_;
  print "$cmd\n";
	system("$cmd");
}

sub adjustip {
  my ($file,%keys) = @_;
	my $fh = open(FIN,$file);
	my @text = <FIN>;
	my $text = join("",@text);
	foreach my $key (keys %keys) {
	  my $val = $keys{$key};
	  $text =~ s/($key)/$val/g;
	}
	$fh = open(FOUT,">$file");
	print FOUT $text;
	close(FOUT);
}
