package PVE::I18N;

use strict;
require Exporter;
use vars qw(@ISA @EXPORT);
use Encode;
use HTML::Entities;

@ISA = qw(Exporter);
@EXPORT = qw( __ );

my $language = 'C';

sub get_lang {
  my $section = 'default';
  my $lang = 'C';
  open (SYSCFG, "</etc/pve/pve.cfg") || return $lang;
  while (my $line = <SYSCFG>) {
	  chomp $line;
	  if ($line =~ m/\s*language\s*:\s*(\S+)\s*$/) {
	    $lang = $1;
	    last;
	  }
  } 
  close (SYSCFG);
  return $lang;
}

my %lg = ();

sub set_lang {
  my $lang = shift;
  $language = $lang;
	readstrings($lang,1) if $lg{'Active'} eq "";
}

sub readstrings {
	my ($lang,$init) = @_;
  if ($init==1) { %lg=(); }
	my $file = "/usr/share/pve-manager/css/".$lang.".po";
	return if !-e $file;
	open(FIN,$file);
	my @lines=<FIN>;
	close(FIN);
  my $strkey="";
	my $strval="";
	my $code="";
	my $text="";
  foreach my $line (@lines) {
		chomp $line;
    if ($line ne "") {
      if ($strkey eq "") {
        ($code,$text)=split('msgid "',$line);
   	    if ($code eq '' && $text ne '') {
		      $strkey=substr($text,0,length($text)-1);
		    }
			} else {
				($code,$text)=split('msgstr "',$line);
			  if ($code eq '' && $text ne '') {
					$strval=substr($text,0,length($text)-1);
        }
        if ($strval ne "") {
					$lg{$strkey}=$strval;
          $strkey="";
					$strval="";
       	}
			}
		}
	}
}

sub __ { 
  my $res = shift;
	$res=$lg{$res} if $lg{$res} ne "";
  $res = encode_entities ($res);
  $res =~ s/&gt;/>/g;
  $res =~ s/&lt;/</g;
  $res =~ s/&\#39;/\'/g;
  return $res;
}

1;
