#!/bin/bash
. ${0%/*}/gnomesu.in
HTTPS_ENABLE_MSG=`findit "HTTPS_ENABLE_MSG" $zeile`
HTTPS_ENABLE_ALREADY=`findit "HTTPS_ENABLE_ALREADY" $zeile`
HTTPS_ENABLE_IP=`findit "HTTPS_ENABLE_IP" $zeile`
HTTPS_ENABLE_COUNTRY=`findit "HTTPS_ENABLE_COUNTRY" $zeile`
HTTPS_ENABLE_COUNTRY="Ländercode";
HTTPS_ENABLE_COUNTRY_ERR=`findit "HTTPS_ENABLE_COUNTRY_ERR" $zeile`
HTTPS_ENABLE_STATE=`findit "HTTPS_ENABLE_STATE" $zeile`
HTTPS_ENABLE_CITY=`findit "HTTPS_ENABLE_CITY" $zeile`
HTTPS_ENABLE_ORGA=`findit "HTTPS_ENABLE_ORGA" $zeile`
HTTPS_ENABLE_DEP=`findit "HTTPS_ENABLE_DEP" $zeile`
HTTPS_ENABLE_ERR=`findit "HTTPS_ENABLE_ERR" $zeile`
HTTPS_ENABLE_FIN=`findit "HTTPS_ENABLE_FIN" $zeile`
goroot "$HTTPS_ENABLE_MSG" "$*"
msgyesno "$HTTPS_ENABLE_ALREADY" "--defaultno" || exit

# previous options for usability
[ -e /etc/pve/last ] && . /etc/pve/last

[ "$ip" ] || ip=`ifconfig eth0 | sed -n "s/.*inet addr:\([^ ]\+\) .*/\1/p"`
ip=`inputbox "$HTTPS_ENABLE_IP" $ip` || exit

tcountry="$country"; country=""
until [ "$country" ]; do
	tcountry=`inputbox "$HTTPS_ENABLE_COUNTRY" "$tcountry"` || exit
	# upper case
	tcountry="`echo $tcountry | tr a-z A-Z`"
	# valid two letter code?
	if [[ "$tcountry" = [A-Z][A-Z] ]]; then
		country="$tcountry"
	else
		msgbox "$HTTPS_ENABLE_COUNTRY_ERR"
	fi
done

state=`inputbox "$HTTPS_ENABLE_STATE" "$state"` || exit
city=`inputbox "$HTTPS_ENABLE_CITY" "$city"` || exit
org=`inputbox "$HTTPS_ENABLE_ORGA" "$org"` || exit
dep=`inputbox "$HTTPS_ENABLE_DEP" "$dep"` || exit

openssl genrsa -out /etc/pve/pve-ssl.key 1024 2>/dev/null >/dev/null
chmod 400 /etc/pve/pve-ssl.key

echo $country >/tmp/ssh
echo $state >>/tmp/ssh
echo $city >>/tmp/ssh
echo $org >>/tmp/ssh
echo $dep >>/tmp/ssh
echo $ip >>/tmp/ssh
echo $mail >>/tmp/ssh

openssl req -new -key /etc/pve/pve-ssl.key -x509 -days 365 \
	-out /etc/pve/pve-ssl.pem </tmp/ssh 2>/dev/null >/dev/null
rm /tmp/ssh

# save config for the defaults of the next run
cat > /etc/pve/last <<-EOT
country="$country"
state="$state"
city="$city"
org="$org"
dep="$dep"
mail="$mail"
EOT

# size greater than zero?
if [ ! -s /etc/pve/pve-ssl.key -o ! -s /etc/pve/pve-ssl.pem ]; then
	msgox "$HTTPS_ENABLE_ERR"
	exit
fi
/usr/bin/perl /home/cvs/archivista/jobs/https-switch.pl 1 2>/dev/null >/dev/null
echo "ssl=1" >/etc/https.conf
stopit "apache2"
startit "apache2"
msgbox "$HTTPS_ENABLE_FIN"

