#!/bin/bash
. ${0%/*}/gnomesu.in
. ${0%/*}/network.in
msg=`findit "PDF_ENABLE_MSG" $zeile`
net_msg=`findit "PDF_ENABLE_NET_MSG" $zeile`
net_err=`findit "PDF_ENABLE_NET_ERR" $zeile`
fin=`findit "PDF_ENABLE_FIN" $zeile`
CUPS_COLOR_MSG=`findit "CUPS_COLOR_MSG" $zeile`
CUPS_COLOR_INACTIVE=`findit "CUPS_COLOR_INACTIVE" $zeile`
CUPS_COLOR_BW=`findit "CUPS_COLOR_BW" $zeile`
CUPS_COLOR_COLOR=`findit "CUPS_COLOR_COLOR" $zeile`
CUPS_ALTER=`findit "CUPS_ALTER" $zeile`
goroot "$msg" "$*"
tip=`ifconfig eth0 | sed -n "s/.*inet addr:\([^ ]\+\) .*/\1/p"`
if [ "$tip" ]; then
	tip=${tip%.[0-9]*}.0/24
else
	tip="192.168.0.0/24"
fi
if [ $webconfig -eq 1 ]; then
  ip=$WEBC_RANGE
	alterps=$WEBC_ALTER
	color=$WEBC_DEFAULTCOLOR
	res=`check_ip_cidr $ip`
	if [ $res -eq 0 ];then
	  # Wrong RANGE
	  exit 1
	fi
else
  until [ "$ip" ]; do
  	tip=`inputbox "$net_msg" "$tip"`
  	# check ip
		res=`check_ip_cidr $tip`
  	if [ $res -eq 0 ];then
  		infobox "$net_err"
  	else
  		ip=$tip
  	fi
  done
	alterps=1
	msgyesno "$CUPS_ALTER" "--defaultno" || alterps=0
  inactive="on"
	bw="off"
  color="off"
	if [ `cat /etc/cups-webconfig.conf | grep 'defaultcolor=1'` ]; then
    inactive="off"
		bw="on"
	fi
	if [ `cat /etc/cups-webconfig.conf | grep 'defaultcolor=2'` ]; then
    inactive="off"
		color="on"
	fi
	vals="0 \"$CUPS_COLOR_INACTIVE\" \"$inactive\" \
	  1 \"$CUPS_COLOR_BW\" \"$bw\" \
		2 \"$CUPS_COLOR_COLOR\" \"$color\""
  color=`radiolist "$CUPS_COLOR_MSG" 3 "$vals"` || exit
	showwaitinfo
fi

# rewrite config file - inject allowed IP range
gawk "BEGIN { matched=0 }

/<Location \/>/ {
	print
	matched=1
	print \"Order Deny,Allow\nDeny From All\nAllow From 127.0.0.1\nAllow From $ip\"
}

/<\/Location>/ {
	matched=0
}

{
	if ( matched == 0 )
		print
}" < /etc/cups/cupsd.conf > /etc/cups/cupsd.conf.new
cat /etc/cups/cupsd.conf.new > /etc/cups/cupsd.conf
rm /etc/cups/cupsd.conf.new
# ^- a bit tricky to preserve access rights

# start CUPS now
stopit "cups"
startit "cups"
# add printer to CUPS (CUPS needs to be running for this)
lpadmin -p archivista -L "Archivista Box" -D "PDF print into database." \
  -E -v "cups-pdf:/" -m /etc/cups/ppd/archivista.ppd 2>/dev/null >/dev/null
# enable CUPS at startup
sysv-rc-conf cups on
(
  echo "ip=$ip"
	echo "autostart=1"
	echo "defaultcolor=$color"
	echo "alterps=$alterps"
) > /etc/cups-webconfig.conf
msgbox "$fin"

