#!/bin/bash
. ${0%/*}/strings.in
KBD_CHOOSE_LAYOUT=`findit "KBD_CHOOSE_LAYOUT" $zeile`
KBD_ENTER_LAYOUT=`findit "KBD_ENTER_LAYOUT" $zeile`
reconfig=0
webconfig=0
layout_file=/home/archivista/.xkb-layout
# Are we in webconfig mode?
if [ "$1" = -webconfig ]; then
  webconfig=1
	shift
  # When we are in webconfig mode we need to set Display to :0 
	# else setxkbmap does fail
fi
if [ "$1" = -reconfig ]; then
  reconfig=1
  shift
fi
. /etc/profile
# we translate from old names to new names to retain backward compat.
setmap()
{
	local layout="$1"
	case "$layout" in
		de_CH) layout="ch -variant de" ;;
		fr_CH) layout="ch -variant fr" ;;
		it_CH) layout="it" ;;
	esac
	setxkbmap $layout 2>/dev/null >/dev/null
}

x_table=(en_US fr de it es de_CH fr_CH it_CH)
cur_layout=${x_table[0]}
# already configured?
if [ -e $layout_file ]; then
	cur_layout=`cat $layout_file`
	setmap $cur_layout
	if 	[ $reconfig -eq 0 ]; then
	  if [ $webconfig -eq 0 ]; then
		  # No reconfig set or no webconfig
		  exit
		fi
	fi
fi

i=0 ; def=""
while [ "${x_table[i]}" ]; do
	if [ "${x_table[i]}" = "$cur_layout" ]; then
		def=(--default-item "${x_table[i]}")
		break
	fi
	: $(( i++ ))
done

if [ $webconfig -eq 1 ]; then
  # Do we have a layout?
	if [ "$WEBC_LAYOUT" == "" ]; then
	  # No layout exit with error state 1
		exit 1
	else
    layout="$WEBC_LAYOUT";
	fi
	#echo $layout
else
	layout=`dialog --stdout ${def[@]} \
		--backtitle "$ARCHIVISTA_BOX: $KBD_CHOOSE_LAYOUT" \
		--cancel-button "$CANCEL" --no-tags --menu " " 16 38 10 \
    en_US US de German fr French es Spanish it Italian \
    de_CH "Swiss German" fr_CH "Swiss French" it_CH "Swiss Italian"`
	i=0
  while [ "${x_table[i]}" ]; do
    if [ "${x_table[i]}" = "$layout" ]; then
	  	layout=${x_table[i]}
	  	break
  	fi
  	: $(( i++ ))
  done
fi

if [ "$layout" ]; then
	setmap $layout 2>/dev/null >/dev/null
	echo $layout > $layout_file
	if [ ! -e '/etc/lang.conf' ]; then
	  /usr/bin/perl /home/archivista/access_menu.pl $layout
	fi
fi

