#!/bin/bash
. ${0%/*}/gnomesu.in
NET_BACKUP_RESTORE_MSG=`findit "NET_BACKUP_RESTORE_MSG" $zeile`
goroot "$NET_BACKUP_RESTORE_MSG" "$*"
. ${0%/*}/backup.in
. ${0%/*}/net-backup.in
showwaitinfo
log=`mktemp`
(
	# shared function, included on top
	if [ ! "$server" = "localhost" ]; then
		mount_net /mnt/net || exit
	fi
	stopit "mysql"
	mkdir -p /home/data
	# no -a since we can not store user/group on most CIFS shares
	if [ ! "$server" = "localhost" ]; then
		rsync -rt --stats --delete /mnt/net/data/ /home/data/
	else
		if [ ! "$type" = "raspi" ]; then
			if [ -e /home/data/backup ]; then
				rm -Rf /home/data/backup
			fi
			if [ -e /home/data/archivista/ftp/backup ]; then
				mv /home/data/archivista/ftp/backup /home/data
				rsync -rt --stats --delete /home/data/backup/archivista/ /home/data/archivista
				mv /home/data/backup /home/data/archivista/ftp
			fi
		else
			echo "Shutdown Box and change card from stick to internal slot!"
		fi
	fi
	# shared function included on top
	permissions_fixup /home/data
	# potentially fixup naming (case) - just to be sure
	/home/archivista/mysql-case-fixup.sh /home/data/archivista/mysql
	if [ ! "$server" = "localhost" ]; then
		umount /mnt/net
	fi
	startit "mysql"
) > $log 2>&1

tailbox "$log"
rm $log

