#!/bin/bash
. ${0%/*}/gnomesu.in
NET_BACKUP_SETUP_MSG=`findit "NET_BACKUP_SETUP_MSG" $zeile`
NET_BACKUP_SETUP_PROTOCOL=`findit "NET_BACKUP_SETUP_PROTOCOL" $zeile`
NET_BACKUP_SETUP_HOST=`findit "NET_BACKUP_SETUP_HOST" $zeile`
NET_BACKUP_SETUP_SHARE=`findit "NET_BACKUP_SETUP_SHARE" $zeile`
NET_BACKUP_SETUP_USER=`findit "NET_BACKUP_SETUP_USER" $zeile`
NET_BACKUP_SETUP_PW=`findit "NET_BACKUP_SETUP_PW" $zeile`
NET_BACKUP_SETUP_DOMAIN=`findit "NET_BACKUP_SETUP_DOMAIN" $zeile`
NET_BACKUP_OPTIONS=`findit "WEBC_OPTIONS" $zeile`
goroot "$NET_BACKUP_SETUP_MSG" "$*"
# include shared code
. ${0%/*}/backup-setup.in /home/archivista/net-backup.sh
get_days
# disable?
if [ "$tdays" = 0 ]; then
	crontab_remove /home/archivista/net-backup.sh
# Delete old values
  echo ""  > /etc/net-backup-webconfig.conf
	exit
fi
get_time
# maybe previous values ...
[ -e /etc/net-backup.conf ] && . /etc/net-backup.conf
# type: cifs / nfs / ...
if [ $webconfig -eq 1 ];then
  type=$WEBC_TYPE
	if [ ! "$type" ];then
	 exit
	fi
	server=$WEBC_SERVER
	if [ ! "$server" ];then
	 exit
	fi
	share=$WEBC_SHARE
else
	tcifs="off"
	if [ "$type" = "cifs" ]; then tcifs="on"; fi
	tnfs="off"
	if [ "$type" = "nfs" ]; then tnfs="on"; fi
	traspi="off"
	if [ "$type" = "raspi" ]; then traspi="on"; fi
	vars="\"cifs\" CIFS \"$tcifs\" \"nfs\" NFS \"$tnfs\" \
		\"raspi\" RASPI \"$traspi\""
  type=`radiolist "$NET_BACKUP_SETUP_PROTOCOL" 3 "$vars"` || exit
  server=`inputbox "$NET_BACKUP_SETUP_HOST" "$server"` || exit
  share=`inputbox "$NET_BACKUP_SETUP_SHARE" "$share"` || exit
fi
if [ $webconfig -eq 0 ]; then
  if [ $type = cifs ]; then
  	user=`inputbox "$NET_BACKUP_SETUP_USER" "$user"` || exit
  	passwd=`passwordbox "$NET_BACKUP_SETUP_PW" "$passwd"` || exit
  	domain=`inputbox "$NET_BACKUP_SETUP_DOMAIN" "$domain"`
  # else # NFS specific stuff
  fi
 	options=`inputbox "$NET_BACKUP_OPTIONS:" "$options"` || exit
else
  user=$WEBC_USER
	passwd=$WEBC_PASSWD
	domain=$WEBC_DOMAIN
	options=$WEBC_OPTIONS
fi
# save config for webconfig
(
  echo "days=$days"
	echo "time=$time"
  echo "type=$type"
  echo "server=$server"
  echo "share=$share"
  if [ $type = cifs ]; then
	[ "$user" ] && echo "user=$user"
	[ "$domain" ] && echo "domain=$domain"
  fi
	echo "options=$options"
) > /etc/net-backup-webconfig.conf
# save config for the net-backup.sh script
(
  echo "type=$type"
  echo "server=$server"
  echo "share=$share"
  if [ $type = cifs ]; then
	[ "$user" ] && echo "user=$user"
	[ "$passwd" ] && echo "passwd=$passwd"
	[ "$domain" ] && echo "domain=$domain"
  fi
	echo "options=$options"
) > /etc/net-backup.conf
chmod 400 /etc/net-backup.conf # hide passwords from users
crontab_add /home/archivista/net-backup.sh $h $m $days

