#!/bin/bash
. ${0%/*}/gnomesu.in
NET_BACKUP_MSG=`findit "NET_BACKUP_MSG" $zeile`
goroot "$NET_BACKUP_MSG" "$*"
# include shared code
. ${0%/*}/net-backup.in
. ${0%/*}/backup.in
start_backup
log=`mktemp`
(
  date
	# shared function, included on top
	if [ ! "$server" = "localhost" ]; then
		mount_net /mnt/net || exit
	fi
	stopit "mysql"
	if [ ! "$server" = "localhost" ]; then
		if [ ! -e "/mnt/net/data" 2>/dev/null ]; then
  	  mkdir "/mnt/net/data"
	  fi
		# no -a since we can not store user/group on most CIFS shares
		rsync -rt --stats /home/data/archivista /mnt/net/data
		error=$?
		[ $error -ne 0 ] && echo "Error $error during rsync run.
Not all files might be transfered."
	  backdev=`df | grep '/mnt/usb'` 
		umount /mnt/net
	else
		if [ "$type" = "raspi" ]; then
			raspi=`cat /proc/cpuinfo | grep 'ARM'`
			if [ ! "$raspi" = "" ]; then
				dd if=/dev/mmcblk0 of=/dev/sda bs=16M
				mdir="/home/data/archivista/mysql"
				find $mdir -type f -print0 | xargs -0 md5sum >> /tmp/file.md5
				mount /dev/sda4 /home
				fcheck=`md5sum --quiet -c /tmp/file.md5`
				if [ "$fcheck" = "" ]; then
					echo "database files successfully verified!"
				fi
				umount /home
			fi
		else
			rm -Rf /home/data/archivista/ftp/backup
			rsync -rt --stats /home/data/archivista /home/data/backup
			error=$?
			[ $error -ne 0 ] && echo "Error $error during rsync run.
Not all files might be transfered."
			chown -R ftp.users /home/data/backup
			mv /home/data/backup /home/data/archivista/ftp
		fi
	fi
	startit "mysql"
	date
	echo 
	echo
	echo
) > $log 2>&1

mail_or_display "$ARCHIVISTA_BOX" $log ; rm $log
fixocr
tailbox "/home/data/archivista/backup.log"
