#!/bin/bash
. ${0%/*}/gnomesu.in
RSYNC_BAK_RESTORE_MSG=`findit "RSYNC_BAK_RESTORE_MSG" $zeile`
goroot "$RSYNC_BAK_RESTORE_MSG" "$PASSWORD" "$*"
# include shared code
. ${0%/*}/backup.in
. ${0%/*}/rsync-backup.in
showwaitinfo
log=`mktemp`
(
	# shared function, included on top
	check_config || exit
	stopit "mysql"
	mkdir -p /home/data
	# no -a since we can not store user/group on most CIFS shares
	rsync -rt --stats --delete $user@$server:/$dir/data/ /home/data/
	error=$?
	[ $error -ne 0 ] && echo "Error $error during rsync run.
Not all files might be transfered."

	# shared function included on top
	permissions_fixup /home/data

	# potentially fixup naming (case) - just to be sure
	/home/archivista/mysql-case-fixup.sh /home/data/archivista/mysql
	startit "mysql"
) > $log 2>&1

tailbox "$log"
rm $log

