#!/bin/bash
. ${0%/*}/gnomesu.in
RSYNC_BAK_MSG=`findit "RSYNC_BAK_MSG" $zeile`
RSYNC_BAK_INFO=`findit "RSYNC_BAK_INFO" $zeile`
goroot "$RSYNC_BAK_MSG" "$*"
# include shared code
. ${0%/*}/backup.in
. ${0%/*}/rsync-backup.in
start_backup
log=`mktemp`
(
  date  
	check_config || exit
	stopit "mysql"
	# no -a since we can not store user/group on most Windows servers
	opt1="-o StrictHostKeyChecking=no"
	opt2="-o UserKnownHostsFile=/root/.ssh/known_hosts"
	/usr/bin/sshpass -p $passwd /usr/bin/ssh $opt1 $opt2 $user@$server "exit"
	cmd1="/usr/bin/rsync -rt --stats"
	pfad="/home/data/archivista $user@$server:$dir/data"
	/usr/bin/sshpass -p $passwd $cmd1 $pfad
	error=$?
	[ $error -ne 0 ] && echo "Error $error during rsync run. Not all files might be transfered."
  startit "mysql"

	date
	echo 
	echo
) > $log 2>&1
mail_or_display "$RSYNC_BAK_INFO" $log ; rm $log
fixocr
tailbox "/home/data/archivista/backup.log"

