#!/bin/bash
. ${0%/*}/gnomesu.in
USB_BACK_RESTORE_MSG=`findit "USB_BACK_RESTORE_MSG" $zeile`
goroot "$USB_BACK_RESTORE_MSG" "$*"
# include shared code
. ${0%/*}/backup.in
. ${0%/*}/usb-backup.in
showwaitinfo
log=`mktemp`
(
	# shared function, included on top
	mount_usb /mnt/usb || exit
	stopit "mysql"
	mkdir -p /home/data
	mkdir -p /home/data/archivista

	# no -a since we can not store user/group on most CIFS shares
	rsync -rvt --delete /mnt/usb/data/archivista/ /home/data/archivista

	# shared function, included on top
	permissions_fixup /home/data

	# potentially fixup naming (case) - just to be sure
	/home/archivista/mysql-case-fixup.sh /home/data/archivista/mysql
	umount /mnt/usb
	startit "mysql"
) > $log 2>&1

tailbox $log
rm $log

