#!/usr/bin/perl

use strict;

my $conf = "/etc/xorg.conf";
my $x11 = "/etc/X11/xorg.conf.vesa";
my $temp = "/etc/X11/xorg.conf.template";
my $content = "";
readFile($conf,\$content);
my ($xdrv,$xres,$xdepth) = split(/\n/,$content);
$xdrv="vesa" if $xdrv eq "";
if ($xres eq "") {
  $xres = '"1024x768" "800x600" "640x480"';
} else {
  $xres =~ s/\"//g;
	$xres = '"'.$xres.'"';
}
$xdepth=24 if $xdepth eq "";
readFile($x11,\$content);
$content =~ s/(\$xdrv)/$xdrv/;
$content =~ s/\$modes/$xres/;
$content =~ s/\$depth/$xdepth/;
writeFile($temp,\$content,1);


=head2 $res=writeFile($file,$pcontent,$killold)

Saves a file (if needed with check) from a pointer variable (1=success)

=cut

sub writeFile {
  my ($file,$pcontent,$killold) = @_;
  my ($res);
  if ($killold) {
    unlink $file if (-e $file);
  }
  if (!-e $file) {
    open(FOUT,">>$file");
    binmode(FOUT);
    print FOUT $$pcontent;
    close(FOUT);
    $res=1 if (-e $file);
  }
  return $res;
}






=head2 readFile($file,\$memory)

Reads a file and stores its contents to a pointer (file must exist)

=cut

sub readFile {
  my ($file,$pmemory) = @_;
  open( FIN, $file );
  binmode(FIN);
	$$pmemory = undef; # reset pmemory 
	while(my $line = <FIN>) {
	  $$pmemory .= $line;
	}
  close(FIN);
}







