
package Archivista::BL::Application;
use strict;
use Archivista::DL::ApplicationMenu;
use Archivista::Application::Menu;

sub new {
  my ($cls,$db) = @_; # Object of Archivista::DL::DB
	my $self = {};
  bless $self, $cls;
  $self->{'db'} = $db;
  $self->{'menu'} = Archivista::Application::Menu->new;
  return $self;
}

sub id {
  my ($self,$applicationId) = @_;
	if (defined $applicationId) {
		$self->{'application_id'} = $applicationId;
	} else {
		return $self->{'application_id'};
	}
}

sub lang {
  my ($self,$lang) = @_; # Object of Archivista::BL::Languages
  if (defined $lang) {
		$self->{'lang'} = $lang;
	} else {
		return $self->{'lang'};
	}
}

sub menu {
  my ($self,$selectedMenuItem) = @_; # Absolute level for the menu item
	my $applicationId = $self->id;
	my $lang = $self->lang;
	my $db = $self->{'db'};
	# Create the link to the data logic
	my $menuO = Archivista::DL::ApplicationMenu->new($db,$applicationId,$lang);
  # Get all menu items from the database for the selected application
	my $pamenuItems = $menuO->items($selectedMenuItem);
  $self->{'menu'}->items($pamenuItems);
	return $self->{'menu'};
}

1;

