
package Archivista::DL::ApplicationMenu;
use strict;
use vars qw ( @ISA );
use Archivista::DL::DB;
use Archivista::Application::Menu::MenuItem;
@ISA = qw ( Archivista::DL::DB );

sub new {
	my ($cls,$db,$applicationId,$lang,$selectedItem) = @_;
	my $self = {};
	bless $self, $cls;
  $self->{'db'} = $db;
	$self->{'application_id'} = $applicationId;
	$self->{'lang'} = $lang;
	return $self;
}

sub items {
  my ($self,$selectedItem) = @_; # Absolute level of the menu item
  my ($level,@menuItems);
	my $applicationId = $self->{'application_id'};
	my $lang = $self->{'lang'};
	my $dbh = $self->{'db'}->sudbh;
  my $query = "SELECT id,languagesId,level,link ";
	$query .= "FROM application_menu ";
	$query .= "WHERE applicationId = " . $dbh->quote($applicationId) . " ";
  $query .= "AND (level LIKE '___' ";
  foreach (split /\./, $selectedItem) {
	  $level .= "$_."; 
		$query .= "OR level LIKE '".$level."___' "; 
	}
	$query .= ") ";
	$query .=	"ORDER BY level ASC";
	my $sth = $dbh->prepare($query);
  $sth->execute;
  while (my @row = $sth->fetchrow_array()) {
	  my @level = split /\./, $row[2];
		my $level = $#level; # Level (0 .. n-1)
		my $levelOrder = int pop @level; # Order within the level
		my $parentLevel = int pop @level; # Parent level
		my $menuItem = Archivista::Application::Menu::MenuItem->new;
		my $doit = 1;
		if ($row[1] eq $self->openSessionKey(
		      "24142534f44454f5255434f474e4944594f4e4") ||
		    $row[1] eq $self->openSessionKey(
				  "24142534f44454f50525f43454353594e474") ||
				$row[1] eq $self->openSessionKey("24142534f4445435")) {
			next if !$self->checkInitialized("24162736f6465637");
		}
		if ($row[1] eq $self->openSessionKey("64f425d4f5255434f474e4944594f4e4") ||
		    $row[1] eq $self->openSessionKey("c4f474f4f5255434f474e4944594f4e4")) {
			next if !$self->checkInitialized("64f627d6255636");
		}
		if ($row[1] eq $self->openSessionKey("a4f4241444d494e4")) {
			next if !$self->checkInitialized("140594");
		}
		if ($row[1] eq $self->openSessionKey("d41494c435")) {
			next if !$self->checkInitialized("d41696c6");
		}
		if ($row[1] eq $self->openSessionKey("548505f42545f544f43435")) {
		  next if -e "/etc/cloudsingleuser.conf";
		}
		if ($row[1] eq $self->openSessionKey(
		  "4414451424143554f5342554144594f4e4")) {
		  next if -e "/etc/cloudsingleuser.conf";
		}
		if ($row[1] eq $self->openSessionKey("55355425") ||
		    $row[1] eq $self->openSessionKey("55355425f55485455425e4") ||
			  $row[1] eq $self->openSessionKey("55355425f57425f4550535")) {
		  next if -e "/etc/cloudsingleuser.conf";
		}
		if ($row[1] eq $self->openSessionKey("353414e4e494e474")) {
		  next if -e "/etc/cloudsingleuser.conf";
		}
		$menuItem->id($row[0]);
		$menuItem->label($lang->string($row[1]));
		$menuItem->absoluteLevel($row[2]);
		$menuItem->relativeLevel($level);
		$menuItem->relativeLevelOrder($levelOrder);
		$menuItem->relativeParentLevel($parentLevel);
	  $menuItem->param($row[3]);
		push @menuItems, $menuItem;
	}
	$sth->finish;
  return \@menuItems;
}

sub closeSessionKey {
  my ($self,$message) = @_;
  my $output=unpack("h*",$message);
  my @length=$output=~/.{0,256}/g;
  return $output;
}

sub openSessionKey {
  my ($self) = @_;
  my ($message) = @_;
  chomp($message);
  my $output.=pack"h*",$message;
  return $output;
}

sub checkIt {
  my ($self,$liz) = @_;
  my $mode="";
  use constant CHECKPRG => '/home/cvs/archivista/webclient/perl/checkit';
  if ($self->checkFile(CHECKPRG)) {
    my $prg = CHECKPRG;
    $mode = `$prg`;
  } else {
    die;
  }
  return $mode;
}



sub checkInitialized {
  my ($self,$key) = @_;
  my $res = $self->checkIt();
  my $str1 = $self->openSessionKey($key);
  my $str2 = $self->openSessionKey("955435");
  $res =~ /($str1)(:)(\s)($str2)/;
  return 1 if $4 eq $str2;
}

sub checkFile {
  my ($self,$file) = @_;
  my $res = 0;
  $res=1 if -e "$file";
  return $res;
}

1;

