
package Archivista::DL::ArchivePages;
use strict;
use vars qw ( @ISA );
use Archivista::DL::DB;
@ISA = qw ( Archivista::DL::DB );

sub new {
	my ($cls,$db) = @_;
  my $self = {};
	bless $self, $cls;
  $self->db($db);
	return $self;
}

sub select {
  my ($self,$page,$pageId) = @_;
	my $dbh = $self->db->dbh;
	my $query = "SELECT * FROM archivseiten WHERE Seite = $pageId";
	my $sth = $dbh->prepare($query);
	$sth->execute();
	if ($sth->rows) {
	  while (my $hash_ref = $sth->fetchrow_hashref()) {
		  foreach my $key (keys %$hash_ref) {
			  my $value = $$hash_ref{$key};
			  $page->attribute($key)->value($value,0);
		  }
	  }
  } else {
		my $exception = "Page $pageId not found ($query)";
		$self->exception($exception,__FILE__,__LINE__);
	}
	$sth->finish();
}

sub insert {
  my ($self,$pageId) = @_;
  my $dbh = $self->db->dbh;
	my $query = "INSERT INTO archivseiten (Seite) VALUES ($pageId)";
	my $do = $dbh->do($query);
	my $exception = "Failed to insert page $pageId ($query)";
	$self->exception($exception,__FILE__,__LINE__) if ($do != 1);
}

sub update {
  my ($self,$pageId,$attribute) = @_;
  my $dbh = $self->db->dbh;
	my $attributesToUpdate = $self->attributesToString($attribute);
	if (length($attributesToUpdate) > 0) {
	  my $query = "UPDATE archivseiten SET $attributesToUpdate ";
	  $query .= "WHERE Seite = $pageId";
	  my $do = $dbh->do($query);
	  my $exception = "Failed to update page $pageId ($query)";
	  $self->exception($exception,__FILE__,__LINE__) if ($do != 1);
  }
}

sub delete {
  my ($self,$pageId) = @_;
	my $dbh = $self->db->dbh;
  my $query = "DELETE FROM archivseiten WHERE Seite = $pageId";
	my $do = $dbh->do($query);
	my $exception = "Failed to delete page $pageId ($query)";
	$self->exception($exception,__FILE__,__LINE__) if ($do != 1);
}

sub deleteByDocumentId {
  my ($self,$documentId) = @_;
	my $dbh = $self->db->dbh;
	my $query = "DELETE FROM archivseiten WHERE Seite LIKE '$documentId%'";
	my $do = $dbh->do($query);
	my $exception = "No pages deleted for document $documentId ($query)";
	$self->exception($exception,__FILE__,__LINE__) if ($do < 1);
}

1;

