
package Archivista::DL::AvUser;
use strict;

sub avGetAllUsers {
  my ($self) = @_;
	my @users;
	my $inc = 0;
	my $dbh = $self->db->dbh;
	my $user1 = $self->db->uid;
	my $host1 = $self->db->host;
	$self->selectdb($self->db->database);
	my $query = "SELECT Host,User,Level,Laufnummer FROM user ORDER BY user,host";
	my $sth = $dbh->prepare($query);
	$sth->execute();
  if ($sth->rows) {
		while (my @row = $sth->fetchrow_array()) {
			$users[$inc][0] = $row[0];
			$users[$inc][1] = $row[1];
			$users[$inc][2] = $row[2];
			$users[$inc][3] = $row[3];
			if (($row[0] eq "localhost" && $row[1] eq "SYSOP") || 
				($host1 eq $row[0] && $user1 eq $row[1])) {
				# First user (SYSOP) can't be deleted
				$users[$inc][4] = 0;
				$users[$inc][5] = 0;
			} else {
				$users[$inc][4] = 1; # Delete flag
				$users[$inc][5] = 1; # Update flag
			}
			$inc++;
		}
  }
	$sth->finish();
  return \@users;
}

sub documentOwners {
  my ($self,$db,$retDS) = @_;
	my $dbh = $db->dbh;
	my (@documentOwners,%documentOwners);
	my $query = "SELECT User FROM user WHERE Level < 255 GROUP BY User";
	my $sth = $dbh->prepare($query);
	$sth->execute();
  while (my @row = $sth->fetchrow_array()) {
	  if ($retDS eq "ARRAY") {
			push @documentOwners, $row[0];
		} elsif ($retDS eq "HASH") {
			$documentOwners{$row[0]} = $row[0];
		}
	}
	$sth->finish();
	if ($retDS eq "ARRAY") {
		return \@documentOwners;
  } elsif ($retDS eq "HASH") {
		return \%documentOwners;
	}
}

sub avSelect {
  my ($self,$user,$userId) = @_;
  my $dbh = $self->db->dbh;	
	$self->selectdb($self->db->database);
	my $query = "SELECT * FROM user WHERE Laufnummer=".$dbh->quote($userId);
	my $sth = $dbh->prepare($query);
	$sth->execute();
  if ($sth->rows) {
		while (my $hash_ref = $sth->fetchrow_hashref()) {
			foreach my $key (keys %$hash_ref) {
				my $value = $$hash_ref{$key};
				$user->attribute($key)->value($value,0);
			}
		}
	} else {
		my $exception = "User $userId not found ($query)";
		$self->exception($exception,__FILE__,__LINE__);		
	}
	$sth->finish();
}

sub avInsert {
  my ($self,$host,$uid,$level) = @_;
  my ($query,$sth,$lastInsertId);
	$level = 0 if (! defined $level);
  my $dbh = $self->db->dbh;
	$self->selectdb($self->db->database);
  my $sql = "select Laufnummer from user where Host=".
	  $dbh->quote($host)." and User=".$dbh->quote($uid)." limit 1";
  my @res = $dbh->selectrow_array($sql);
	my $do = 0;
	if ($res[0]==0) {
	  $query = "INSERT INTO user (Host,User,Level) VALUES (";
	  $query .= $dbh->quote($host).",";
	  $query .= $dbh->quote($uid).",";
	  $query .= $level.")";
	  $do = $dbh->do($query);
	} else {
	  $do = 1;
	}
  my $exception = "Failed to insert new user ($query)";
	$self->exception($exception,__FILE__,__LINE__) if (! $do);
	$query = "SELECT LAST_INSERT_ID()";
	$sth = $dbh->prepare($query);
	$sth->execute();
	while (my @row = $sth->fetchrow_array()) {
		$lastInsertId = $row[0];
	}
  $sth->finish();
	return $lastInsertId;
}

sub avUpdate {
  my ($self,$userId,$attribute) = @_; # Object of Archivista::BL::Attribute
	my $dbh = $self->db->dbh;
	my $database = $self->db->database;
  $attribute = $self->shiftObsoleteAttributes($database,"user",$attribute);
  # String of attributes to update
	my $attributesToUpdate = $self->attributesToString($attribute);
	if (length($attributesToUpdate) > 0) {
		$self->selectdb($self->db->database);
	  my $query = "UPDATE user SET $attributesToUpdate ";
	  $query .= "WHERE Laufnummer = $userId";
	  my $do = $dbh->do($query);
	  my $exception = "Failed to update user $userId ($query)";
	  $self->exception($exception,__FILE__,__LINE__) if (! $do);
  }
}

sub avDelete {
  my ($self,$userId) = @_;
  if (defined $userId) {
	  my $dbh = $self->db->dbh;
		$self->selectdb($self->db->database);
	  my $query = "DELETE FROM user WHERE Laufnummer = $userId";
	  my $do = $dbh->do($query);
	  my $exception = "Failed to delete user $userId ($query)";
	  $self->exception($exception,__FILE__,__LINE__) if (! $do);
  } else {
		my $exception = "Missing user id!";
		$self->exception($exception,__FILE__,__LINE__);
	}
}

1;

