
package Archivista::DL::Jobs;
use strict;
use vars qw ( @ISA );
use Archivista::DL::DB;
@ISA = qw ( Archivista::DL::DB );

sub new {
	my ($cls,$params,$db) = @_; # Object of Archivista::DL::DB
	my $self = {};
	bless $self, $cls;
  $self->{'db'} = $db;
	$self->{'job_params'} = $params;
  return $self;
}

sub get {
  my ($self) = @_;
  my ($query,$sth);
	my $dbh = $self->db->sudbh;
	my $params = $self->{'job_params'};
	my $jobA = $params->{'job'};
  $query = "SELECT id,host,user,db ";
	$query .= "FROM jobs ";
	$query .= "WHERE job = ".$dbh->quote($jobA)." AND ";
	$query .= "status = 100 ";
	$query .= "LIMIT 1";
	$sth = $dbh->prepare($query);
	$sth->execute;
  while (my @row = $sth->fetchrow_array()) {
		$params->{'id'} = $row[0];
		$params->{'host'} = $row[1];
		$params->{'user'} = $row[2];
		$params->{'db'} = $row[3];
	}
	$sth->finish;
  if (defined $params->{'id'}) {
		$query = "SELECT param,value FROM jobs_data WHERE jid = ".$params->{'id'};
		$sth = $dbh->prepare($query);
		$sth->execute;
  	while (my @row = $sth->fetchrow_array()) {
			$params->{$row[0]} = $row[1];
		}
		$sth->finish;
	}
}

sub done {
  my ($self) = @_;
	my $dbh = $self->db->sudbh;
	my $params = $self->{'job_params'};
	my $jobId = $params->{'id'};
  if (defined $jobId) {
		my $query = "UPDATE jobs SET status = 120 WHERE id = $jobId";
		$dbh->do($query);
	}
}

sub process {
  my ($self) = @_;
	my $dbh = $self->db->sudbh;
	my $params = $self->{'job_params'};
	my $jobId = $params->{'id'};
  if (defined $jobId) {
		my $query = "UPDATE jobs SET status = 110 WHERE id = $jobId";
		$dbh->do($query);
	}
}

1;

