
package Archivista::DL::User;
use strict;
use vars qw ( @ISA );
use Archivista::DL::DB;
use Archivista::DL::AvUser;
use Archivista::DL::MyUser;
@ISA = qw(Archivista::DL::DB Archivista::DL::AvUser Archivista::DL::MyUser);

sub new {
	my ($cls,$db) = @_; # Object of Archivista::DL::DB
  my $self = {};
	bless $self, $cls;
  $self->db($db);
	return $self;
}

sub all {
  my ($cls,$db) = @_;
  my $self = {};
	bless $self, $cls;
	$self->db($db);
	return $self->avGetAllUsers;
}

sub grant {
  my ($cls,$db,$pausers) = @_; # 2-dim array[n][3] host,user,level
  my $self = {};
	bless $self, $cls;
	$self->db($db);
  $self->myGrant($pausers);
}

sub revoke {
  my ($cls,$db,$pausers) = @_;
	my $self = {};
	bless $self, $cls;
	$self->db($db);
	$self->myRevoke($pausers);
}

sub select {
	my ($self,$user,$userId) = @_;
  $self->avSelect($user,$userId);	
}

sub insert {
  my ($self,$user,$host,$uid,$pwd,$level) = @_;
  my $lastInsertId = $self->avInsert($host,$uid,$level);
	$self->myInsert($host,$uid,$pwd,$level);
	return $lastInsertId;
}

sub update {
  my ($self,$userId,$attribute) = @_;
	$self->avUpdate($userId,$attribute);
	$self->myUpdate($attribute);
}

sub delete {
  my ($self,$user) = @_;
	my $userId = $user->id;
	$self->avDelete($userId);
	$self->myDelete($user);
}

sub idByHostAndUser {
  my ($self,$host,$uid) = @_;
  my ($userId, $clientIP, $clientPort);
	my $dbh = $self->db->dbh;
	# Retrieve the client IP
	my $query = "SHOW PROCESSLIST";
	my $sth = $dbh->prepare($query);
	$sth->execute();
	while (my @row = $sth->fetchrow_array()) {
		if ($row[1] eq $uid) {
			($clientIP,$clientPort) = split /:/, $row[2];
		}
	}
	# Get the IP octects (zzz.zzz.zzz.zzz)
	my @ipo = split /\./, $clientIP;
	$sth->finish();
	$query = "SELECT Laufnummer FROM user WHERE ";
	if (lc($host) eq "localhost") {
		$query .= "Host = ".$dbh->quote($host);
	} else {
		$query .= "(" .
			"Host = '$clientIP' OR " .
			"Host = '$ipo[0].%' OR " .
			"Host = '$ipo[0].$ipo[1].%' OR " .
			"Host = '$ipo[0].$ipo[1].$ipo[2].%' OR " .
			"Host = '%'" .
		")";
	}
	$query .= " AND User = ".$dbh->quote($uid)." LIMIT 1";
	$sth = $dbh->prepare($query);
	$sth->execute();
  if ($sth->rows) {
	  while (my @row = $sth->fetchrow_array()) {
	    $userId = $row[0];
	  }
  } else {
    my $exception = "User $uid @ $host not found ($query)";
		$self->exception($exception,__FILE__,__LINE__);
	}
	$sth->finish();
	return $userId;
}

1;

