
package Archivista::Util::IO;
use strict;

sub new {
  my ($cls) = @_;
	my $self = {};
  bless $self, $cls;
  return $self;
}

sub read {
  my ($self,$resource,$type) = @_; # Can be 'DIR' or 'FILE'
	$type = "FILE" if (! defined $type);
	if (uc($type) eq "FILE") {
		open FIN, "$resource" or die "Can't open file $resource\n";
  	my @fin = <FIN>;
		my $fin = join "", @fin;
		close FIN;
		return \$fin;
	} elsif (uc($type) eq "DIR") {
	  my @files;
		opendir DIR, "$resource" or die "Can't open directory $resource\n";
		while (my $file = readdir DIR) {
			next if $file eq "." or $file eq "..";
			push @files, $file;
		}
		closedir DIR;
		return \@files;
	}
}

sub append {
  my ($self,$file,$data) = @_;
	open FOUT, ">>$file" or die "Can't open $file\n";
  print FOUT $data;
	close FOUT;
}

1;

