// Firefox 65+ fix
document.addEventListener('keydown', keyDownCheck, false);

function keyDownCheck(event) {
  var browser2 = navigator.userAgent;
  var pos = browser2.search(/Chrome/);
  if (pos==-1) { pos = browser2.search("Trident"); } // only check if no Chrome
  if (pos==-1) {
    if (event.isComposing || event.keyCode === 229) { return; }
    return false;
  }
}

window.onload = function() {
  document.onkeydown = this.keyNone;
  document.onkeypress = this.keyReturn;
  document.onkeyup = this.keyListener;
}

// get the current screen size (inner values)
function getScreenSize() {
  var x,y;
  if (self.innerHeight) // all except Explorer
  {
    x = self.innerWidth;
    y = self.innerHeight;
  }
  else if (document.documentElement &&
           document.documentElement.clientHeight)
     // Explorer 6 Strict Mode
  {
    x = document.documentElement.clientWidth;
    y =  document.documentElement.clientHeight;
  }
  else if (document.body) // other Explorers
  {
    x = document.body.clientWidth;
    y =  document.body.clientHeight;
  }
  document.cookie = "ScreenWidth=" + x;
  document.cookie = "ScreenHeight=" + y;
}



// get the current x screen size (inner values)
function getScreenX() {
  var x;
  if (self.innerHeight) { // all except Explorer
    x = self.innerWidth;
  } else if (document.documentElement &&
             document.documentElement.clientHeight) {
     // Explorer 6 Strict Mode
    x = document.documentElement.clientWidth;
  } else if (document.body) { // other Explorers
    x = document.body.clientWidth;
  }
	return x;
}



// get the current y screen size (inner values)
function getScreenY() {
  var y;
  if (self.innerHeight) { // all except Explorer
    y = self.innerHeight;
  } else if (document.documentElement &&
             document.documentElement.clientHeight) {
     // Explorer 6 Strict Mode
    y =  document.documentElement.clientHeight;
  } else if (document.body) { // other Explorers
    y =  document.body.clientHeight;
  }
	return y;
}



function scrollup() {
}
function scrolldown() {
}
function scrollleft() {
}
function scrollright() {
}



// add mouse wheel
function wheel(event){
  var delta = 0;
  var browser = getBrowser();
  event = checkEvent(event,browser);
  if (event.wheelDelta) {
    delta = event.wheelDelta/120;
    if (window.opera) delta = -delta;
  } else if (event.detail) {
    delta = -event.detail/3;
  }
  if (delta > 0) { scrollup(); }
  if (delta < 0) { scrolldown(); }
  return false;
}



// Give back the browser
function isExplorer6or7() {
  var res = 0;
	var pos = 0;
  var browser = getBrowser();
	if (browser=="Explorer") {
	  var version = navigator.appVersion;
    pos = version.search(/MSIE 6./);
    if (pos >= 0) {
		  res=1;
    } else {
      pos = version.search(/MSIE 7./);
      if (pos >= 0) {
		    res=1;
			}
		}
	}
	return res;
}



// listen to some keys (also in page view)
function keyListener(event) {
  var browser = getBrowser();
  event = checkEvent(event,browser);
  if(event.keyCode==38)scrollup();
  if(event.keyCode==40)scrolldown();
  if(event.keyCode==37)scrollleft();
  if(event.keyCode==39)scrollright();
  ret = keyPress(event);
  return ret;
}



// handle difference between explorer/mozilla
function checkEvent(event,browser) {
  if (browser == "Explorer") {
    try { if(!event)event = window.event } catch (foo) {};
  } else {
    if(!event)event = Window.Event;
  }
  return event;
}



// handle return and key f5 for mozilla/firefox
function keyReturn(event) {
  var browser = getBrowser();
  event = checkEvent(event,browser);
  var code = event.keyCode;
  return code;
}



// Check what key was pressed
function keyPress(event) {
  var code = event.keyCode;
  if (code>=112 && code<=123) { // F1-F12
    event.preventDefault();
    event.stopPropagation();
    var shift = event.shiftKey;
    var ctrl = event.ctrlKey;
    var alt = event.altKey;
    var key = 0;
    if (code==122){return true} // F11=>fullscreen or not
    key = code-111;
    var shift1='0';
    var alt1='0';
    var ctrl1='0';
    if (shift==1){shift1='1'};
    if (alt==1){alt1='1'};
    if (ctrl==1){ctrl1='1'};
		function_keys(code,shift,ctrl,alt);
  }
}



// supress codes so that Explorer does not call internall function keys
function keyNone(event) {
  var browser = getBrowser();
  event = checkEvent(event,browser);
  var code = event.keyCode;
  var alt = event.altKey;
	if (alt==1) {
	  if (code>=65 && code<=90) { 
			var hcall = document.getElementById("hcall").value;
      var items = new Array();
      items = hcall.split(',');
			var nr = code-65;
			code=0;
			if (items[nr] != "") {
			  var button = "edit"+nr;
				var buttongo = document.getElementById(button);
				if (buttongo.value != "") { 
				  buttongo.click();
			    return false;
				}
			}
	  }
	}
  if (code>=112 && code<=123) { // F1-F12
    if (browser == "Explorer") {
      event.keyCode=0;
    }
    return false;
  } else {
    if (code!=13) {
      return code;
    } else {
      keyReturn(event);
    }
  }
}



// Give back the browser
function getBrowser() {
  var browser = navigator.appName;
  var browser2 = navigator.userAgent;
	var pos = browser2.search("Trident");
	if (pos>=0) {
	  browser = "Explorer";
	} else {
    var pos = browser2.search(/Chrome/);
    if (browser == "Microsoft Internet Explorer") {
      browser = "Explorer";
    } else {
      if (pos >= 0) {
        browser = "Chrome";
      } else {
        pos = browser2.search(/Safari/);
        if (pos >= 0) {
          browser = "Safari";
        }
      }
    }
	}
  return browser;
}

function function_keys(code,shift,ctrl,alt) {
  if (code==112 || code==121) { // F1 or F10
		if (shift==0 && ctrl==0) {
	  	window.location.href = "/erp/index.php?app=orders";
		} else if (shift==1 && ctrl==0) {
	  	window.location.href = "/erp/index.php?app=AP";
		} else if (shift==0 && ctrl==1) {
	  	window.location.href = "/erp/index.php?app=stock";
		} else if (shift==1 && ctrl==1) {
	  	window.location.href = "/erp/index.php?app=manuf";
		}
	} else if (code==113) {  // F2
		go_function_key("F2",shift,ctrl);
	} else if (code==114) { // F3
		go_function_key("F3",shift,ctrl);
	} else if (code==115) { // F4
		go_function_key("F4",shift,ctrl);
	} else if (code==116) { // F5
		var res = go_function_key("F5",shift,ctrl);
		if (res==true) { go_function_click("AddItem"); }
	} else if (code==117) { // F6
		var res = go_function_key("F6",shift,ctrl);
		if (res==true) { go_function_click("Process"); }
	} else if (code==118) { // F7
		go_function_key("F7",shift,ctrl);
	} else if (code==119) { // F8
		go_function_key("F8",shift,ctrl);
	} else if (code==120) { // F9
		if (shift==0 && ctrl==0) {
	  	window.location.href = "/erp/index.php?app=GL";
		} else if (shift==1 && ctrl==0) {
	  	window.location.href = "/erp/index.php?app=system";
		} else if (shift==0 && ctrl==1) {
	  	window.location.href = "/erp/index.php?app=proj";
		} else if (shift==1 && ctrl==1) {
			// nothing
		}
	}
}

function go_function_click(elid) {
	if (elid != "") {
		var mySubmitButton = document.getElementById(elid);
		if (mySubmitButton==null) {
			// nothing to do
		} else {
		 	mySubmitButton.click();
		}
	}
}

function go_function_key(fkey,shift,ctrl) {
	var fgo = ""
	if (shift==1) { fgo="Shift\\+"; }
	if (ctrl==1) { fgo=fgo+"Ctrl\\+"; }
	fgo = '('+fgo+fkey+')';
	var links = document.getElementsByTagName('a');
	var lang = links.length;
	for (var c=0;c<lang;c++) {
		var txt = links[c].innerText;
		var res = txt.search(fgo);
		if (res>0) {
			link = links[c];
			var rpt = "report\\=rep";
			var txt = link.toString();
			var res2 = txt.search(rpt);
			if (res2>0) {
				window.open(link,"_blank");
			} else {
				window.location.href = link;
			}
			return false; // no further action
		}
	}
	return true;
}

function checkPrice(script,field) {
	var val = document.getElementById("stock_id").value;
	var type = 'price';
  var params = {value:val,ajax:type};
  var myAjax = new Ajax.Request(script,{method: 'get', parameters: params,
      onSuccess: updatePrice, onFailure: ajax_error});
}

function checkPricePO(script,field) {
	var val = document.getElementById("stock_id").value;
	var type = 'pricePO';
  var params = {value:val,ajax:type};
  var myAjax = new Ajax.Request(script,{method: 'get', parameters: params,
      onSuccess: updatePrice, onFailure: ajax_error});
}

function checkCustomer(script,field) {
	var val = document.getElementById(field).value;
	var type = 'branch';
  var params = {value:val,ajax:type,fieldid:field};
  var myAjax = new Ajax.Request(script,{method: 'get', parameters: params,
      onSuccess: updateBranch, onFailure: ajax_error});
	//if (field=="customer_id") {
	  document.forms["0"].submit();
	//}
}

function ajax_error(t) {
  if (t.responseText != "") {
    alert(t.responseText);
  }
}

function updatePrice(t) {
  if (t.responseText != "") {
		var price = t.responseText;
	  document.getElementById("price").value=price;
  }
}

function updateBranch(t) {
  if (t.responseText != "") {
		var id = t.responseText;
	  document.getElementById("branch_id2").innerHTML=id;
  }
}

function updatePrices(t) {
  if (t.responseText != "") {
		var id = t.responseText;
	  document.getElementById("branch_id2").innerHTML=id;
  }
}

function sleep(delay) { 
   var start = new Date().getTime();
   while (new Date().getTime() < start + delay);
}
