#!/usr/bin/perl

use strict;
use lib qw(/home/cvs/archivista/jobs);
use AVJobs;
my ($ho,$db,$us,$pw) = @ARGV;
logit("start in $db for $ho");
die "$0 host db user pw" if $ho eq "" || $db eq "" || $us eq "" || $pw eq "";
my $pfad = "/home/data/tmp";
mkdir $pfad if !-d $pfad;
$pfad.="/av0";
mkdir $pfad if !-d $pfad;
my $dbh = MySQLOpen($ho,$db,$us,$pw);
if ($dbh) {
  if (HostIsSlave($dbh)==0) {
		my $lnr = 1;
		my $count = 60;
		while ($lnr>0) {
			$dbh->do('SET @update_id := 0');
			my $sql = 'update archivseiten set Zipped=-2,'.
				'Seite = (SELECT @update_id := Seite) where Zipped=-1 limit 1';
			$dbh->do($sql);
			($lnr) = $dbh->selectrow_array('SELECT @update_id');
			if ($lnr>0) {
				logit("$0: page to ocr in $db is:$lnr");
				my $akte= int($lnr/1000);
				$sql = "select OCR from archivseiten where Seite=$lnr";
				my ($lang) = $dbh->selectrow_array($sql);
				my $page = $lnr % 1000;
				$sql = "select ArchivArt,Ordner,Archiviert,Seiten,Laufnummer ".
					"from archiv where Laufnummer=$akte";
				my ($art,$fold,$arch,$pages,$doc)=$dbh->selectrow_array($sql);
				my $ext="tif";
				$ext="png" if $art==2;
				$ext="jpg" if $art==3;
				my $base = "$pfad/$db".'_'.$doc."_".$page;
				my $fname = $base.'.'.$ext;
				my $fout = $base.'.'.'txt';
				my $fpdf = $base.'.'.'pdf';
				my $archfolders = getBlockTableCheck($dbh);
				my $table=getBlobTable($dbh,$fold,$arch,"archivbilder",$archfolders);
	     	my $pblob = getBlobFile($dbh,"BildInput",$lnr,$fold,$arch,$archfolders);
				if (length($$pblob)>0) {
					my $res=writeFile($fname,$pblob,1);
					logit("$0: $res of writing $fname");
					if ($res==1) {
	    	    my ($dopdf,$doocr,$pdfwhole,$limit,$start,$end,$pdftemp,$pdfhost,
							$pdfdomain,$pdffold,$pdfuser,$pdfpw) = getOCRVals($dbh,$db);
						my ($lang1,$detect,$clean,$tables) = 
							OCRDoOpenSourceLang($dbh,$db,$dbh,"",$lang);
  					OCRDoOpenSource($doc,$pages,$lang1,$doocr,$dopdf,$pdfwhole,$pfad,
							$ext,$detect,$clean,$tables,$page,$db);
					}
				} else {
					logit("$0: NO image $lnr in $db found!");
				}
				logit("$0: save text of $lnr in $db...");
				my $text = "";
				readFile2($fout,\$text,1);
				$sql = "update archivseiten set Text=".$dbh->quote($text)." ".
					"where Seite = $lnr";
				$dbh->do($sql);
				my $blob = "";
				readFile2($fpdf,\$blob,1) if -e $fpdf;
				$sql = "update $table set Quelle=".$dbh->quote($blob)." ".
					"where Seite = $lnr";
				$dbh->do($sql);
				$sql = "update archivseiten set Zipped=-3 where Seite = $lnr";
				$dbh->do($sql);
				unlink($fname) if -e $fname;
			} else {
				sleep 2;
				$count++;
				$lnr=1 if $count<60;
			}
		}
	} else {
		logit("$db at $ho in slave mode");
	}
} else {
	logit("no connection at $ho in $db");
}
logit("end in $db at $ho");
