#!/usr/bin/perl

=head1 avimpexport.pl, (c) 4.8.2007 by Archivista GmbH, Urs Pfister

Skript does import and export documents from archivista databases
The values are:

$mode, $db, $dir, $range

=cut

use strict;
use File::Copy;
use DBI;
use Archivista::Config;
#use lib qw(/home/cvs/archivista/jobs/im2/objdir/api/);
use ExactImage;
use lib qw (/home/cvs/archivista/jobs);
use AVJobs;

my $mode = shift;
my $db1 = shift;
my $dir = shift;
my $val = shift;
my $sql = shift;
if ($mode eq "" && $db1 eq "" && $dir eq "" && $val eq "" && $sql eq "") {
	print "$0 importdb2|exportdb2 dbname dir docx-docy|NULL sql\n";
}
my $out = "/mnt/usbdisk/transfer";
$out=$dir if $dir ne "";
$out =~ s/\/$//;
my $path = "$out/"; # static variables 
my $file = "export.av5";
my $ds = "/"; # ATTENTION: Linux (/) or Windows (\\)

my $config = Archivista::Config->new;
my $host = $config->get("MYSQL_HOST");
my $db = $config->get("MYSQL_DB");
my $user = $config->get("MYSQL_UID");
my $pw = $config->get("MYSQL_PWD");
$db1=$db if $db1 eq "";

my %val;
$val{dirsep} = "/"; # seperate a directory ((windows/linux)
$val{tmpdir} = "/home/data/archivista/tmp/"; # temp dir (in case we need file)

# even if we have no password to connect, we need a value
$pw = "" if $pw eq "''";
my $dbh=MySQLOpen($host,$db1,$user,$pw);
if ($dbh) {
  if (checkDatabase($dbh,$db1,1)) {
	  if (HostIsSlave($dbh)==0) {
		  my @files = <$path*.av?>;
			if ($files[0] eq "") {
		    @files = <$path*.AV?>;
			}
			if ($files[0] ne "") {
			  $file=$files[0];
				@files = split("\/",$file);
				$file = pop @files;
			}
			if ($mode eq "importdb2") {
	      importdb($dbh,$host,$db1,$user,$pw,$path,$file,$val);
			}
		}
    exportdb($dbh,$db1,$val,$path,$file,$sql) if $mode eq "exportdb2";
  }    
  MySQLClose($dbh);
}






=head1 exportdb($dbh,$range,$path,$file)

export a document range to a path

=cut

sub exportdb {
  my $dbh = shift;
	my $db1 = shift;
  my $range = shift;
  my $path = shift;
  my $file = shift;
	my $sqlplus = shift;
  my ($pa,@a,$sql,$sql1,$message,@fields,$pfields,$ext,$enr,$qnr);
	my ($nr,$maxfld,$notiz,$fname,$z,$first,$typ,$quelle);

  emptypath($path);
  $pfields=getFields($dbh,"archiv");
  @fields = @$pfields;

  $first=1;
  $nr=0;
	# read all fields until Laufnummer
  for($nr=0;$nr<100;$nr++) {
    $z.=$fields[$nr]->{name}."\t";
    $notiz=$nr if $fields[$nr]->{name} eq "Notiz";
    $maxfld=$nr;
    $nr=100 if $fields[$nr]->{name} eq "Laufnummer";
  }
  $z.="NotizRTF\t\r\n";
	
	# get the InputExtension
  for($nr=0;$nr<100;$nr++) {
	  if ($fields[$nr]->{name} eq "ArchivArt") {
		  $enr=$nr;
		} elsif ($fields[$nr]->{name} eq "QuelleExt") {
		  $qnr=$nr;
			$nr=100;
		}
	}

	$sql = "select * from archiv where (Gesperrt='' or Gesperrt is null) ";
	if ($sqlplus ne "" && $range eq "NULL") {
		$sql .= "and ".$sqlplus;
	} else {
		$sql .=sqlrange($range) . " order by Laufnummer asc";
	}
  my $st = $dbh->prepare($sql);
  my $r = $st->execute;
	my $count = 0;
  while (my @r=$st->fetchrow_array) {
	  if ($first==1) {
  	  $fname="$path$file";
      open(FOUT,">>$fname");
      print FOUT $z;
			$first=0;
		}
			
    # gets the current record for export
    $z="";
    for (my $c=0;$c<=$maxfld;$c++) {
      my $val=$r[$c];
			$val =~ s/\t/ /g;
      $val =~ s/\r\n/ /g;
      $val =~ s/\r/ /g;
      $val =~ s/\n/ /g;
      my $typ=$fields[$c]->{type};
      $z.=exportformatvalue($val,$typ);     
    }
    my $akte=$r[$maxfld];
    my $seiten=$r[3];
		# the imput file format is stored 
    my $art=$r[$enr];
		$ext="TIF";
		$ext="JPG" if $art==3;
		$ext="PNG" if $art==2;
		$quelle=$r[$qnr];
		$quelle="pdf" if $quelle eq "";
    # now export behind the values all images
    $z.=exportfiles($dbh,$db1,$path,$akte,$seiten,$ext,$quelle);
    $z.="\r\n";
		$count++;
		my $nr = $count % 1000;
		print "$count at doc $akte\n" if $nr==0;
    print FOUT $z;
  }
  close(FOUT) if $first==0;
	print "$count at end\n";
  $message = "Document(s) $val exported";
  logit($message);
	my $lang = length($path);
	$lang=$lang-1 if $lang>0;
	my $path1 = substr($path,0,$lang);
	my $cmd="touch $path1.txt";
	my $res=system($cmd);
	logit("$res=>$cmd");
}



=head1 importdb($dbh,$host,$db,$user,$pw,$path,$file)

import documents to an archivista db

=cut

sub importdb {
  my $dbh = shift;
	my $host = shift;
  my $db = shift;
	my $user = shift;
	my $pw = shift;
  my $path = shift;
  my $file = shift;
	my $opt = shift;

  my ($pa,@a,$sql,$sql1,$message,@fields,$pfields,$nr);
	my ($records,$maxfld,$notiz,$fname,$z);
	my $multi=getParameterRead($dbh,$db,"SourcesOffline");
	my $folder=getParameterRead($dbh,$db,"ArchivOrdner");
  # get back all fields
  $pfields=getFields($dbh,"archiv");
  @fields = @$pfields;

  my $pfadname="$path$file";
  if (-e $pfadname) {
    print "$pfadname found!\n";
    # import file is ok
    open(FIN,$pfadname);
    my @r=<FIN>;
    close(FIN);
  
    # remove all \r -> problem of std archivista export file
    $nr=0;
    foreach(@r) {
      my $l=$_;
      $l=~tr/\r//;
      $r[$nr]=$l;
      $nr++;
    }

    # remove first line and get position of Laufnummer
    my $f=shift @r;
		$f =~ s/\n//g;
		$f =~ s/\r//g;
    my @f=split("\t",$f);
    $nr=0; 
    for(my $c=0;$c<100;$c++) {
      if ($f[$c] eq "Laufnummer") {
        $maxfld=$c;
        logit("Archivista file format checked - is ok");
        $nr=100;
      }
    }

    # now process all records
		$records = 0;
    foreach my $rec (@r) {
		  $records++;
      my $sql;
      my @n = split("\t",$rec);

      # create an sql command with all fields (but not with Laufnummer)
      for($nr=0;$nr<$maxfld;$nr++) {
        my $val=$n[$nr];
        my $feld=$f[$nr];
			  $feld="Stichwoerter" if index($feld,"Stichw")==0;
			  $feld="Eigentuemer" if index($feld,"Eigent")==0;
        if ($val ne "") {
          # there is a value
          my $nr1=0;
          foreach (@fields) {
            if ($fields[$nr1]->{name} eq $feld) {
              my $typ=$fields[$nr1]->{type};
              my $size=$fields[$nr1]->{size};
              $sql.=importformatvalue($dbh,$sql,$val,$feld,$typ,$size);
            }
            $nr1++;
          }
        }
      }
    
      # now import the images to the database
      $sql.=", Gesperrt='importdb'";
      $sql="insert into $db1.archiv set ".$sql if $sql ne "";
      my $res=$dbh->do($sql);
      if ($res) {
        my @lr=$dbh->selectrow_array("select last_insert_id()");
        my $lrow=$lr[0];
        if ($lrow>0) {
					my ($opt1,$opt2) = split(":",$opt);
					my $ftype = "";
					my $fext = "";
					my $olddoc = 0;
					if ($maxfld>5) {
						my $maxfld1 = $maxfld-5;
						$olddoc = $n[$maxfld];
						my $edvname = $n[$maxfld1];
						my @parts = split(";",$edvname);
						$ftype = shift @parts;
						my $file = join(";",@parts);
						my @parts0 = split(/\./,$file);
						$fext = pop @parts0;
						logit("found $ftype with $fext at $olddoc");
					}
          my $ext=importfiles($dbh,$host,$db,$user,$pw,$path,
						$lrow,$n[3],$n[$maxfld+2],$opt1,$opt2,$ftype,$fext,$olddoc,$multi);
					my $txt = $n[$maxfld+1];
					my @parts = split(/\\/,$txt);
					my $fname = pop @parts;
					print "$path$fname\n";
					if ($fname ne "" && -e "$path$fname") {
						my @parts2 = split(/\./,$fname);
						my $ext = pop @parts2;
						my $fout = join('.',@parts2).'.html';
						$ext = lc($ext);
						if ($ext eq "rtf") {
							my $cont=`unrtf $path$out|html2text|iconv -f utf8 -t iso88591`;
							if ($cont ne "") {
								$sql = "update archiv set Notiz=".$dbh->quote($cont)." ".
									"where Laufnummer=$lrow";
								$dbh->do($sql);
							}
						}
					}
					my $erfasst=0;
					$erfasst=1 if $n[3]>0; # if pages set it to Erfasst=1
          $sql="update $db1.archiv set Erfasst=$erfasst,".
					     "Archiviert=0,Akte=$lrow,Ordner=$folder,Gesperrt='',".
               "BildInput=1,BildIntern=1,BildInputExt='".uc($ext)."' ".
							 "where Laufnummer=$lrow";
          $dbh->do($sql);
        }
      }
    }
  }
  $message = "$records Document(s) imported";
  logit($message);
}






=head1 $ext=importfiles($dbh,$host,$db,$user,$pw,$path,$akte,$seiten,$files)

imports images to the table archivbilder

=cut

sub importfiles {
  my ($dbh,$host,$db,$user,$pw,$path,$akte,$seiten,$files,
		$opt,$qual,$ftype,$fext,$olddoc,$multi) = @_;
	$seiten=0 if $seiten eq ""; # set to 0 pages if seiten not available
	$seiten=0 if $seiten<0;
	my $ocrdone = 0;
	my $c1 = 0;
  my @f=split(";",$files);
	my ($ext,$sfile) = importfilescheckpdf($path,\@f,\$seiten);
  for (my $c=0;$c<$seiten;$c++) {
	  my $f1 = $f[$c];
		my $f1a = "";
		$ext = importfilesgetname($path,\$f1) if $sfile eq "";
		my $ext1 = lc($ext);
		if ($ext1 eq "jpg" && $opt eq "jpg") {
			$qual = 20 if $qual<5 || $qual>100; 
			my $f1a = $f1.'.jpg';
			my $cmd = "econvert -i $f1 --colorspace RGB --quality 20 -o $f1a";
			my $res=system($cmd);
			$f1 = $f1a if $res==0 && -e $f1a;
		}
		if ($ext1 eq "png" && $opt eq "jpg") {
			$qual = 25 if $qual<5 || $qual>100; 
			my $f1a = $f1.'.jpg';
			my $cmd = "econvert -i $f1 --quality 25 -o $f1a";
			my $res=system($cmd);
			$f1 = $f1a if $res==0 && -e $f1a;
		}
		if ($ext ne "") {
      importfilespage($dbh,$db1,$f1,$ext,$sfile,$akte,$c,\$c1,
				\$ocrdone,$opt,$ftype,$fext,$olddoc,$multi);
    }
		unlink $f1 if $sfile ne "" && -e $f1;
		unlink $f1a if -e $f1a;
  }
	unlink $sfile if $sfile ne "" && -e $sfile;
  addLogEntryImport($dbh,$dbh,$host,$db1,$user,$pw,$akte,
		$seiten,'imp',0,$ocrdone);
 	if ($ext eq "PNG") {
	  my $sql="update $db1.archiv set ArchivArt=2,BildInputExt='PNG' ".
		        "where Laufnummer=$akte";
		$dbh->do($sql);
	}
  return $ext;
}






=head1 importfilescheckpdf ($path,$pf,$pseiten)

Check if the first file is a pdf file, so first conver to tiff/jpeg

=cut

sub importfilescheckpdf {
  my ($path,$pf,$pseiten) = @_;
	my $file = $$pf[0];
  my $f1="$path$file";
	my $pathftp = "/home/data/archivista/ftp/";
	my $ext = "";
	my $ext1 = "";
	my $filepdf = "";
	$file=~s/\\/\//g;
	my @parts = split(/\//,$file);
	my $file1 = pop @parts;
	$f1 = $file1;
  $f1 =~ /(.*)?(\.)(PDF|pdf)$/;
  $ext=$3 if $3 eq "pdf" or $3 eq "PDF";
	if ($ext ne "") {
	  if (!-e "$pathftp$f1") {
	    my $cmd = "cp $path$f1 $pathftp";
			system($cmd);
			$filepdf = "$pathftp$f1" if -e "$pathftp$f1";
      my $pinfo = getInfos1($pathftp,$f1);
      my $fout = FTPsplitFile($pinfo);
		  $ext1 = "tif";
		  $ext1 = "jpg" if $$pinfo{'Bits per pixel'}>1;
		  my @files = </home/data/archivista/ftp/$fout*$ext1>;
		  @files = sort { $a <=> $b } @files; 
	    for (my $c=0;$c<$$pinfo{'Number of pages'};$c++) {
			  $$pf[$c] = $files[$c];
        $$pseiten = $c+1;
		    last if $c>=640;
			}
	  }
	}
	return ($ext1,"$filepdf");
}






=head1 importfilesgetname ($path,$pf1)

Chech for the current file (incl. upper/lower case problems)

=cut

sub importfilesgetname {
  my ($path,$pf1) = @_;
	my ($ext,$f2,$f1a,$f1b);
  if ($$pf1 ne "") {
    $f2="$path$$pf1";
	  # change the path to UNIX
		$$pf1=~s/\\/\//g;
		# split all subdirectories
		my @f1=split('/',$$pf1);
		$f1a = pop @f1;
		$f1b = pop @f1;
		# create the file name
		$f2=$path;
		$f2.=$f1b.'/' if $f1b ne "" && $f1b ne "transfer";
		$f2.=$f1a;
		$$pf1=$f1a;
   	if (-e lc($f2)) {
		  # the file comes with lower case
			$f2=lc($f2);
			$$pf1=uc($$pf1);
		}
    if (-e $f2) {
      if ($ext eq "") {
        $$pf1 =~ /(.*)?(\.)(JPG|TIF|PNG)$/;
        $ext=$3 if ($3 eq "JPG" or $3 eq "TIF" or $3 eq "PNG");
      }
		}
		$$pf1 = $f2;
	}
	return $ext;
}






=head1 importfilespage ($dbh,$db1,$f1,$sfile,$akte,$c,$pc1,$porcdone)

Import a given file (incl. sources and text files)

=cut

sub importfilespage {
  my ($dbh,$db1,$f1,$ext,$sfile,$akte,$c,$pc1,$pocrdone,$opt,
		$ftype,$fext,$olddoc,$multi) = @_;
	my ($source,$bild,$zip,$sext,$sok,$spdf,$sfile2);
	my $part = "/home/data/archivista/tmp/in-$db1-$akte"."-part-";
	if ($c==0) {
	  if ($sfile eq "") {
		  ($sext,$sfile) = importfilesource($f1);
      readFile2($sfile,\$source);
			$sok = 1 if $sfile ne "";
	  } else {
		  ($sok,$sext,$sfile) = importfilescheckpdfzip($sfile);
			$spdf = 1 if $sok==1; # we want to delete the zipped file
		}
		if ($ftype eq "multi" && $fext ne "") {
			my $fname = "$path$olddoc"."_1.".$fext;
			$fname = "$path$olddoc"."_1.".lc($fext) if !-e "$fname";
			$fname = "$path$olddoc"."_1.".uc($fext) if !-e "$fname";
			if (-e "$fname") {
				if ($multi==1) { # store files externally
					my $pin = "/home/data/archivista/archmulti";
					my $fout= "$pin/$db1-$akte.".$fext;
					if (!-e "$fout") {
						my $cmd = "cp $fname $fout";
						my $res = system($cmd);
						logit("$res=>$cmd");
					} else {
						logit("ERROR: destination $fout already exists for $fname");
					}
				} else {
					logit("check for $fname");
					if (-e $fname) {
						my $maxsize = 512*1024*1024; # old max. size of file (512 MByte)
						my $cmd = "split --bytes=$maxsize \"$fname\" $part";
						my $res = system($cmd);
						logit("$res=>$cmd");
					}
				}
			} else {
				logit("ERROR: source file $fname not found");
			}
		}
	}
  readFile2($f1,\$bild);
  if ($bild ne "") {
	  $$pc1++;
    my $seite=$akte*1000+$$pc1;
    my $sql="insert into $db1.archivbilder set ".
	            "Seite=$seite,BildInput=".$dbh->quote($bild);
		if ($source ne "") {
		  # we got a source file
		  $sql.=",Quelle=".$dbh->quote($source);
		  $source="";
	    $sext=$dbh->quote($sext);
		}
		if ($ftype eq "multi" && $fext ne "" && $multi==0) {
			my @files = <$part*>;
			@files = sort @files;
			my $fin = $files[0];
			logit("check for chunk $fin");
			my $val = "";
			if (-e "$fin") {
				logit("import chunk $fin for $db1-$akte-$c with $fext");
		    readFile2($fin,\$val);
				$sql.=",BildA=".$dbh->quote($val) if length($val)>0;
				unlink $fin;
			}
		}
		$sfile2=importfilesoffice($dbh,$db1,$sfile,$sext,$akte,\$sql) if $sok==1;
    $dbh->do($sql);
    my $img = ExactImage::newImage();
    ExactImage::decodeImage($img,$bild);
		my $cm = ExactImage::imageColorspace($img);
		my $bit = 1;
		$bit = 8 if $cm eq "gray8";
		$bit = 24 if $cm eq "rgb8";
		my $sc = getScanDefByNumber($dbh,$db1);
    my @svals = split(";",$sc);
		$svals[1] = $bit; # bitmap (1/8/24)
    $svals[24] = 0; # no bw/optimization
		$sc = join(";",@svals);
    createThumbsAndSave($dbh,$db1,$img,$bit,$akte,$seite,$sc,$bit);
		ExactImage::deleteImage($img);
		unlink $sfile2 if $spdf==1 && -e $sfile2;
	  importfilestext($dbh,$db1,$f1,$akte,$pocrdone,$pc1);
  } 
}






=head1 $sok = importfilescheckpdfzip ($f1)

Check if we have pdf file, if so add a zip file

=cut

sub importfilescheckpdfzip {
  my ($f1) = @_;
	my $zipped = 0;
	my $fzip = "";
  if (-e "$f1") {
    $fzip = $f1;
	  $fzip =~ s/(.*)(\.)(.+$)/$1$2zip/;
	  if (!-e $fzip) {
      my $cmd = "zip -j '$fzip' '$f1'";
      my $res = system($cmd);
			$zipped=1 if $res==0;
		}
	}
	return ($zipped,"pdf",$fzip);
}






=head1 $sfile2 = importfilesoffice($dbh,$db1,$f1,$sext,$akte,$psql)

Check if we have pdf file, if so add a zip file

=cut

sub importfilesoffice {
  my ($dbh,$db1,$f1,$sext,$akte,$psql,$ftype,$fext) = @_;

  my $fzip = $f1;
	my $zip = "";
  $fzip =~ s/(\.[a-zA-Z])$/.zip/;
	print "$fzip\n";
  if (-e $fzip) {
    readFile2($fzip,\$zip);
	  if ($zip ne "") {
      $$psql.=",BildA=".$dbh->quote($zip);
	    my @parts = split(/\//,$f1);
	    my $f2 = pop @parts;
			my ($base,$ext2) = split(/\./,$f2);
			my $fnew = $base.'.'.$sext;
      my $sql1="update $db1.archiv set QuelleIntern=1,QuelleExt=".
               "'".uc($sext)."',EDVName=".$dbh->quote("office;$fnew")." ".
               "where Laufnummer=$akte";
      $dbh->do($sql1);
		}
	}
}






=head1 importfilestext($dbh,$db1,$f1,$akte,$pocrdone,$pc1)

Check if there is a text file for a page

=cut

sub importfilestext {
  my ($dbh,$db1,$f1,$akte,$pocrdone,$pc1) = @_;
	my @parts = split("\/",$f1);
	my $fname = pop @parts;
	my $text = "";
	$fname =~ s/(\.[a-z]{3,3}$)/.txt/;
	$fname =~ s/(\.[A-Z]{3,3}$)/.TXT/;
	$fname =~ s/(^[a-z]{1,1})/t/;
	$fname =~ s/(^[A-Z]{1,1})/T/;
	push @parts, $fname;
	$fname = join("\/",@parts);
	if (-e $fname) {
	  $$pocrdone=4;
	  open(FIN,"$fname");
    binmode(FIN);
    my @f3=<FIN>;
    close(FIN);
    $text=join("",@f3);
	}
  my $seite=$akte*1000+$$pc1;
  my $text1=$dbh->quote($text);
	my $sql = "select Seite from $db1.archivseiten where Seite=$seite";
	my @row = $dbh->selectrow_array($sql);
	if ($row[0]>0) {
    $sql="update $db1.archivseiten set Text=$text1 where Seite=$seite";
	} else {
    $sql="insert into $db1.archivseiten set Seite=$seite,Text=$text1";
	}
 	$dbh->do($sql);
}






=head1 ($sext,$sfile) = importfilesource ($f2)

Import a source file

=cut

sub importfilesource {
  my ($f2) = @_;
  # add source file
	my (@f4,$f3a,$f3b,$sext,$sfile);
  $f3a=$f2;
	$f3a=~/(.*)(\..*)$/;
	$f3a=$1;
	$f3a=substr($f3a,0,length($f3a)-1).'A.*';
	$f3b=`ls $f3a 2>/dev/null`;
	chomp $f3b;
	if (-e $f3b) {
	  $f3b=~/(\.)(.*?)$/;
	  $sext=uc($2);
	  $sfile = $f3b;
	}
	return ($sext,$sfile);
}



sub getInfos1 {
  my ($dir,$file,$db) = @_;
  my %info;
  my $line = getIdentify("$dir$file");
  my @lines = split("\n",$line);
	foreach (@lines) {
    my ($name,$val) = split(/\s{2,10}/,$_);
		if ($name eq "Pages:") {
      $info{'Number of pages'}=$val;
		} elsif ($name eq "Page size:") {
      my @temp = split(" ",$val);
      $info{'Width'}=$temp[0];
			$info{'Height'}=$temp[2];
		}
	}
  $info{'Format'}=1;	
  $info{'Bits per pixel'}=1;
	my $found = 0;
	my $tbase = "$val{tmpdir}$file";
	my $tfile = $tbase."-000001.ppm";
	unlinkFile($tfile) if checkFile($tfile);
	if (notFile($tfile)) {
	  if (check64bit()==64) {
		  my $cmd = "pdftk $dir$file cat 1 output $tfile";
			system($cmd);
			if (checkFile($tfile)) {
		    $cmd = "identify -ping $tfile";
			  my $res = `$cmd`;
        my @res1 = split(" ",$res);
	      my $pos = 4; 
	      my $col = $res1[$pos];
				$pos++;
				my $type = $res1[$pos];
			  $col = int $col;
				if ($col==16 && $type eq "Bilevel") {
          $info{'Bits per pixel'}=1;
				} elsif ($col>8) {
          $info{'Bits per pixel'}=24;
				} elsif ($col==8) {
          $info{'Bits per pixel'}=8;
				}
			}
		} else {
	    my $cmd = "pdftoppm -f 1 -l 1 $dir$file $tbase";
		  system($cmd);
		  if (checkFile($tfile)) {
		    $cmd = "identify -ping $tfile";
			  my $res = `$cmd`;
			  my @res1 = split(" ",$res);
	      my $pos = 3; # in 32 bit edition, identify gives color position at pos 3
	      my $pos1 = $pos+1;
	      if($res1[$pos] eq 'DirectClass'){
          $info{'Bits per pixel'}=24;
        } elsif($res1[$pos] eq 'PseudoClass'){
          $info{'Bits per pixel'}=8 if $res1[$pos1] eq '256c';
			  }
			}
    }
	  unlinkFile($tfile) if checkFile($tfile);
	}
  $info{'Format'}=3 if $info{'Bits per pixel'}!=1;
  $file =~ s/\.[a-zA-Z]{3,3}$/\.pdf/g;
  $info{'File name'}="$dir$file";
  $info{'Date'}=$file;
  $info{'Paper size'}="A4";
  $info{'Destination'}=$db;
	# correction from points to pixels
	$info{Width} = int $info{Width} * 4.166;
	$info{Height} = int $info{Height} * 4.166;
  $info{'X Resolution (DPI)'}=300;
  $info{'Y Resolution (DPI)'}=300;
  if($info{'Height'} > $info{'Width'}){
    $info{'Paper Orientation'}='Portrait';
  } else {
    $info{'Paper Orientation'}='Landscape';
  }
  return \%info;
}


