#!/usr/bin/perl

=head1 archivingNow.pl

This script shows all valid databases for archiving on localhost
and for user root. After selecting the desired databases the
archiving process will be started.

=cut

use lib qw(/home/cvs/archivista/jobs);
use strict;
use AVJobs;

my @isos = </var/lib/vz/template/iso/*_ARCH*.iso>;
my @out = ();
foreach my $short (@isos) {
  my @parts = split(/\//,$short);
	my $file = pop @parts;
	push @out,$file;
}
my $piso = \@out;
my $lang = getLang();
my $msg_eject=findit("WODIM_IN_DISK",$lang);
my $yes=findit("YES",$lang);
my $no=findit("NO",$lang);
my $again=findit("web_ask_proceed",$lang);
my $process_ok=findit("PROCESS_OK",$lang);
my $process_wait=findit("PROCESS_WAIT",$lang);
my $error=findit("LOGS_CLEAR_UNKNOWN_ERR",$lang);
my $start=findit("ISO_START",$lang);
my $title0=findit("ARCHIVISTA_BOX",$lang);
my $title1=findit("M_ARCH_OCR_WRIT_FOLDER",$lang);
my $msg_dbs=$title1;
my $title="$title0: $title1";
my $restart=1;

while ($restart) {
  my $psel = chooseXValues($piso,$msg_dbs);
	last if $$psel[0] eq "";
  for my $iso (@$psel) {
    logit("current iso : $iso");
    next if $iso eq "";
	  my $ok = system("dialog --stdout --backtitle \"$title\" ".
		  "--msgbox \"$start\" 0 0");
    my $cmd = "dialog --backtitle \"$title\" --infobox \"$process_wait\" 0 0";
		$ok = system($cmd);
    $cmd = "cd /home/archivista;./wodim.sh ".
	            "/var/lib/vz/template/iso/$iso";
	  my $res = system($cmd);
		if ($res!=0) {
	    $ok = system("dialog --stdout --backtitle \"$title\" ".
				"--msgbox \"$error\" 0 0");
      $cmd = "eject /dev/sr0 2>/dev/null";
			system($cmd);
		} else {
      $cmd = "eject /dev/sr0 2>/dev/null";
	    $res = system($cmd);
	    $ok = system("dialog --stdout --backtitle \"$title\" ".
				"--msgbox \"$msg_eject\" 0 0");
	    $res=checkcd($iso,$process_wait);
	    if ($res==0) {
	      $res = system("eject /dev/sr0 2>/dev/null >/dev/null");
	      if ($res==0) {
	        logit("$iso successfully burned!!!!");
	        logit("==> Take care to create always at least two copies!");
		    }
	    }
		  if ($res==0) {
		    my $process1 = "$iso: $process_ok";
				$process1 =~ s/\n//g;
	      $ok = system("dialog --stdout --backtitle \"$title\" ".
					"--msgbox \"$process1\" 0 0");
		  } else {
	      $ok = system("dialog --stdout --backtitle \"$title\" ".
					"--msgbox \"$error\" 0 0");
		  }
		}
    $cmd =  "dialog --stdout --backtitle \"$title\" ".
		        "--yes-label \"$yes\" --no-label ".
	          "\"$no\" --yesno \"$again\" 0 0";
    $ok = system($cmd);
	  if ($ok!=0) {
	    $restart=0;
		  last;
	  }
	}
}



sub checkcd {
  my ($iso,$process_wait) = @_;
	foreach ("in","in","in","out","out","out") {
		system("umount /mnt/$_ 2>/dev/null >/dev/null");
	}
  mkdir "/mnt" if !-e "/mnt";
  mkdir "/mnt/in" if !-e "/mnt/in";
	mkdir "/mnt/out" if !-e "/mnt/out";
	my $cmd = "mount -o loop ".
	       "/var/lib/vz/template/iso/$iso /mnt/in 2>/dev/null >/dev/null";
	my $res = system($cmd);
	if ($res==0) {
		my $res1 = 0;
	  logit("iso $iso mounted");
	  $cmd = "mount /dev/sr0 /mnt/out 2>/dev/null >/dev/null";
		for (my $c1=0;$c1<5;$c1++) {
		  $res1 = system($cmd);
			last if $res1==0;
			my $c2 = $c1+1;
			my $cwait = $c2*2;
			sleep $cwait;
		}
		$res=$res1;
		if ($res==0) {
      $cmd = "dialog --backtitle \"$title\" --infobox \"$process_wait\" 0 0";
			system($cmd);
	    logit("cd /dev/sr0 mounted, now counting md5 sums...");
		  $cmd="find /mnt/out/ARCH* ".
			     "-exec md5sum {} 2>/dev/null >/out.log \\\;";
			$res = system($cmd);
			if ($res==0) {
			  logit("now counting md5 sums of iso file...");
		    $cmd="find /mnt/in/ARCH* ".
				     "-exec md5sum {} 2>/dev/null >/in.log \\\;";
				$res = system($cmd);
				if ($res==0) {
				  open(FIN,"/in.log");
					my @in = <FIN>;
					close(FIN);
					open(FOUT,"/out.log");
					my @out = <FOUT>;
					close(FOUT);
					my $c = 0;
					foreach my $lin (@in) {
					  my $lout = $out[$c];
						my ($nrin,$restin) = split(/\s/,$lin);
						my ($nrout,$restout) = split(/\s/,$lout);
						if ($nrin ne $nrout) {
						  logit("$lout ERROR");
							last;
						}
						$c++;
					}
				}
			}
		}
		if ($res==0) {
			logit("now unmount iso file");
	    $cmd = "umount /mnt/in 2>/dev/null >/dev/null";
	    $res = system($cmd);
		}
		logit("error while unmounting iso") if $res!=0;
	}
	if ($res==0) {
		logit("now unmount /dev/sr0");
    $cmd = "umount /mnt/out 2>/dev/null >/dev/null";
		for (my $c1=0;$c1<5;$c1++) {
      $res = system($cmd);
			last if $res==0;
			sleep 1;
		}
	}
	logit("error while unmounting cd") if $res!=0;
	return $res;
}


