#!/usr/bin/perl

use strict;
my $init = shift;

my @scripts = ();
my $sane = "/home/cvs/archivista/jobs/sane-daemon.pl";
push @scripts, $sane; 
my $notify = "/home/cvs/archivista/jobs/notify-daemon.pl";
push @scripts, $notify; 
my $watch = "/home/cvs/archivista/jobs/watch-button.pl";
push @scripts, $watch;
my $pdf = "/home/cvs/archivista/jobs/createpdf.pl";
push @scripts, $pdf; 

if (!-e "/etc/checkdaemon.stp") {
	foreach my $script (@scripts) {
  	if (-e $script) {
    	if ($init==1 && $script eq $sane) {
		  	logit("starting daemons, waiting for x server");
	      for (my $c=1;$c<=10;$c++) {
  	      my$xsrv0 = `ps ax | grep 'Xorg'`;
			    my @xsrv = split(/\n/,$xsrv0);
		  	  if ($xsrv[1] ne "") {
					  logit("Xorg server found, now waiting a bit");
						last;
					};
  	      $xsrv0 = `ps ax | grep 'fluxbox'`;
			    @xsrv = split(/\n/,$xsrv0);
		  	  if ($xsrv[1] ne "") {
					  logit("x server found, now waiting a bit");
						last;
					};
	    	  sleep $c;
		    }
		    sleep 10;
    	}
	    my $cmd = "ps ax | grep 'perl' | grep '$script'";
		  my $res = `$cmd`;
		  my @lines = split(/\n/,$res);
		  if ($lines[1] eq "") {
			  my $log = "/home/data/archivista/av.log";
				my $dir = "/home/cvs/archivista/jobs";
				my $cmd0 = "/usr/bin/perl $script >>$log 2>>$log";
  	    my $cmd = "nohup $cmd0 &";
				my $nolog = 0;
				$nolog=1 if $script eq $watch;
			  doit($cmd,$nolog);
				sleep 1;
		  } else {
		    #print $lines[0]."\n";
		  }
		}
	}
	if (`uname -r`<5) {
		my $res = `cat /proc/cpuinfo | grep '[P|p]rocessor' | grep 'ARM'`;
		if ($res eq "") {
			$res = `ps ax | grep '/proc/sys/vm/drop_caches'`;
			my @parts = split(/\n/,$res);
			if ($parts[2] eq "") {
				system("sync;echo 3 >/proc/sys/vm/drop_caches"); 
			} else {
				logit("drop_caches already running");
			}
		}
	}	
	if (-e "/tmp/archmulti" && !-e "/tmp/archprocess") {
		doit("touch /tmp/archprocess");
		use Archivista::Config;    # is needed for the passwords and other settings
		use lib qw(/home/cvs/archivista/jobs);
		my $config = Archivista::Config->new;
		my $pw = $config->get("MYSQL_PWD");
		undef $config;
		my $slaveip = "";
	  my $opts = `cat /proc/cmdline`;
		my @parts = split(/\s/,$opts);
		foreach my $part (@parts) {
			my @parts1 = split(/\./,$part);
			my $name = shift @parts1;
			my $val = join('.',@parts1);
			if ($name eq "slave") {
				$slaveip = $val;
				last;
			}
		}
		if ($slaveip ne "") {
			my $pw1 = escape($pw);
			my $cmd = "rsync -ar --delete --rsh=\"/usr/bin/sshpass -p \"$pw1\" ".
				"ssh -o StrictHostKeyChecking=no -l root\" ".
				"/home/data/archivista/archmulti root\@$slaveip:/home/data/archivista;".
				"rm -f /tmp/archmulti;rm -f /tmp/archprocess";
			my $log = "rsync -ar --delete --rsh=\"/usr/bin/sshpass -p \"****\" ".
				"ssh -o StrictHostKeyChecking=no -l root\" ".
				"/home/data/archivista/archmulti root\@$slaveip:/home/data/archivista;".
				"rm -f /tmp/archmulti;rm -f /tmp/archprocess";
			doit($cmd,0,$log);
		}
	}
} else {
	foreach my $script (@scripts) {
  	if (-e $script) {
	    my $cmd = "ps ax | grep 'perl' | grep '$script'";
		  my $res = `$cmd`;
		  my @lines = split(/\n/,$res);
	  	if ($lines[1] ne "") {
				my $job = $lines[0];
				$job =~ /([0-9]+)/;
				my $killit = 0;
				$killit=$1 if $1 ne "";
				$cmd = "kill $killit";
				$res=system($cmd);
				logit("$res=>$cmd with $job");
			}
		}
	}
}

sub doit {
  my ($cmd,$nolog,$log) = @_;
	my $res = system($cmd);
	logit("$res=>$cmd",$log) if $nolog==0;
	return $res;
}

sub logit {
  my ($msg,$log) = @_;
	$msg = $log if $log ne "";
	open(FOUT,">>/home/data/archivista/av.log");
	print FOUT "$msg\n";
	close(FOUT);
}

sub escape {
	my ($string) = @_;
  $string =~ s/([^a-zA-Z0-9_])/\\$1/g;
  return $string;
}
