#!/usr/bin/perl

=head1 images.pl (c) 19.3.2007, v1.0 by Archivista GmbH, Urs Pfister

Import images from a location (namely usb stick) and import them to an
archivista db

=cut

use strict;
use lib qw(/home/cvs/archivista/jobs);
use AVJobs;

my $lang = getLang();

my ($msg_img_titel,$msg_img_noconnect,$msg_img_importdone,
	$msg_img_slave,$msg_img_imagesadd,$msg_img_importit,$msg_img_host,
	$msg_img_db,$msg_img_user,$msg_img_password,$msg_img_fields,
	$msg_img_text,$msg_img_none,$msg_img_single,$msg_img_all,
	$msg_img_copy,$msg_img_frm,$msg_img_ok,$msg_img_cancel,$msg_img_login);

my $squeeze=0;
$squeeze=1 if `cat /proc/version | grep 4.9` ne "";
if (`cat /proc/cpinfo | grep 'ARM'`ne "" || $squeeze==1) {
	$msg_img_titel=goiso(findit1("MSG_IMG_TITEL",$lang),$squeeze);
	$msg_img_noconnect=goiso(findit1("MSG_IMG_NOCONNECT",$lang),$squeeze);
	$msg_img_importdone=goiso(findit1("MSG_IMG_IMPORTDONE",$lang),$squeeze);
	$msg_img_slave=goiso(findit1("MSG_IMG_SLAVE",$lang),$squeeze);
	$msg_img_imagesadd=goiso(findit1("MSG_IMG_IMAGESADD",$lang),$squeeze);
	$msg_img_importit=goiso(findit1("MSG_IMG_IMPORTIT",$lang),$squeeze);
	$msg_img_host=goiso(findit1("MSG_IMG_HOST",$lang),$squeeze);
	$msg_img_db=goiso(findit1("MSG_IMG_DB",$lang),$squeeze);
	$msg_img_user=goiso(findit1("MSG_IMG_USER",$lang),$squeeze);
	$msg_img_password=goiso(findit1("MSG_IMG_PASSWORD",$lang),$squeeze);
	$msg_img_fields=goiso(findit1("MSG_IMG_FIELDS",$lang),$squeeze);
	$msg_img_text=goiso(findit1("MSG_IMG_TEXT",$lang),$squeeze);
	$msg_img_none=goiso(findit1("MSG_IMG_NONE",$lang),$squeeze);
	$msg_img_single=goiso(findit1("MSG_IMG_SINGLE",$lang),$squeeze);
	$msg_img_all=goiso(findit1("MSG_IMG_ALL",$lang),$squeeze);
	$msg_img_copy=goiso(findit1("MSG_IMG_COPY",$lang),$squeeze);
	$msg_img_frm=goiso(findit1("MSG_IMG_FRM",$lang),$squeeze);
	$msg_img_ok=goiso(findit1("MSG_IMG_OK",$lang),$squeeze);
	$msg_img_cancel=goiso(findit1("MSG_IMG_CANCEL",$lang),$squeeze);
	$msg_img_login=goiso(findit1("MSG_IMG_LOGIN",$lang),$squeeze);
} else {
	$msg_img_titel=findit("MSG_IMG_TITEL",$lang);
	$msg_img_noconnect=findit("MSG_IMG_NOCONNECT",$lang);
	$msg_img_importdone=findit("MSG_IMG_IMPORTDONE",$lang);
	$msg_img_slave=findit("MSG_IMG_SLAVE",$lang);
	$msg_img_imagesadd=findit("MSG_IMG_IMAGESADD",$lang);
	$msg_img_importit=findit("MSG_IMG_IMPORTIT",$lang);
	$msg_img_host=findit("MSG_IMG_HOST",$lang);
	$msg_img_db=findit("MSG_IMG_DB",$lang);
	$msg_img_user=findit("MSG_IMG_USER",$lang);
	$msg_img_password=findit("MSG_IMG_PASSWORD",$lang);
	$msg_img_fields=findit("MSG_IMG_FIELDS",$lang);
	$msg_img_text=findit("MSG_IMG_TEXT",$lang);
	$msg_img_none=findit("MSG_IMG_NONE",$lang);
	$msg_img_single=findit("MSG_IMG_SINGLE",$lang);
	$msg_img_all=findit("MSG_IMG_ALL",$lang);
	$msg_img_copy=findit("MSG_IMG_COPY",$lang);
	$msg_img_frm=findit("MSG_IMG_FRM",$lang);
	$msg_img_ok=findit("MSG_IMG_OK",$lang);
	$msg_img_cancel=findit("MSG_IMG_CANCEL",$lang);
	$msg_img_login=findit("MSG_IMG_LOGIN",$lang);
}

sub goiso {
	my ($text,$squeeze) = @_;
	Encode::from_to($text, 'utf8', 'iso-8859-1') if $squeeze==1;
	return $text;
}

my $dir = shift; # get the current directory where we search for jpg files

# check if Prima is there
use Prima qw(Application ImageViewer MsgBox Lists Classes Buttons);
eval "use Prima::VB::VBLoader"; die"$@\n" if $@;

my %val; # the global hash value
$val{ds} = "/"; # ATTENTION: Linux (/) or Windows (\\)
$val{jhead} = "jhead"; # extract exif informations
$val{sanebutton} = "/etc/sane-button.conf";
my @files; # store the founded files

# load the form and show it
my $frm = Prima::VBLoad("/home/cvs/archivista/jobs/frmImages.fm",
          'frm' => { centered => 1 },);

$frm->set(text => $msg_img_titel); # set title

self::setLabels($frm); # set the language depending string
self::getUserConnection($frm); # read user connection info from sane-button.pl
@files = `cd $dir;ls -ltd \$(find . -type f) 2>/dev/null`;
@files = grep(/\.jpg|JPG$/,@files);
my $c=0;
foreach my $file (@files) {
  my @parts = split(/\//,$file);
	shift @parts;
	my $file2 = join('/',@parts);
	chomp $file2;
  $files[$c] = "$dir/$file2";
	$c++;
}
self::setFiles($frm,\@files);
my @obj=$frm->get(name=>'img');
my $obj = $obj[3];
self::imageLoad($obj,$files[0]); # load the first iamge
run Prima; # Loop to handle all actions

package self;

=head1 setToggle($self)

Select/Unselect a file 

=cut

sub setToggle {
  my $self = shift;
	my $nr = $self->focusedItem;
	$self->toggle_item($nr);
	my $frm = $self->owner;
  my @obj=$frm->get(name=>'chkNone');
  my $obj = $obj[3];
	$obj->uncheck;
  @obj=$frm->get(name=>'chkAll');
  $obj = $obj[3];
	$obj->uncheck;
}



=head1 setFiles($frm,$pfiles)

Add all files to the file list

=cut

sub setFiles {
  my $frm = shift;
	my $pfiles = shift;
  my @obj=$frm->get(name=>'lst');
	$obj[3]->set(items=>$pfiles);
}



=head1 selectAll($self)

Select all files for later import

=cut

sub selectAll {
  my $self = shift;
	my $frm = $self->owner;
  my @obj=$frm->get(name=>'chkNone');
  my $obj = $obj[3];
	$obj->uncheck;
  @obj=$frm->get(name=>'lst');
  $obj = $obj[3];
	$obj->select_all;
}



=head1 deselectAll($self)

Deselect all files (nothing to import)

=cut

sub deselectAll {
  my $self = shift;
	my $frm = $self->owner;
  my @obj=$frm->get(name=>'chkAll');
  my $obj = $obj[3];
	$obj->uncheck;
  @obj=$frm->get(name=>'lst');
  $obj = $obj[3];
	$obj->deselect_all;
}



=head1 imageLoad($obj,$image)

Load the temp. thumb file

=cut

sub imageLoad {
  my $obj = shift;
	my $image = shift;
	my $ftemp = "/tmp/usb_file.jpg";
	my $ftemp1 = "/tmp/usb_file1.jpg";
	unlink $ftemp if -e $ftemp;
	unlink $ftemp1 if -e $ftemp1;
	if (!-e $ftemp) {
	  my $cmd = "$val{jhead} -st $ftemp $image 2&>/dev/null";
		system($cmd); # stupid hack because Prima::Image 1.20 can't read thumbs
		if (-e $ftemp) {
		  $cmd = "convert $ftemp $ftemp1";
		  system($cmd);
		}
	  my $x = Prima::Image->create;
		$x->load($ftemp1);
		$x->load($image) if $x->width==0;
		my $width = $x->width;
		my $height = $x->height;
		my $fact = 1;
		if ($width>0 && $height>0) {
		  my $factw = 200/$width;
			my $facth = 200/$height;
			$fact = $facth;
			$fact = $factw if $factw<$facth;
		}
	  $obj->set(image=>$x);
		$obj->zoom($fact);
		undef $x;
		unlink $ftemp;
		unlink $ftemp1;
	}
}



=head1 showCurrent($self)

Show the current thumb image

=cut

sub showCurrent {
  my $self = shift;
	my $nr = $self->focusedItem;
	my $file = $self->get_item_text($nr);
	my $frm = $self->owner;
  my @obj=$frm->get(name=>'img');
  my $obj = $obj[3];
	imageLoad($obj,$file);
}



=head1 exit

Exit the mask (without prompting)

=cut

sub exit {
  exit 0;
}



=head1 importImages($self)

Start to import the selected images

=cut

sub importImages {
  my $self = shift;
	my $frm = $self->owner;
  my @obj=$frm->get(name=>'lst');
  my $obj = $obj[3];
	my @files;
	
	my @selected = @{$obj->selectedItems};
	foreach (@selected) {
	  my $nr = $_;
	  my $file = $obj->get_item_text($nr);
	  push @files,$file; 
  }
	@files = reverse @files;
  
	@obj=$frm->get(name=>'chkText');
  $obj = $obj[3];
	my $bw = $obj->checked;

	@obj=$frm->get(name=>'sld');
  $obj = $obj[3];
	my $high = $obj->value;
	
	@obj=$frm->get(name=>'chkSingle');
  $obj = $obj[3];
	my $onedoc = $obj->checked;

  @obj=$frm->get(name=>'txtFields');
  $obj = $obj[3];
	my $vals = $obj->text;
  my @frag = split(";",$vals);
	my (@flds,@vals);
	foreach(@frag) {
	  my ($fld,$val) = split("=",$_);
		push @flds,$fld;
		push @vals,$val;
	}
  my ($host,$db1,$user,$pw)=readUserConnection($frm);
  @obj=$frm->get(name=>'lbl');
  $obj = $obj[3];
	my $old = $obj->text;
	$obj->set(text=>$msg_img_imagesadd);
  # main loop, open a connection
	my $dbh2 = AVJobs::MySQLOpen();
	my $dbh = AVJobs::MySQLOpen($host,$db1,$user,$pw);
	if (! $dbh) {
    Prima::message($msg_img_noconnect);
	} elsif (AVJobs::HostIsSlaveSimple($dbh)==0) {
    # if it is an archivista db, then start importing
    my $scandef = AVJobs::getScanDefByNumber($dbh,$db1,0);
		if ($scandef ne "") {
		  importImagesDo($dbh,$dbh2,$host,$db1,$user,$pw,\@files,
			               $scandef,$onedoc,$high,$bw,\@flds,\@vals);
		}
    $obj->set(text=>$old);
		if ($files[0] ne "") {
      @obj=$frm->get(name=>'img');
      $obj = $obj[3];
      imageLoad($obj,$files[0]);
		}
    Prima::message($msg_img_importdone);
	} else {
	  Prima::message($msg_img_slave);
	}
}


sub importImagesDo {
  my ($dbh,$dbh2,$host,$db1,$user,$pw,$pfiles,
	    $scandef,$onedoc,$high,$bw,$pflds,$pvals) = @_;
  my ($qual,$scale,$md5it) = getParameters($dbh,$db1);
  my $cakt=0;
	my $cmax=@files;
	my $page=0;
	my $nr=0;
	my $first = 0;
  foreach my $file (@$pfiles) { # add every single file
		$cakt++;
		sleep 1 if $cakt % 500 == 0;
    my $ext = lc(AVJobs::getFileExtension($file));
		next if $ext ne "jpg";
		$page++ if $onedoc==1 || $page==0;
		$nr = 0 if $onedoc==0;
    my @obj=$frm->get(name=>'lbl');
    my $obj = $obj[3];
    my $msg = "$msg_img_importit $file ($cakt/$cmax)";
	  $obj->set(text=>$msg);
		my $img = "";
 	  AVJobs::readFile2($file,\$img);
    if ($bw==1) {	
      $qual=0;
      $ext="tiff";
      optimizeBW(\$img,$qual,$ext,$high);
    }
		my $md5count = 0;
		my $md5 = "";
		if ($md5it==1) { 
      $md5 = AVJobs::md5get(\$img);
      $md5count = AVJobs::md5check($dbh,$db1,$md5);
		}
    my $x = Prima::Image->create;
    @obj=$frm->get(name=>'img');
    $obj = $obj[3];
    $obj->set(image=>$x);
		if ($md5count==0 || $md5it==0) {
	    AVJobs::logit("Add $file to database $db1");
      @obj=$frm->get(name=>'img');
      $obj = $obj[3];
	    #imageLoad($obj,$file);
	    addImage($dbh,$db1,$file,\$img,$qual,$scale,
			         $page,$bw,$high,$pflds,$pvals,\$nr,$scandef,$md5,$md5it);
		  if ($onedoc==0 || $page>=640) {
		    if ($bw==1) {
          AVJobs::addLogEntryImport($dbh2,$dbh,$host,$db1,$user,$pw,
			                              $nr,$page,'imp',0,1,0);
			  }
	      AVJobs::DocumentUnlock($dbh,$db1,$nr);
				$page=0;
		  }
	  } else {
			if ($first==0) {
			  AVJobs::logit("$md5 hash already in $db1");
				$first=1;
			}
		}
	}
  if ($bw==1) {
    AVJobs::addLogEntryImport($dbh2,$host,$db1,$user,$pw,
	                            $nr,$page,'imp',0,1,0);
  }
  AVJobs::DocumentUnlock($dbh,$db1,$nr);
}



=head1 addImage($av,$file,$qual,$scale,$page,$bw,$high)

Add an image to a new document

=cut

sub addImage {
  my ($dbh,$db1,$file,$pimg,$qual,$scale,$page,
	    $bw,$high,$pflds,$pvals,$pnr,$scandef,$md5,$md5it) = @_;
	my $sql = "";
  my $prg = $val{jhead}." ".$file;
  my $exif = `$prg`;
  my $date = $exif;
	$exif .= "\nOptimized to b/w by Archivista\n" if $bw==1;
  $date =~ /Date\/Time\s+\:+\s+([0-9]+)\:+([0-9]+)\:+([0-9]+)/;
  $date = "$1$2$3";
	$date = AVJobs::DocumentAddDatForm($date);
  my $art = 3;
  my $lockuser = "avimp";
  AVJobs::recordAddOrUpdate($dbh,$db1,$pnr,\$page,\$lockuser,"","");
  if ($$pnr>0) {
    $art=1 if $bw==1;
    if ($page==0) {
	    $sql = "update $db1.archiv set ArchivArt=$art";
      $sql .= ",Datum=$date" if $date ne '//';
	    my $c = 0;
      foreach my $fld (@$pflds) {
	      $sql.=",$fld=".$dbh->quote($$pvals[$c]);
		    $c++;
	    }
	    $sql .= " where Laufnummer=$$pnr";
	    $dbh->do($sql);
	  }
	  $page++;
	  my $seite = ($$pnr*1000)+$page;
    $sql="insert into $db1.archivbilder set Seite=$seite,".
	       "BildInput=".$dbh->quote($$pimg);
    $dbh->do($sql);
	  $sql = "update $db1.archiv set Seiten=$page where Laufnummer=$$pnr";
	  $dbh->do($sql);
	  my $color = 24;
	  $color=1 if $bw==1;
	  if ($scale>0) {
      my $img1 = ExactImage::newImage();
      ExactImage::decodeImage($img1,$$pimg);
      AVJobs::createThumbsAndSave($dbh,$db1,$img1,24,$$pnr,
	                                $page,$scandef,$color);
			ExactImage::deleteImage($img1);
	  }
		my @row = "select Seite from $db1.archivseiten where Seite=$seite";
		$sql = "insert into $db1.archivseiten ";
		$sql = "update $db1.archivseiten " if $row[0]==$seite;
	  $sql .= "set Text=".$dbh->quote($exif).",Seite=$seite";
    $sql .= ",Schlussel=".$dbh->quote($md5) if $md5it==1;
		$sql .= " where Seite=$seite" if $row[0]==$seite;
	  $dbh->do($sql);
  }
}



=head1 getParameter($av)

Read quality and scale factor

=cut

sub getParameters {
  my ($dbh,$db1) = @_;
  my $qual = AVJobs::getParameterRead($dbh,$db1,"JpegQuality");
	$qual = 33 if $qual<10 || $qual>100;
  my $scale = AVJobs::getParameterRead($dbh,$db1,"PrevScaling");
	if ($scale>0 && $scale<100) {
	  $scale = $scale / 100;
	} else {
    $scale = 0;
	}
  my $md5it = AVJobs::getParameterRead($dbh,$db1,"CameraMD5");
	return ($qual,$scale,$md5it);
}



=head1 setLabels

Fill in the language depending string

=cut

sub setLabels {
  my $frm = shift;
  my @obj=$frm->get(name=>'frmLogin');
  my $log = $obj[3];
	
  @obj=$log->get(name=>'lblHost');
  my $obj = $obj[3];
	$obj->set(text=>$msg_img_host);

  @obj=$log->get(name=>'lblDatabase');
  $obj = $obj[3];
	$obj->set(text=>$msg_img_db);
	
	@obj=$log->get(name=>'lblUser');
  $obj = $obj[3];
	$obj->set(text=>$msg_img_user);
	
	@obj=$log->get(name=>'lblPassword');
  $obj = $obj[3];
	$obj->set(text=>$msg_img_password);

	@obj=$frm->get(name=>'lblFields');
  $obj = $obj[3];
	$obj->set(text=>$msg_img_fields);

	@obj=$frm->get(name=>'chkText');
  $obj = $obj[3];
	$obj->set(text=>$msg_img_text);

	@obj=$frm->get(name=>'chkNone');
  $obj = $obj[3];
	$obj->set(text=>$msg_img_none);

	@obj=$frm->get(name=>'chkSingle');
  $obj = $obj[3];
	$obj->set(text=>$msg_img_single);

	@obj=$frm->get(name=>'chkAll');
  $obj = $obj[3];
	$obj->set(text=>$msg_img_all);

	@obj=$frm->get(name=>'lbl');
  $obj = $obj[3];
	$obj->set(text=>$msg_img_copy);
	
	@obj=$frm->get(name=>'frmLogin');
  $obj = $obj[3];
	$obj->set(text=>$msg_img_login);

	$frm->set(text=>$msg_img_frm);

	@obj=$frm->get(name=>'cmdOk');
  $obj = $obj[3];
	$obj->set(text=>$msg_img_ok);

	@obj=$frm->get(name=>'cmdCancel');
  $obj = $obj[3];
	$obj->set(text=>$msg_img_cancel);
}



=head1 getUserConnection($frm)

Read the password information from sane-button.pl and show it in form

=cut

sub getUserConnection {
  my $frm = shift;
  my $prg = "";
  AVJobs::readFile2($val{sanebutton},\$prg);
	my @lines = split(/\n/,\$prg);
	my $host = "";
	my $db = "";
	my $user = "";
	my $pw = "";
	foreach my $line (@lines) {
	  chomp $line;
	  my ($name,$val) = split(/=/,$line);
		$host = $val if $name eq "host";
		$db = $val if $name eq "db";
		$user = $val if $name eq "user";
		$pw = $val if $name eq "pw";
	}
  my @databases = split(',',$db);
  my $database = shift @databases;
  my ($dbname,$id) = split(':',$database);
	$db = $dbname if $dbname ne "";
	$host = "localhost" if $host eq "";
	$db = "archivista" if $db eq "";
	$user = "Admin" if $user eq "";
	$pw = "archivista" if $pw eq "";
  my @obj=$frm->get(name=>'frmLogin');
  my $log = $obj[3];
  @obj=$log->get(name=>'txtHost');
  my $obj = $obj[3];
	$obj->set(text=>$host);
  @obj=$log->get(name=>'txtDatabase');
  $obj = $obj[3];
	$obj->set(text=>$db);
  @obj=$log->get(name=>'txtUser');
  $obj = $obj[3];
	$obj->set(text=>$user);
  @obj=$log->get(name=>'txtPassword');
  $obj = $obj[3];
	$obj->set(text=>$pw);
}



=head1 readUserConnection($frm) 

Read the user information for a connection

=cut

sub readUserConnection {
  my $frm = shift;
  my @obj=$frm->get(name=>'frmLogin');
  my $log = $obj[3];
  @obj=$log->get(name=>'txtHost');
  my $obj = $obj[3];
	my $host = $obj->text;
  @obj=$log->get(name=>'txtDatabase');
  $obj = $obj[3];
	my $db = $obj->text;
  @obj=$log->get(name=>'txtUser');
  $obj = $obj[3];
	my $user = $obj->text;
  @obj=$log->get(name=>'txtPassword');
  $obj = $obj[3];
	my $pw = $obj->text;
	return ($host,$db,$user,$pw);
}



=head1 optimizeBW($pimage,$qual,$ext,$high)

Does optimize a jpeg file to tif 

=cut

sub optimizeBW {
  my $pimage = shift;
	my $qual = shift;
	my $ext = shift;
  my $high = shift;
  my $image = ExactImage::newImage(); # decode the image
  ExactImage::decodeImage($image,$$pimage);
  ExactImage::imageOptimize2BW($image,0,0,$high,3,2.1);
	$$pimage = ExactImage::encodeImage($image,$ext,$qual,'');
	ExactImage::deleteImage($image);
}



