#!/usr/bin/perl

use strict;
use lib qw(/home/cvs/archivista/jobs);
use AVJobs;
my $db = shift;
my $lnr = shift;
my $fpsin = shift;
$fpsin = 50 if $fpsin eq "";
my $fpsout = shift;
$fpsout = 25 if $fpsout eq "";
my $win = shift; # search for movies with current width
$win = 1280 if $win eq "";
my $hin = shift; # search for movies with current height
$hin = 720 if $hin eq "";
my $wout = shift; # raster movies to desired width
$wout = 1280 if $wout eq "";
my $hout = shift; # raster movies to desired height
$hout = 720 if $hout eq "";
my $qual = shift; # quality of render process
$qual = 0 if $qual eq "";
my $buffer = shift; # error correction on corrupted videos
$buffer = 0 if $buffer eq "";
my $dvdopt = shift; # option for converted dvds
$dvdopt = 0 if $dvdopt eq "";
my $ftemp = "/home/data/archivista/tmp";
mkdir $ftemp if !-d $ftemp;
my $fout = "/home/data/archivista/tmp/mp4";
mkdir $fout if !-d $fout;
my $fhigh = "/home/data/archivista/archhigh"; # path to put originals
mkdir $fhigh if !-d $fhigh; 
if ($db eq "" && $lnr==0) {
	die "$0 db doc [fpsin|50 fpsout|25] win|1280 hin|720 wout|1280 hout|720 ".
		"qual|0-50] buffer[0|1024|2048|4096] dvdopt\n";
}
logit("mp4 optimisation for $db $lnr $fpsin $fpsout ".
	"$win:$hin $wout:$hout $qual $buffer $dvdopt");
my $dbh = MySQLOpen();
if ($dbh) {
  if (HostIsSlave($dbh)==0) {
		my $sql = "use $db";
		$dbh->do($sql);
		$sql = "select Laufnummer,Seiten,Archiviert,Ordner,EDVName,".
			"MediaFrames,MediaType,MediaCodec from archiv where Laufnummer=$lnr";
		$sql .= " and MediaFrames=$fpsin" if $fpsin ne "-1" && $fpsin ne "0";
		$sql .= " and MediaWidth=$win and MediaHeight=$hin" if $win>0 && $hin>0;
		my @row = $dbh->selectrow_array($sql);
		if ($row[0]==$lnr) {
			my $seiten = $row[1];
			my $arch = $row[2];
			my $ordner = $row[3];
			my $edvname = $row[4];
			my $frames = $row[5];
			my $video = $row[6];
			my $cod = $row[7];
			my $file = "";
			my ($type,$name,$ext) = splitEDVName($edvname);
			if ($type eq "multi") {
				$file = isSourceExternal($db,$lnr,$type,$ext) if $type eq "multi";
				my @parts = split(/\//,$file);
				my $fileext = "$fhigh/".pop @parts;
				logit("$file for $lnr in $db with $frames to $fpsout and $wout:$hout");
				if (-e $file && $video eq "video" && $cod eq "h264" && 
					($frames==$fpsin || $fpsin eq "-1") && !-e $fileext) {
					my @parts = split(/\//,$file);
					my $fname = pop @parts;
					my @parts0 = split(/\./,$fname);
					my $ext = pop @parts0;
					my $base = join('.',@parts0);
					my $fmp4 = $ftemp.'/'.$fname;
					my $ferr = $ftemp.'/'.$base.'.err';
					my $file2 = $fout.'/'.$fname;
					unlinkFile($fmp4);
					unlinkFile($file2);
					my $cmd2 = "";
					if ($buffer==1024 || $buffer==2048 || $buffer==4096) {
						$cmd2 = " -max_muxing_queue_size $buffer";
					}
					my $cmd = "ffmpeg -i $file";
					if ($fpsout ne "-1" && $fpsout ne "0") {
						$cmd .= " -filter:v fps=fps=$fpsout";
						$cmd .= ",scale=$wout:$hout" if $win>$wout && $hin>$hout;
					} else {
						$cmd .= " -filter:v scale=$wout:$hout" if $win>$wout && $hin>$hout;
					}
					$cmd .= " -crf $qual" if $qual>0;
					$cmd .= " -vf yadif" if $dvdopt>0;
					$cmd .= "$cmd2 $fmp4";
					my $err=callPrg($cmd,$ferr,1);
					$cmd = "ffmpeg -i $file -i $fmp4 -map_metadata 0 -map 1:v:0 ".
						"-map 0:a -map 0:s -c copy $file2";
					$err=callPrg($cmd,$ferr,2) if !-e $file2 && $err==0;
					if ($err!=0) { # if there are no subtitles, call it without them
						$cmd = "ffmpeg -i $file -i $fmp4 -map_metadata 0 -map 1:v:0 ".
							"-map 0:a -c copy $file2";
						$err=callPrg($cmd,$ferr,3) if !-e $file2;
					}
					if (-e $file2 && $err==0) {
						unlinkFile($fmp4);
						my $ok=moveFile($file,$fileext,1);
						if ($ok==1) {
							my $size=0;
							$ok=moveFile($file2,$file,1);
							$size = -s $file if $ok==1;
							if ($size>0) {
								$size = int(($size/(1024*1024)*100)+0.5);
								$size = $size/100;
								$sql = "update archiv set MediaSizeMB=".$dbh->quote($size);
								$sql.= ",MediaFrames=$fpsout" if $fpsout ne "-1";
								$sql.= ",MediaWidth=$wout" if $wout>0;
								$sql.= ",MediaHeight=$hout" if $hout>0;
								$sql.=" where Laufnummer=$lnr";
								$dbh->do($sql);
								logit($sql);
								my $snr = ($lnr*1000)+1;
								my $md5 = md5File($file);
								$sql = "update archivseiten set Schlussel=".$dbh->quote($md5).
									" where Seite=$snr";
								$dbh->do($sql);
								logit($sql);
							} else {
								$err=-3;
							}
						} else {
							$err=-2;
						}
					}
					logit("ERROR at $lnr") if $err!=0;
				} else {
					if (-e $fileext) {
						logit("no processing at $lnr, already optimized, see $fileext");
					} else {
						logit("ERROR at $lnr, unknown reasen");
					}
				}
			}
		}
	}
}

sub callPrg {
	my ($prg,$ferr,$nr) = @_;
	my $log = "";
	my $err = 0;
	my $tmpfile = writeTempFile();
	my $res=system("$prg 2>$tmpfile");
	readFile2($tmpfile,\$log,1);
	if ($res==0) {
		if ($log =~ /(invalid)/) {
			$err=$nr;
			writeFile($ferr,\$log,1);
		}
	} else {
		$err=-1;
	}
	logit("$res/$err=>$prg");
	return $err;
}

