#!/usr/bin/perl

use strict;
use lib qw(/home/cvs/archivista/jobs);
use AVJobs;
my $file = shift; # path and file together
my @parts = split(/\//,$file);
my $fout = pop @parts;
my $pout = shift; # path only to raster
my $fps = shift;
my $wout = shift;
my $hout = shift;
my $qual = shift;
my $dvdopt = shift;
my $sameinput = shift;
$fps=25 if $fps eq "";
my $ftemp = "/home/data/archivista/tmp";
if (!-e "$file" || !-d "$pout") {
	die "$0 pathfile pathout [fps widthout heightout quality dvdopt sameinput]\n";
}
my $same="doit";
if ($wout>0 && $hout>0 && $sameinput ne "") {
	$same = "";
	my $cmd="ffprobe -v error -show_streams \"$file\"";
	my $info=`$cmd`;
	$same = "doit" if $info =~ /(height=$hout)/ && $info =~ /(width=$wout)/;
}
if ($same ne "") {
	logit("mp4 optimization with $file $pout $fps $wout $hout $qual");
	my $cmd = "";
	if ($fps ne "-1") {
		$cmd .= " -filter:v fps=fps=$fps";
		$cmd .= ",scale=$wout:$hout" if $wout>0 && $hout>0;
	} else {
		$cmd .= " -filter:v scale=$wout:$hout" if $wout>0 && $hout>0;
	}
	$cmd .= " -vf yadif" if $dvdopt>0;
	$cmd .= " -crf $qual" if $qual>0;
	unlink "$ftemp/$fout" if -e "$ftemp/$fout";
	my $err=startjob($file,$pout,$ftemp,$cmd,1);
	$cmd = "-map_metadata 0 -map 1:v:0 -map 0:a -map 0:s -c copy";
	if ($err==0) {
		$err=startjob($file,$pout,$ftemp,$cmd,2);
		if ($err!=0) {
			$cmd = "-map_metadata 0 -map 1:v:0 -map 0:a -c copy";
			$err=startjob($file,$pout,$ftemp,$cmd,2,$err);
		}
	}
	unlink "$ftemp/$fout" if -e "$ftemp/$fout";
}

sub startjob {
	my ($file,$pout,$ftemp,$cmd,$nr) = @_;
	my @parts = split(/\//,$file);
	my $fname = pop @parts;
	my @parts0 = split(/\./,$fname);
	my $ext = pop @parts0;
	my $base = join('.',@parts0);
	my $fmp4 = $ftemp.'/'.$fname;
	my $ferr = $ftemp.'/'.$base.'.err';
	my $file2 = $pout.'/'.$fname;
	my $prg = "";
	my $err = 0;
	if ($nr==1) {
		$prg = "ffmpeg -i \"$file\"$cmd \"$fmp4\"";
	} elsif ($nr==2 || $nr==3) {
		$prg = "ffmpeg -i \"$file\" -i \"$fmp4\" $cmd \"$file2\"";
	}
	if ($prg ne "") {
		my $tmpfile = writeTempFile();
		my $res=system("$prg 2>$tmpfile");
		my $log = "";
		readFile2($tmpfile,\$log,1);
		if ($res==0) {
			if ($log =~ /(invalid)/) {
				$err=$nr;
				writeFile($ferr,\$log,1);
			}
		} else {
			$err=-1;
		}
		logit("$res/$err=>$prg");
	}
	return $err;
}

