#!/usr/bin/perl

use strict;
use lib qw (/home/cvs/archivista/jobs);
use AVJobs;
use lib qw (/home/cvs/archivista/webclient/perl); 
use obj::Note;
my $cpu = shift;
my $host = shift;
my $db = shift;
my $user = shift;
my $pw = shift;
my $quality = shift;
my $lang = shift;
my $detect = shift; # detect page orientation
my $docs = shift;
my $id = shift;
my @docs = split(",",$docs);
my $doc = shift @docs;
my $doocr = shift;
my $clean = shift;
my $tables = shift;
if ($cpu eq "" && $host eq "" && $db eq "" && $user eq "" && $pw eq "") {
  print "$0 cpu host db user pw [quality (5-100) ".
	      "lang (German,English) detect (0/1=page orientation)]\n\n";
	#exit 0;
}
$quality = 5 if $quality<5;
$quality = 100 if $quality>100;
$detect = 0 if $detect!=1;
my $smallram = smallram();
$lang = "German,French,Italian,English" if $lang eq "";
my $pfad = "/home/archivista/.wine/drive_c/Programs";
$pfad = "/home/data/tmp" if $smallram==1;
mkdir $pfad if !-e $pfad;
$pfad .= "/av$cpu";
mkdir $pfad if !-e $pfad;
my $pfad0 = "/home/data/archivista/tmp/av";
mkdir $pfad0 if !-e $pfad0;
my $prg = "/home/archivista/status.sh -webconfig";
my $status = `$prg 2>/dev/null | grep 'Inet addr'`;
my ($label,$ip) = split(":",$status);
$ip =~ s/(\s)//;
chomp $ip;
my $found=1;
my $c = 0;
while ($found) {
  $host = $ip if $host eq "localhost";
  my $host1 = $host;
  $host1 = "localhost" if $user eq "root";
  my $dbh = MySQLOpen($host1,$db,$user,$pw);
  if ($dbh) {
    if (HostIsSlaveSimple($dbh)==0) {
	    logit("database connection is ok");
      my ($pdf,$ocr,$whole,$lim,$sta,$end,$pdftemp,$pdfhost,$pdfdomain,
				$pdffolder,$pdfuser,$pdfpw) = getOCRVals($dbh,$db);
			$whole=0 if $smallram==1;
			if (ocrServerInit($pfad,$cpu,$smallram,$doocr)) {
        if (DocumentLock($dbh,$db,$doc,"ocr844-$cpu")) {
			    $c=0;
          $found = ocrServerGo($pfad,$pfad0,$ip,$cpu,$dbh,$db,$quality,
						$lang,$pdf,$whole,$doc,$detect,$doocr,$detect,$clean,$tables);
				  logit("$doc is processed");
					OCRScriptPDFCheck($dbh,$host1,$db,$user,$pw,$doc,$pdftemp,
						$pdfhost,$pdfdomain,$pdffolder,$pdfuser,$pdfpw);
          DocumentUnlock($dbh,$db,$doc);
					speechRecognition($db,$doc);
			    my $dbh2 = MySQLOpen();
				  if ($dbh2) {
            if (HostIsSlaveSimple($dbh2)==0) {
              my $sql="update archivista.logs set pwd='',DONE=4 where ID=$id";
              $dbh2->do($sql);
					  }
					}
					unlink("$pfad/AV5AUTO.OCR") if -e "$pfad/AV5AUTO.OCR";
				}
        if ($found==1 && $doc>0) {
          $doc = shift @docs;
					$found = 0 if $doc==0;
				}
			} else {
        logit("$0 not started, initialization of ocr server failed!");
			  $found = 0;
			}
	  } else {
      logit("$0 not started, we are in slave mode!");
			$found = 0;
	  }
	} else {
	  $c++;
		if ($c<20) {
		  sleep 1;
		} else {
		  $found=0;
		}
  }
}
unlink("$pfad/AV5AUTO.OCR") if -e "$pfad/AV5AUTO.OCR";



sub ocrServerGo {
  my ($pfad,$pfad0,$ip,$cpu,$dbh,$db,$quality,$lang,$pdf,
			$whole,$doc,$pa,$doocr,$detect,$clean,$tables) = @_;
	my $archfolders = ""; # number of folders in one splitted table
	my @in = ();
	my @out = ();
	my $found = 0;
	my $sql = "select Laufnummer,Seiten,Ordner,Archiviert,ArchivArt ".
	       "from archiv where Laufnummer=$doc";
	my ($doc1,$pages,$ord,$arch,$art) = $dbh->selectrow_array($sql);
	if ($doc1==$doc) {
		my $table = "archivbilder";
	  my $ext = "tif";
		$ext = "png" if $art==2;
		$ext = "jpg" if $art==3;
		$found = 1;
  	for (my $page=1;$page<=$pages;$page++) {
			my $lnr=($doc*1000)+$page;
			$sql = "select Seite from archivseiten where Seite=".$lnr;
			my @row1 = $dbh->selectrow_array($sql);
			if ($row1[0]==0) {
				$sql="insert into archivseiten set Seite=".$lnr.
				",OCR=0,Erfasst=1,Ausschliessen=0";
				logit($sql);
				$dbh->do($sql);
			}
			$table=getBlobTable($dbh,$ord,$arch,"archivbilder","");
		  $sql = "select BildInput from $table where Seite=$lnr";
  		my ($img) = $dbh->selectrow_array($sql);
			my $lang=length($img);
			logit("image size $doc"."_"."$page.$ext:$lang");
			if ($lang>0) {
			  my $namein = $db."_".$doc."_".$page.".".$ext;
				my $nameout = $db."_".$doc."_".$page."."."txt";
        my $res=writeFile("$pfad/$namein",\$img,1);
				if ($res==0) {
				  $found=1;
					last;
				}
			  unlink "$pfad/$nameout" if -e "$pfad/$nameout";
			  push @in,$namein;
			  push @out,$nameout;
			}
		}
		if ($found==1) {
		  my $in = join(",",@in);
		  my $out = join(",",@out);
			logit("start ocrserver with $cpu-$ip and $in");
    	ocrServerGoOCR($in,$out,$pfad,$quality,$lang,$pdf,$pa,$doocr,
				$doc,$pages,$ext,$detect,$clean,$tables,$db);
			my $cpage = 0;
			foreach my $file (@in) {
				$cpage++;
				my $lnr = ($doc*1000)+$cpage;
			  my ($nr,$ext) = split(/\./,$file);
				my $img = "$pfad/$file";
				my $pdff = "$pfad/$nr.pdf";
				my $txt = "$pfad/$nr.txt";
				my $cont = "";
				readFile2($txt,\$cont,1);
				my $lower = "[a-z-áàȧâäǟǎăāãåǻǽǣćċĉčďḍḑḓéèėêëěĕēẽe̊".
					"ẹǵġĝǧğg̃ģĥḥíìiîïǐĭīĩịĵķǩĺļľŀḽm̂m̄ŉńn̂ṅn̈ňn̄ñņṋóòôȯȱöȫǒŏōõȭőọǿơ".
					"p̄ŕřŗśŝṡšşṣťțṭṱúùûüǔŭūũűůụẃẁŵẅýỳŷÿȳỹźżžẓç]";
				$cont =~ s/(-)(\n)($lower{1,1}?)(.*?)(\s)/$3$4\n/gs;
				$sql = "update archivseiten set Erfasst=1,Text=".$dbh->quote($cont).
					" where Seite=$lnr";
				$dbh->do($sql);
				unlink $img if -e $img;
				if ($pdf==1) {
				  $cont = "";
					if ($whole==0)  {
				    readFile2($pdff,\$cont,1);
				    $sql = "update $table set Quelle=".$dbh->quote($cont)." ".
				           "where Seite=$lnr";
			  	  $dbh->do($sql);
			    	logit("$txt and $pdf added to $db");
					} else {
					  my $cmd = "mv $pdff $pfad0";
						system($cmd);
						if ($cpage==$pages) {
	   	  	    ocrServerPDFWhole($dbh,$db,$table,$pfad0,
								$doc,$pages,$archfolders);
						}
			  	}
				} else {
				  logit("$txt added to $db");
    	  }
			}	
		}
	} else {
		logit("doc $doc in $db at $host seems to be to have an error!");
	}
  return $found;
}



sub ocrServerGoOCR {
  my ($in,$out,$pfad,$quality,$lang,$pdf,$pa,$doocr,
		$doc,$pages,$art,$detect,$clean,$tables,$db) = @_;
	if ($doocr==1) {
	  my $profile_cmd = '. /etc/profile'; # import default settingdx = 0; $idx <
		my $nr=":0";
		$nr=`cat /tmp/display` if -e "/tmp/display";
  	my $display_cmd = "export DISPLAY=$nr"; # export display to default
	  my $cd_cmd = "cd ".$pfad; # ocr folder
		my $xrandr = getXRandr($profile_cmd,$display_cmd);
	  my $ocr_cmd = "wine avformrc.exe -i $in -o $out ";
		$ocr_cmd .= "-p -q $quality" if $pdf==1;
	  $ocr_cmd .= " -l $lang" if $lang ne "";
		$ocr_cmd .= " -d" if $pa==1;
  	my $ocrdo = qq(/bin/su - archivista -c "$profile_cmd; $display_cmd;).
	              qq($xrandr $cd_cmd; $ocr_cmd");
  	logit($ocrdo);
	  system($ocrdo);
	} else {
		$lang = "English,German,French,Italian" if $lang eq "";
   	OCRDoOpenSource($doc,$pages,$lang,$doocr,$pdf,0,$pfad,$art,
			$detect,$clean,$tables,0,$db);
	}
}



sub ocrServerInit {
  my ($dir,$cpu,$smallram,$doocr) = @_;
	my $lang0 = "/home/archivista/.wine/drive_c/Programs/av41fr5";
	my $lang1 = "/home/data/tmp/av41fr5";
	if ($smallram==1) {
    if (-e $lang0 && !-e $lang1) {
      my $go = "/home/archivista/.wine/dosdevices";
      my $cmd = "cd $go;ln -s /home/data/tmp d:";
      my $res = system("$cmd");
      $res = system("cd $go;chown -R archivista.users d:");
	    $res = system("cp -rp $lang0 $lang1");
	  }
	}
	my $res=0; 
	my $from = "/home/archivista/.wine/drive_c/Programs/Av5e";
  my $cpus = `cat /proc/cpuinfo | grep '[P|p]rocessor'`;
  my @lines = split(/\n/,$cpus);
  my $cpumax = @lines;
	if ($cpu<=$cpumax) {
		if ($doocr==1) {
	    mkdir $dir if !-e $dir;
		  system("cp -rp $from/avformrc.exe $dir");
	  	system("cp -rp $from/av7.con $dir");
		  system("chown -R archivista.users $dir");
		  $res=1 if -e "$dir/avformrc.exe" && -e "$dir/av7.con";
		} else {
			$res=1;
		}
	}
	return $res;
}



sub ocrServerPDFWhole {
  my ($dbh,$db,$table1,$pfad,$doc,$pages,$archfolders) = @_;
  my $sql = "select Seiten,Ordner,Archiviert ".
	          "from archiv where Laufnummer=$doc";
  my @res = $dbh->selectrow_array($sql);
  my $max = $res[0];
	my $folder = $res[1];
	my $arch = $res[2];
	my $allpdfs = 1;
	my $files = "";
  for (my $c=1;$c<=$max;$c++) {
	  my $nr1 = ($doc*1000)+$c;
		my $file1 = $pfad."/".$db."_".$doc."_".$c.'.pdf';
		if (!-e $file1) {
		  $sql = "select Ausschliessen,Notes from archivseiten where Seite=$nr1";
		  my @row = $dbh->selectrow_array($sql);
			my $excl = $row[0];
			my $notes = $row[1];
			if ($excl>0 || $notes ne "") {
			  ocrServerPDFSingle($dbh,$db,$table1,$file1,$nr1,$doc,$c,
				                   $arch,$folder,$archfolders);
			}
		}
		my $size = 0;
		for (my $c1=0;$c1<10;$c1++) {
			if (-e $file1) {
		    $size = -s $file1;
				if ($size>0) {
				  $c1=10;
				} else {
				  sleep 1;
        }
			} else {
			  $c1=10;
			}
		}
		if (!-e $file1) {
		  $allpdfs = 0;
			last;
    }
		if (-e $file1 && $size==0) {
		  $allpdfs = 0;
			last;
		}
		$files .= "$file1 ";
  }
	if ($allpdfs==1) {
	  my $file0 = "$pfad/$doc.pdf";
	  my $cmd = "pdftk $files"."output $file0";
		my $res = system($cmd);
		logit("$res=>$cmd");
		if ($res==0) {
		  my $cont="";
      readFile2($file0,\$cont,1);
			my $nr = ($doc*1000)+1;
      my $sql = "update $table1 set Quelle=".$dbh->quote($cont)." ".
                "where Seite=$nr";
			my $res2 = $dbh->do($sql);
			logit("added pdf $doc to $table1 with status $res2");
		}
   	for (my $c=1;$c<=$max;$c++) {
		  if ($c>1) {
			  my $nr=($doc*1000)+$c;
			  $sql = "update $table1 set Quelle='' where Seite=$nr";
				$dbh->do($sql);
			}
	    my $nr1 = ($doc*1000)+$c;
		  my $file1 = $pfad."/".$db."_".$doc."_".$c.'.pdf';
			unlink $file1 if -e $file1;
		}
	}
}



sub ocrServerPDFSingle {
  my ($dbh,$db,$table1,$file1,$nr1,$doc,$c,$arch,$folder,$archfolders) = @_;
  my $bild = 'BildInput';
  my $prow = getBlobFile($bild,$nr1,$folder,$arch,$table1,$archfolders);
  if (length($$prow[0])==0) {
    $bild = 'Bild';
    $prow = getBlobFile($bild,$nr1,$folder,$arch,$table1,$archfolders);
  }
  my $imgo = ExactImage::newImage();
  ExactImage::decodeImage($imgo,$$prow[0]);
  my $params = {
    doc=>$doc,
    page=>$c,
    cWidth => ExactImage::imageWidth($imgo),
    cHeight => ExactImage::imageHeight($imgo)
  };
  # extract notes from db, but dont rotate them or update params
  # pass in image to increase speed. Should always be BildInput?
  my $dbnotes = MainNoteHash($dbh,$db,$params,$imgo);
  # loop thru notes and add to image
  foreach my $note (values %{$dbnotes}){
    $note->getImage($imgo);
  }
  ExactImage::encodeImageFile($imgo,$file1);
  ExactImage::deleteImage($imgo);
}

