#!/usr/bin/perl

=head1 processweb.pl (c) 17.3.2008 by Archivista GmbH, Urs Pfister

This script processes an uploaded file from WebClient

=cut

use strict;
use lib qw(/home/cvs/archivista/jobs);
use AVJobs;
use File::Copy;
use File::stat;
use File::Temp "tempfile";
use File::Basename "basename";
use Encode;
my $SLEEP = 1; # Seconds we wait when no job was found
use constant MAX_PAGES => 640; # max. number of pages/doc (640)
use constant JOB_DONE => 120; # scanadf job was started
use Fcntl qw(:flock SEEK_END); # import LOCK_* and SEEK_END constants

# DBI data for jobs table
my %val;
$val{sane} = "/usr/bin/perl /home/cvs/archivista/jobs/sane-client.pl";
$val{logtype} = "sne"; # type in logs table
$val{webfile} = ""; # uploaded file name
$val{jobid} = shift; # the id from the jobs table
$val{tmp} = "/home/data/archivista/tmp/";
$val{ds} = '/'; # directory separator (/ or \\)
$val{dbhh} = 0;
$val{vers} = check64bit();
$val{def} = '';
use constant MPG => "MPG";
use constant AV1 => "AV1";
use constant MP4 => "MP4";
use constant AVI => 'AVI';
use constant MKV => 'MKV';
use constant FLV => 'FLV';
use constant WAV => "WAV";
use constant OGG => "OGG";
use constant MP3 => "MP3";
use constant PDF => "PDF";
use constant PNM => "PNM";
use constant PNG => "PNG";
use constant TIF => "TIF";
use constant JPEG => "JPEG";
use constant GIF => "GIF";
use constant BMP => "BMP";
use constant BMP3 => "BMP3";
use constant TIFF => "TIFF";
use constant MAIL => "MAIL";
use constant DATA => "data";
use constant FFMPEG => "/usr/bin/ffmpeg";

logit("web job with $val{jobid} started");
my $res = 0;
for (my $c0=0;$c0<360;$c0++) {
  $val{dbh}=MySQLOpen();
  if ($val{dbh}) {
	  $res=1;
		last;
	}
	sleep 1;
}
if ($res==1) {	  
  if (HostIsSlave($val{dbh})==0) {
    # set back the log id
    $val{logid} = 0;
    # get the next job
    my $sql = "select id,host,db,user,pwd,job from jobs " .
              "where id = $val{jobid}";
    my @f = $val{dbh}->selectrow_array($sql);
	  if ($f[0] == $val{jobid}) {
      # we store the host,db,user,password information for later storage
      $ENV{'AV_SCAN_JOBS_ID'} = $val{jobid};
      $ENV{'AV_SCAN_HOST'} = $f[1];
      $ENV{'AV_SCAN_DB'} = $f[2];
      $ENV{'AV_SCAN_USER'} = $f[3];
      $ENV{'AV_SCAN_PWD'} = $f[4];
      $ENV{'AV_SCAN_OWNER'} = selectValue($val{dbh},$val{jobid},"SCAN_USER2");
      $val{scanid} = selectValue($val{dbh},$val{jobid},"SCAN_DEFINITION");
			$ENV{'AV_PATH'} = selectValue($val{dbh},$val{jobid},"WEB_PATH");
			$val{webfile} = selectValue($val{dbh},$val{jobid},"WEB_FILE");
      $val{ocr} = selectValue($val{dbh},$val{jobid},"WEB_OCR"); # get ocr
      $val{bits} = selectValue($val{dbh},$val{jobid},"WEB_BITS"); # get bits
      $val{def} = selectValue($val{dbh},$val{jobid},"WEB_DEF"); # get scan def
      $val{offturbo} = selectValue($val{dbh},$val{jobid},"TurboVideosOff");
      $val{dontkill} = selectValue($val{dbh},$val{jobid},"DONTKILL");
      $ENV{'AV_KFILE'} = selectValue($val{dbh},$val{jobid},"KFILE");
			my $mediafile=checkMediaFile($val{dbh},$ENV{'AV_SCAN_DB'},$val{webfile});
      processWeb(\%val) if $mediafile==0;
	    my $status = JOB_DONE;
      $sql = "update jobs set pwd='',status=$status where id=$val{jobid}";
      $val{dbh}->do($sql);
		  logit("web job with $val{jobid} ended");
		}
	}
	$val{dbh}->disconnect();
}



sub checkMediaFile {
	my ($dbh,$db,$file) = @_;
	my $mediafile=0;
	my @parts = split(/\./,$file);
	my $ext = pop @parts;
	if ($ext eq "txt") {
		my $mediadb = getParameterRead($dbh,$db,"MediaFields");
		if ($mediadb == 1) {
			my $base = join('.',@parts);
			@parts = split(/\//,$base);
			my $fbase = pop @parts;
			my $fname = $fbase.'.'.$ext;
			my $sql = "select Laufnummer,Titel from $db.archiv where ".
				"MediaName like ".$dbh->quote(fromUTF8($fbase)."%")." order ".
				"by Laufnummer asc limit 1";
			my @row = $dbh->selectrow_array($sql);
			if ($row[0]>0) {
				my $lnr = $row[0];
				my $text = $row[1];
				logit("media file at $lnr in $db found, now check file content");
				if ($text eq "") {
					readFile2($file,\$text);
					$text=fromUTF8($text);
					$text =~ /(Titel:)(.*)/;
					if ($1 eq "Titel:" && $2 ne "") {
						my $titel = $2;
						$titel =~ s/^(\s+)//g;
						$titel =~ s/^(\t+)//g;
						$sql = "update $db.archiv set Titel=".$dbh->quote($titel).
							" where Laufnummer=$lnr";
						$dbh->do($sql);
						foreach my $fld ("Thema","Sender","Datum") {
							my $text1 = $text;
							$text1 =~ /($fld:)(.*)/;
							if ($1 eq "$fld:" && $2 ne "") {
								my $value = $2;
								$value =~ s/^(\s+)//g;
								$value =~ s/^(\t+)//g;
								$sql = "show fields from $db.archiv like '$fld'";
								my @row = $dbh->selectrow_array($sql);
								if ($row[0] eq "$fld") {
									my $sql="select $fld from $db.archiv where Laufnummer=$lnr";
									my @row1 = $dbh->selectrow_array($sql);
									if ($row1[0] eq "" || $fld eq "Datum") {
										logit("store $value for $fld at $lnr in $db");
										if ($fld eq "Datum") {
											$value=DocumentAddDatSQL($value);
										} else {
											$value=$dbh->quote($value);
										}
										$sql = "update $db.archiv set $fld=$value ".
											"where Laufnummer=$lnr";
										$dbh->do($sql);
									}
								}
							}
						}
						my $seite = ($lnr*1000)+1;
						$sql = "select Text from $db.archivseiten where Seite=$seite";
						my ($pagetext) = $dbh->selectrow_array($sql);
						$pagetext = "$text\n\n$pagetext";
						$sql = "update $db.archivseiten set Text=".$dbh->quote($pagetext).
							" where Seite=$seite";
						$dbh->do($sql);
						logit("update movie description for $lnr in $db, remove $file");
						unlink "$file" if -e "$file";
						$mediafile=1;
					}
				}
			}
		}
	}
	return $mediafile;
}



=head1 processWeb($pval)

Process a file with sane-client that was uploaded

=cut

sub processWeb {
  my $pval   = shift;
	my $file = $$pval{tmp}."job-$$pval{jobid}.upl";
	my $file1 = $$pval{tmp}."job-$$pval{jobid}";
	my $file2 = "/home/data/archivista/tmp/".$$pval{webfile};
	my $file3 = "/home/data/archivista/tmp/".$$pval{jobid}."-".$$pval{webfile};
	if (-e "$file") {
		moveFile($file2,$file3) if -e "$file2";
		if (!-e "$file2") { # Upload via WebClient
			$$pval{webfile} = $file2;
			moveFile($file,$$pval{webfile});
		}
	}
	my $date = "";
	if (checkFile($$pval{webfile})) {
    my $mdate = stat($$pval{webfile})->mtime;
		$date = DateStamp($mdate);
	}
	if (notFile($file) && checkFile($$pval{webfile})) {
		my $depth = 0;
		my $ocr = 0;
		my $rot = 0;
    my $host = $ENV{'AV_SCAN_HOST'};
    my $db = $ENV{'AV_SCAN_DB'};
    my $user = $ENV{'AV_SCAN_USER'};
		my $pwd = $ENV{'AV_SCAN_PWD'};
    $pwd = encode("utf8", $pwd);
		my $dbh = MySQLOpen($host,$db,$user,$pwd);
		if ($dbh) {
      my @svals = split(";",$$pval{scanid});
			my $scanname = $svals[0]; # name of scan defintion
			if ($$pval{bits}>0) {
			  $depth = $$pval{bits};
		    $depth = 0 if $depth == 1;
  		  $depth = 1 if $depth == 8;
	  	  $depth = 2 if $depth == 24;
		    $depth = 0 if $depth <0 || $depth>2;
			  $ocr = $$pval{ocr} if $$pval{ocr} ne "";
			} else {
        $depth = $svals[1]; # bitmap (1/8/24)
        $ocr = $svals[10]; # desired ocr option
				$rot = $svals[7]; # rotation factor
			}
		  my $source = "";
  		my $officeimages = getParameterRead($dbh,$db,"OfficeImages");
  		my $md5on = getParameterRead($dbh,$db,"CameraMD5");
			my $md5 = "";
			my $md5stop = 0;
			my $fname = "";
			if ($md5on==1) {
				$md5 = md5File($$pval{webfile});
				my $sql = "select Seite,Schlussel from $db.archivseiten where ".
					"Schlussel=".$dbh->quote($md5)." limit 1";
				my @row = $dbh->selectrow_array($sql);
				$md5stop=$row[0] if $row[0]>0 && $row[1] eq $md5;
				if ($md5stop>0) {
					if ($$pval{dontkill}==0) {
						my @parts = split(/\//,$$pval{webfile});
						my $fname = pop @parts;
						my $fout = "/home/data/archivista/ftp/temp/$db-$md5stop-$fname";
						if (!-e $fout) {
							moveFile($$pval{webfile},$fout,1);
						} else {
   						unlinkFile($$pval{webfile});
						}
					}
					logit("no processing becuase double at $db and $md5stop");
				}
			}
			if ($md5stop==0) {
				if ($$pval{dontkill}==1) {
					doit("cp \"".$$pval{webfile}."\" \"$file\"",1);
				} else {
				  moveFile($$pval{webfile},$file);
				}
		  	my @parts = split(/\//,$$pval{webfile});
				$$pval{webfile} = pop @parts;
				if (checkFile($file)) {
	  			logit("uploaded file $file found");
		   		$ENV{'AV_MD5'} = $md5;
			  	my ($format,$image,$office)=processWebFormat(\$file,
						\$source,$pval,$scanname,$depth,\$officeimages);
					if ($format ne MAIL) {
						if ($format ne DATA) {
				  		processWebPages($pval,$format,$ocr,$depth,$rot,$file,
								$file1,$source,$date,$dbh,$db,$image,$office,$officeimages);
						} else {
							processDataNo($file,$$pval{webfile});
						}
					} else {
						my $savemail = "/home/data/archivista/ftp/temp/officemail";
		  			my $maildef = getParameterReadWithType($$pval{dbh},
							$db,"MailArchiving01","MailArchiving");
						if (checkInitialized("d41696c6")) {
							my @parts = split(";",$maildef);
							$maildef = shift  @parts;
							if ($maildef ne "") {
								logit("maildef is:$maildef");
 								my $maildir = "/tmp/mail";
							  mkdir $maildir if !-e $maildir;
								$savemail = $maildir;
							} else {
								logit("To archive mails, configure it in WebAdmin");
							}
						}
						my @parts = split(/\//,$file);
						my $onlyfile = pop @parts;
						$onlyfile = $$pval{webfile} if $savemail ne "/tmp/mail";
						my $savefile = $savemail."/".$onlyfile;
						if (-d $savemail) {
							moveFile($file,$savefile);
							logit("mail is saved under $savefile");
						}
						if ($savemail eq "/tmp/mail") {
							my $cmd = "cd /home/cvs/archivista/jobs;/usr/bin/perl ".
								"mail-fetch.pl $db $maildef $savefile";
							$res=doit($cmd);
						} else {
							logit($$pval{webfile}." is mail, no office folder processing");
						}
					}
				}
			}
   		$dbh->disconnect();
		}
	}
}



sub processDataNo {
	my ($file,$fileweb) = @_;
	my $savepath = "/home/data/archivista/ftp/temp/dataonly";
	if (! -e "$savepath") {
		mkdir $savepath;
		doit("chown -Rf ftp.users $savepath");
	}
	my @parts = split(/\//,$fileweb);
	my $file0 = pop @parts;
	my @parts1 = split(/\./,$file0);
	my $ext = pop @parts1;
	my $base = join('.',@parts1);
	my $ok=0;
	for (my $c=0;$c<=10;$c++) {
		my $c1 = $c;
		$c1 = "" if $c==0;
		my $file1 = "$savepath/$base$c1.$ext";
		if (!-e "$file1" || $c==10) {
			moveFile($file,$file1);
			last;
		}
  }
}



=head1 processWebPages($pval,$form,$ocr,$depth,$opt,$def,$file,$f1,$source)

Process all pages that are ready to process (either als pdf or image file)

=cut

sub processWebPages {
  my ($pval,$format,$ocr,$depth,$rot,$file,$file1,$source,$date,
		$dbh,$db,$image,$office,$officeimages) = @_;
	my $seite = 1;
	my $res = 0;
	my $file2 = "";
	my $maxpage = 0;
	my $firstdoc = 0;
  my $opt = "";
  $opt = "-mono" if $depth==0;
  $opt = "-gray" if $depth==1;
	my $typ = "office";
	if ($format eq MPG || $format eq MP4 || $format eq WAV || 
		$format eq MP3 || $format eq OGG || $format eq MKV || 
		$format eq AVI || $format eq FLV || $format eq AV1) {
		$typ = "multi";
	}
	while ($seite>0 && $format ne "") {
	  ($res,$file2)=processWebPageSingle($file,$file1,$seite,\$maxpage,
			$format,$depth,$opt,$pval);
		if ($res==0) {
			my $versions = processWebVersions($dbh,$db,$pval);
	    my @svals = split(";",$$pval{scanid});
			$svals[1] = $depth; # bitmap (1/8/24)
			$svals[7] = $rot; # desired rotation
			$svals[10] = $ocr; # desired ocr option
      $svals[11] = 1; # adf mode (simplex)
      $svals[24] = 0; # no bw/optimization
			if ($seite==1) {
			  if ($$pval{webfile} ne "") {
			    my $filename = escape("$typ;".$$pval{webfile});
					if ($officeimages==1 || $image==0) {
				    $svals[27] .= ":" if $svals[27] ne "";
				    $svals[27] .= "EDVName=$filename";
					}
			  }
			  if ($date ne "") {
			    # add date if it is available
			    $svals[27] .= ":" if $svals[27] ne "";
			    $svals[27] .= "Datum=$date";
			  }
			  if ($versions ne "") {
			    $svals[27] .= ":" if $svals[27] ne "";
			    $svals[27] .= "$versions";
				}
			  if (checkFile($source)) {
			    if ($ocr != 27 && $typ ne "multi") {
		        $svals[10] = -1; # no ocr from office documents
				  }
				}
			  my $sc = join(";",@svals);
        $ENV{'AV_SCAN_DEFINITION'} = join(";",@svals);
			}
			if ($typ eq "multi") {
				$svals[1] = 24;
        $ENV{'AV_SCAN_DEFINITION'} = join(";",@svals);
			}
			if ($typ eq "multi" && ($seite>1 and $seite<$maxpage)) {
				$seite = $maxpage-1;
				my $found = checkmaxi(2);
				my @parts = split("-",$file2);
				pop @parts;
				my $base = join("-",@parts);
			 	my $doc = selectValue($$pval{dbh},$$pval{jobid},"SCAN_TO_DOCUMENT");
				my $cmd = "seq 2 $seite | parallel ".
					"--tmpdir /home/data/archivista/tmp -P $found /usr/bin/perl ".
					"/home/cvs/archivista/jobs/addpagefast.pl $db $doc {} $base-{}.jpg";
				$res=doit($cmd);
				my $nr = ($doc*1000)+1;
				my $sql = "select Ausschliessen,Erfasst from $db.archivseiten ".
					"where Seite=$nr";
				my @row = $dbh->selectrow_array($sql);
				my $erf = $row[0];
				my $aus = $row[1];
				for (my $c=2;$c<$seite;$c++) {
					$nr = ($doc*1000)+$c;
					$sql="insert into $db.archivseiten set Seite=$nr,".
						"OCR=$ocr,Erfasst=$erf,Ausschliessen=$aus";
  		  	$dbh->do($sql);
				}
				$dbh->do("update $db.archiv set Seiten=$seite where Laufnummer=$doc");
			} else {
				$res=processWebPageDo($pval,$seite,\$maxpage,$file,$source,$file2,
					$format,$depth,\$firstdoc,$typ,$image,$office,$officeimages);
			}
		}
		$seite++; # go to next page
		$seite=0 if $res != 0;
    unlinkFile($file2) if checkFile($file2);
	}
	unlinkFile($source) if checkFile($source);
  unlinkFile($file) if checkFile($file);
}

=head $retval=processWebVersions($dbh,$db,$pval)

Check if a source file is under control (adjust file name)

=cut

sub processWebVersions {
  my ($dbh,$db,$pval) = @_;
	my $retval = "";
	my $filename = "";
	my $docval = "";
	my $keyval = "";
  my $docfld = getParameterRead($dbh,$db,"VERSIONS");
	my $keyfld = getParameterRead($dbh,$db,"VERSIONKEY");
	if ($docfld ne "" && $keyfld ne "") {
	  my @parts = split(/\_/,$$pval{webfile});
	  $docval = shift @parts;
	  $keyval = shift @parts;
		if ($docval ne "" && $keyval ne "") {
		  $filename = join("_",@parts)  
		} else {
		  $docval="";
			$keyval="";
		}
		my $sql = "select $docfld,$keyfld from archiv ".
		          "where $docfld=".$dbh->quote($docval)." and ".
							"$keyfld > 0 ".
							"order by Laufnummer desc limit 1";
		my ($docval1,$keyval1) = $dbh->selectrow_array($sql);
		if ($docval1 eq $docval && $keyval eq $keyval1 && $docval ne "") {
		  # get in current version
			$keyval = $keyval + 0.1;
			$retval = "$docfld=$docval".":"."$keyfld=$keyval";
		  $$pval{webfile} = $filename;
		} elsif ($docval1 eq $docval && $keyval ne $keyval1 && $docval ne "") {
		  # get in old version
			$keyval = $keyval - (2*$keyval);
			$retval = "$docfld=$docval".":"."$keyfld=$keyval";
		  $$pval{webfile} = $filename;
		} else {
		  # no version at all found
			$retval = "$keyfld=1.0";
		}
	}
  $ENV{'SCAN_VERSIONS'}=$docfld;
  $ENV{'SCAN_VERSIONS_VAL'}=$docval;
  $ENV{'SCAN_VERSIONKEY'}=$keyfld;
  $ENV{'SCAN_VERSIONKEY_VAL'}=$keyval;
	return $retval;
}



=head1 processWebPageDo($pval,$seite,$pmaxpage,$file,$source,$f2,$form,$dept,$f)

Process one single page with sane-client.pl

=cut

sub processWebPageDo {
  my ($pval,$seite,$pmaxpage,$file,$source,$file2,
		$format,$depth,$pdoc,$typ,$image,$office,$officeimage) = @_;
	my $res = -1;
	if (checkFile($file2)) {
    logit("process page $seite in $file2");
		$ENV{'AV_CURRENTPAGE'}=$seite;
		$ENV{'AV_MAXPAGES'}=$$pmaxpage;
    $ENV{'SCAN_DEPTH'}=$depth;
    $ENV{'SCAN_FILE'}=$file2;
    my $doc = selectValue($$pval{dbh},$$pval{jobid},"SCAN_TO_DOCUMENT");
		$$pdoc=$doc if $doc>0 && $$pdoc==0;
    $ENV{'AV_SCAN_TO_DOCUMENT'} = $doc;
		$ENV{'AV_EDVNAME_KILL'}=1 if $doc>0 && $doc != $$pdoc;
		if ($image==1) {
	   	$ENV{'AV_SCAN_TO_DOCUMENT'} = 0;
			$ENV{'AV_PAGE_START'} = 1;
			$ENV{'AV_PAGE_END'} = 1;
      $ENV{'AV_OFFICE_IMAGES'} = $officeimage;
		  $source = "" if $officeimage==0;
		} else {
      if ((($seite % MAX_PAGES)==0) || $seite==$$pmaxpage) {
	      my $frame = int(($seite-1)/MAX_PAGES);
		    my $start = ($frame*MAX_PAGES)+1;
		    my $last = $seite;
			  $ENV{'AV_PAGE_START'} = $start;
			  $ENV{'AV_PAGE_END'} = $last;
				$ENV{'AV_SCAN_NO_LOG'} = 0;
        $ENV{'AV_SOURCE_NOTKILL'} = 1;
			} else {
			  $ENV{'AV_SCAN_NO_LOG'} = 1;
			}
		}
	  if (checkFile($source)) {
	    $ENV{'AV_SOURCE2'} = $source;
	    $ENV{'AV_SOURCE3'} = $file;
	  }
	  $ENV{'AV_OFFICETYP'} = $typ;
	  $ENV{'AV_MEDIASOUND'} = 0;
		if ($format eq MP3 || $format eq OGG || $format eq WAV) {
	  	$ENV{'AV_MEDIASOUND'} = 1;
		}
    my $cmd = "$$pval{sane}";
    $res = doit($cmd,1);
	}
	return $res;
}



=head1 processWebPageSingle($file,$file1,$seite,$pmaxpage,$format,$depth,$opt)

Prepare one page for importing with sane-client.pl (create an image from pdf)

=cut

sub processWebPageSingle {
  my ($file,$file1,$seite,$pmaxpage,$format,$depth,$opt,$pval) = @_;
	my $res = 0;
	my $file2 = "";
	my $file3 = "";
	if ($format eq MPG || $format eq MP4 || $format eq MKV || $format eq AVI || 
		$format eq MP3 || $format eq OGG || $format eq WAV || $format eq FLV ||
		$format eq AV1) {
		$file2 = "$file1-$seite.jpg";
		if ($$pmaxpage==0) {
			my @files = <$file1-*.jpg>;
			$$pmaxpage = @files;
		}
	} else {
	  if ($format eq PDF) {
			if ($$pmaxpage==0) {
			  my $cmd = "pdfinfo \"$file\"";
		  	my $out = `$cmd 2>/dev/null`;
				$out =~ /(Pages:)(\s+)([0-9]+)/;
				$$pmaxpage = $3;
			}
			my $ext = "pbm";
			$ext = "pgm" if $depth==1;
			$ext = "ppm" if $depth==2;
	  	if (`cat /proc/cpuinfo | grep 'ARM'` ne "") {
		  	$ext = "jpg" if $depth==1 || $depth==2;
			}
		  $opt .= " -jpeg" if $ext eq "jpg";
			my $zeros = getZeros($$pmaxpage);
		  $file2 = $file1."-".sprintf($zeros,$seite).".$ext";
		  my $cmd = "";
			if ($seite==1) {
  	  	#$cmd = "pdftoppm $opt -r 300 -f $seite -l $seite '$file' '$file1'";
				my $found = checkmaxi(2);
				my $file0 = $file1."-in.pdf";
				if (-e "$file" && !-e "$file0") {
					my $res1 = moveFile($file,$file0);
					$file0 = $file if $res1 != 1;
				} else {
					$file0 = $file;
				}
				$cmd = "seq 1 $$pmaxpage | parallel ".
					"--tmpdir /home/data/archivista/tmp -P $found ".
					"pdftoppm $opt -r 300 -f {} -l {} \"$file0\" \"$file1\"";
	    	$res = doit("$cmd 2>/dev/null",1);
				moveFile($file0,$file) if $file0 ne $file;
			}
			logit("$res=>$cmd") if $res != 0;
			my $file3 = getZeroFile($file1,$seite,$ext);
			if (checkFile($file3) && $file2 ne $file3) {
		    unlinkFile($file2) if checkFile($file2);
	  	  moveFile($file3,$file2);
			}
		} else {
		  $file2 = $file; # image files
			$$pmaxpage=1 if $$pmaxpage==0;
		}
	}
	return ($res,$file2);
}



=head1 checkFinished($file)

Check if the file is available

=cut

sub checkFinished {
  my ($file) = @_;
	sleep 1;
  my $line = `ps ax | grep 'pdftoppm'`;
	my @lines = split(/\n/,$line);
	if ($lines[1] ne "") {
	  my $size0 = 0;
		my $size1 = -s $file;
	  for (my $c=1;$c<=10;$c++) {
	    logit("pdftoppm still in work, so wait some seconds, try $c");
	    sleep 3;
      $size0 = -s $file;
			last if $size0==$size1 && $size0>0;
			$size1 = $size0;
		}
	}
}



sub processWebCheckZip {
	my ($pfile,$fnew) = @_;
	my $zip="";
	my $zprg = "/usr/bin/unzip";
  my $zfld = "/home/data/archivista/tmp/zip";
	mkdir $zfld if !-d $zfld;
 	my ($fh,$tempfile) = tempfile(DIR=>$zfld);
	close($fh);
	my $cmd = "$zprg -t $$pfile";
	my $res = doit("$cmd 2>/dev/null >/dev/null",1);
	my @parts = split(/\./,$fnew);
	my $ext = lc(pop @parts);
	if ($res==0 && $ext ne "docx" && $ext ne "xlsx" && $ext ne "pptx" &&
		$ext ne "odg" && $ext ne "odp" && $ext ne "ods" && $ext ne "odt") {
		$res=doit("$zprg -t $$pfile >$tempfile",1);
		#logit("$res=>$zprg -t $$pfile >$tempfile");
		if ($res==0) {
			my $res1 = "";
			readFile2($tempfile,\$res1,1);
			$res1 =~ /(testing:)(.*?)(\[Content_Types\]\.xml)(.*?)(OK)/;
			if ($1 ne "testing:" && $6 ne "OK") {
  		  my $fname = File::Temp->newdir(DIR=>$zfld);
				logit("$fname is zip file");
				$cmd = "$zprg $$pfile -d $fname";
				$res=doit("$cmd 2>/dev/null >/dev/null",1);
				if ($res==0) {
					opendir(DIR,$fname);
				  my @files = readdir(DIR);
					my $pdfnames = "";
		  		closedir(DIR);
					@files = sort @files;
					my $line = "=" x 70;
					my $html = "<html><body>\n";
					$html .= "<p>$line</p>";
					foreach my $file (@files) {
						my $file2 = $file;
						next if $file eq "." || $file eq "..";
						my $file1 = Encode::encode("utf-8", $file);
			     	if ($file ne $file1) {
		  	    	moveFile("$fname/$file","$fname/$file1",1);
							$file=$file1;
						}
						my $info = `file "$fname/$file"`;
						my @infos = split(/\:/,$info);
						$info = pop @infos;
						$info =~ s/^\s//;
						$info =~ s/\s$//;
						$html .= "<p><b>$file2</b>&nbsp;&nbsp;($info)</p>\n";
						my @parts = split(/\./,"$file");
						my $ext = lc(pop @parts);
						$pdfnames .= "\"$fname/$file\" " if $ext eq "pdf";
					}
					$pdfnames .= "\"$fname.toc\"";
					$html .= "<p>$line</p>";
					$html .= "</body></html>\n";
					writeFile("$fname.htm",\$html);
					my $htmldoc = 'htmldoc --size a4 --format pdf14 '.
  		                      '--continuous --no-embedfonts ';
	    		$res = doit("$htmldoc $fname.htm --outfile $fname.toc");
					if ($res==0) {
						$res = doit("pdftk $pdfnames output $fname.pdf");
					}
					if ($res==0) {
						$zip = "$fname.pdf";
						logit("pdf form zip is: $fname.pdf");
					}
				}
				doit("rm -Rf $fname",1);
				doit("rm -Rf $fname.htm",1);
				doit("rm -Rf $fname.toc",1);
			}
		}
	}
	return $zip;
}



=head1 $format=processWebFormat($file)

Give back the current format ("" if no format found)

=cut

sub processWebFormat {
  my $pfile = shift;
	my $psource = shift;
	my $pval = shift;
	my $scanname = shift;
	my $depth = shift;
	my $pofficeimages = shift;
	my $fnew = $$pval{webfile};
	my $zip = processWebCheckZip($pfile,$fnew);
	my $format = "";
	my $office = 0;
	my $image = 0;
	if ($zip ne "") {
		my @parts=split(/\./,$zip);
		pop @parts;
		push @parts,"zip";
		my $zip1 = join('.',@parts);
		my ($fin1,$path,$base1) = CheckFileNamePathBase($fnew);
		my $res=doit("chown archivista.users '$$pfile'",1);
  	$res=moveFile($$pfile,$fin1) if notFile($fin1);
		$$pfile=$fin1 if $res==1;
		my $cmd = "zip -q -j '$zip1' '$$pfile' 0>/dev/null 2>/dev/null";
		$res = doit($cmd,1);
		if ($res==0) {
			unlinkFile($$pfile);
			$$psource=$zip1;
			$$pfile=$zip;
			$format=PDF;
		}
	} else {
		my $rfc = `file \"$$pfile\"`;
		logit("file ".$$pfile." is $rfc");
		my $pos = index($rfc,": RFC 822 mail");
		$pos = index($rfc,": news or mail") if $pos==-1;
		if ($pos==-1) {
			my $msg2 = "Composite Document File V2 Document, No summary info";
			$pos = index($rfc,": $msg2");
			if ($pos==-1) {
				my $msg2 = "CDFV2 Microsoft Outlook Message";
				$pos = index($rfc,": $msg2");
			}
			if ($pos>0 && $pos<200) {
				$pos=-1;
				my $file1 = $$pfile.'.eml';
				my $cmd = "/usr/bin/msgconvert $$pfile --mbox $file1";
				my $res=doit($cmd,1);
				if ($res==0) {
					if (-e "$file1") {
						if (-e "$$pfile") {
							unlink "$$pfile";
							$$pfile=$file1;
							$pos=1;
						} else {
							unlink "$file1";
						}
					}
				}
			}
		}
		if ($pos==-1) {
			my $msg2 = "SMTP mail, ASCII";
			$pos = index($rfc,": $msg2");
		}
		if ($pos>0 && $pos <200) {
			# it is a mail
			$format=MAIL;
		} else {
			$pos = index($rfc,": MPEG sequence");
			$format = MPG if $pos>=0 && $format eq "";
			$pos = index($rfc,": ISO Media, MPEG");
			$format = MPG if $pos>=0 && $format eq "";
			$pos = index($rfc,": Macromedia Flash Video");
			$format = FLV if $pos>=0 && $format eq "";
			$pos = index($rfc,": ISO Media, MP4") if $pos==-1;
			$format = MP4 if $pos>=0 && $format eq "";
			$pos = index($rfc,": ISO Media") if $pos==-1;
			$format = MP4 if $pos>=0 && $format eq "";
			$pos = index($rfc,": WebM") if $pos==-1;
			$format = AV1 if $pos>=0 && $format eq "";
			$pos=index($rfc,": RIFF (little-endian) data, AVI") if $pos==-1;
			if ($pos>0 && $format eq "") {
				my $pos1=index($rfc,"video");
				if ($pos1>0) {
					$format=AVI;
				} else {
					$format=WAV;
				}
			}
			$pos=index($rfc,": Matroska data") if $pos==-1;
			$format = MKV if $pos>=0 && $format eq "";
			$pos = index($rfc,": Ogg data, Vorbis audio") if $pos==-1;
			$format = OGG if $pos>=0 && $format eq "";
			$pos = index($rfc,": Ogg data, Theora") if $pos==-1;
			$format = OGG if $pos>=0 && $format eq "";
			$pos=index($rfc,": RIFF (little-endian) data, WAVE audio") if $pos==-1;
			$format = WAV if $pos>=0 && $format eq "";
			$pos = index($rfc,": MPEG ADTS, layer") if $pos==-1;
			$format = MP3 if $pos>=0 && $format eq "";
			$pos = index($rfc,": Audio file with ID3") if $pos==-1;
			$format = MP3 if $pos>=0 && $format eq "";
			if (`uname -r`>5) {
				$pos = index($rfc,": TIFF image data,");
				$pos = index($rfc,"bps=16") if $pos>0;
				if ($pos>0) {
					$pos = processWebFormatRaw($pfile,$psource,$fnew,\$format,
						\$image,$pofficeimages);
				}
			}
			$pos = index($rfc,": data") if $pos==-1;
			$format = DATA if $pos>=0 && $format eq "";
			if ($format eq DATA) {
				my $res=`ffprobe -v error -show_format \"$$pfile\"`;
				$format = MPG if index($res,"format_name=mpegts")>0;
			}
			if ($format eq "") {
				my $identify = "pdfinfo '$$pfile'";
				my $cmdinfo = `$identify 2>/dev/null`;
				$format = PDF if $cmdinfo =~ 'PDF version';
				if ($format eq "" || $format eq PDF) {
					if ($format ne PDF) {
	  		  	$identify = "identify -ping $$pfile";
		  	  	my $cmdinfo = `$identify 2>/dev/null`;
				  	my @infos = split(" ",$cmdinfo);
					  my $format1 = $infos[1];
						if ($format1 ne PNM && $format1 ne PNG && $format1 ne TIF &&
		    			$format1 ne JPEG && $format1 ne GIF && $format1 ne BMP &&
				  		$format1 ne TIFF && $format1 ne BMP3) {
							$office=1;
						} else {
				  		$format=$format1; # we accept a bitmap page
							$image=1;
						}
					}
				}
			}
  		doit("chown archivista.users '$$pfile'",1);
		  doit("chmod a+rwx $$pval{tmp}",1);
			processWebPrepare($pfile,$psource,\$format,$fnew,$image,
				$office,$depth,$pval);
		}
	}
	return ($format,$image,$office);
}



sub processWebFormatRaw {
	my ($pfile,$psource,$fnew,$pformat,$pimage,$pofficeimages) = @_;
	my $pos=-1;
	logit("$$pfile is probably a raw file, check if not tiff");
	my $notif=`identify -ping $$pfile 2>/dev/null`;
	if ($notif eq "") {
		logit("$$pfile ($fnew) is a RAW file");
		my @parts = split(/\./,$$pfile);
		pop @parts;
		my $base = join('.',@parts);
		@parts = split(/\./,$fnew);
		my $ext = pop @parts;
		$$psource = "$base.$ext";
		if (!-e "$$psource") {
			my $res = 0;
			my $ok = moveFile($$pfile,$$psource,1);
			$res=-1 if $ok!=1;
			if ($res==0) {
				$$pfile = "$base.jpg";
				my $cmd =  "darktable-cli $$psource $$pfile";
				$res=doit($cmd);
				if ($res==0) {
					$$pformat = JPEG;
					$$pimage = 1;
					$$pofficeimages=1;
					$pos=1;
				}
			}
		}
	}
	$$psource="" if $pos==-1;
	return $pos;
}



=head processWebPrepare($pfile,$psource,$pfor,$fout,$image,$off,$depth,$pval)

Prepare a document to process (create image/pdf or easy file, check source)

=cut

sub processWebPrepare {
  my ($pfile,$psource,$pformat,$fnew,$image,$office,$depth,$pval) = @_;
	my @parts = split(/\./,$$pfile);
	pop @parts; # remove extension
	my $base = join('.',@parts);
	my $fin2 = "";
	my $res = -1;
	my ($fin1,$path,$base1) = CheckFileNamePathBase($fnew);
	if ($$pformat eq MP3 || $$pformat eq OGG || $$pformat eq WAV) {
		$res = prepareSound($pfile,$base,$$pformat,1);
		if ($res!=0 && $$pformat eq WAV && !-e "$base.mp3") {
			my $cmd = "lame $$pfile $base.mp3";
			$res=doit($cmd);
			$res = prepareSound(\"$base.mp3",$base,MP3,0);
			unlink "$base.mp3" if -e "$base.mp3";
		}
		processWebPrepareMove($pfile,$path,$fnew);
		$$psource=$$pfile;
	} elsif ($$pformat eq MP4 || $$pformat eq MPG || $$pformat eq AV1 ||
		$$pformat eq MKV || $$pformat eq AVI || $$pformat eq FLV) {
		$res = prepareVideo($$pfile,$base,$pval);
		processWebPrepareMove($pfile,$path,$fnew);
		$$psource=$$pfile;
	} else {
		processWebPrepareMove($pfile,$path,$fnew);
		my $fzip = $$pfile; # the original file goes to be zipped
		if ($office==1) {
			my $tpfad = "/home/data/archivista/tmp";
			my $check = `file \"$$pfile\" 2>/dev/null`;
			if (index($check,": HTML document,")>0) {
				$fin2=HTMLtoPDF($$pfile,$tpfad);
			}
			if (checkFile($fin2)) {
				$ENV{AV_OCRTXT}=HTMLtoText($$pfile,$tpfad);
				$$pformat=PDF;
			} else {
				($res,$$pfile,$fin2)=OpenOfficeConvert($$pfile,$path,$base1);
				$$pformat=PDF if $res==0;
			}
		} else {
	  	$fin2=$$pfile; # this file is for image processing (pdf/images)
		}
		if (checkFile($fin2)) {
	  	my $fin3 = "$base\.zip";
		  unlinkFile($fin3) if checkFile($fin3);
			if (($$pformat eq JPEG && $depth==2) || $$pformat eq DATA) {
				$res = 0; # don't zip, native JPEG format OR unknown data file
			} else {
				my $cmd="zip -q -j \"$fin3\" \"$fzip\" 0>/dev/null 2>/dev/null";
				$res = doit($cmd);
				if ($res==0 && $office==1) {
		  		unlinkFile($$pfile) if checkFile($$pfile);
				}
 				$$pfile = $fin2;
				$$psource = $fin3;
			}
		} else {
			$res=-1; # there is no file available
		}
	}
	if ($res!=0) {
		my $fin = $$pfile;
		my $res = `file \"$fin\"`;
		if (index($res,"Security: 1")>0) {
			my $enc = "/home/data/archivista/ftp/temp/bad";
			if (!-d "$enc") {
				mkdir "$enc";
				doit("chown -Rf ftp.users \"$enc\"",1);
			}
			logit("$fnew is encrypted, move it to $enc");
			my @parts = split(/\./,$fnew);
			my $ext = pop @parts;
			my $base = join('.',@parts);
			my $fout = "$enc\/".$fnew;
			my $c=0;
			while (-e "$fout") {
				logit("$fout already exists, add extension $ext");
				$fout .= ".$ext";
				$c++;
				last if $c>10;
			}
			moveFile($fin,$fout,1);
			doit("chown ftp.users \"$fout\"",1);
		} else {
		  unlinkFile($fin) if checkFile($fin);
		}
	}
}

sub processWebPrepareMove {
	my ($pfile,$path,$fnew) = @_;
	my $move=0;
	if (-e "$path$fnew") {
		logit("$fnew is already in temp folder, so try to add number at end");
		my (@parts) = split(/\./,$fnew);
		my $ext = pop @parts;
		my $base = join('.',@parts);
		if ($base eq "") {
			$base=$ext;
			$ext="";
		}
		for (my $c=1;$c<20;$c++) {
			$fnew = "$base$c.$ext";
			last if !-e "$path$fnew";
			logit("$fnew does already exist, so go to next counter");
		}
	}
 	if (notFile("$path$fnew")) {
    $move=moveFile("$$pfile","$path$fnew");
		logit("moving from $$pfile to $path$fnew=>result:$move");
		$$pfile="$path$fnew" if $move==1;
	}
	return $move;
}



sub prepareSound {
	my ($pfile,$base,$format,$move) = @_;
	my $res=-1;
	my $coverimage=0;
	if (`uname -r`>5) {
		my $fsound = $$pfile;
		if (-e "$fsound") {
			if ($move==1) {
				$fsound = "$base.$format";
				unlink $fsound if -e $fsound;
				moveFile($$pfile,$fsound,1);
			}
			my $cmd = "ffprobe $fsound 2>&1 | grep 'Cover'";
			my $cover = `$cmd`;
			if ($cover ne "") {
				$cmd = FFMPEG." -i $fsound $base-1.jpg 2>/dev/null";
				$res=doit($cmd);
				if ($res==0) {
					if (-e "$base-1.jpg") {
						$ENV{AV_COVER}=1;
						$coverimage=1;
					} else {
						$res=-1;
					}
				}
			}
			if ($coverimage==0) {
				my $cmd = "ffprobe -v error -show_format -show_streams $fsound ".
					"| grep 'duration=' | awk -F'=' '{ print \$2 }'";
				my $length = int `$cmd`;
				chomp $length;
				$length = $length+34;
				my $length0 = 192;
				$length0=$length if $length<$length0;
				$length0=$length0*10;
				$length0=810 if $length0>810; # don't generate too long images
				my $only="$base"."_only";
				$cmd = "sox $fsound -r 1000 $base.dat";
				$res=doit($cmd);
				$res=doit("tail -n+3 $base.dat > $only.dat") if $res==0;
				$res=doit("echo set term png size $length0,270 > $base.gpi") if $res==0;				$res=doit("echo set output \\\"$base.png\\\" >> $base.gpi") if $res==0;
				$res=doit("echo set border 0 >> $base.gpi") if $res==0;
				$res=doit("echo unset ytics >> $base.gpi") if $res==0;
				$res=doit("echo unset xtics >> $base.gpi") if $res==0;
				my $cmd2="echo plot \\\"$only.dat\\\" ".
					"using 1:2 notitle \\\"\\\" with linespoints ". # points, no lines
					"ls -1 lw 1 lc \\\"#adb9ff\\\"". # default, add width 1 and color
					">> $base.gpi";
				$res=doit($cmd2) if $res==0;
				$res=doit("gnuplot $base.gpi") if $res==0;
				$res=doit("econvert -i $base.png -o $base-1.jpg") if $res==0;
				doit("rm -f $base.dat",1) if -e "$base.dat";
				doit("rm -f $only.dat",1) if -e "$only.dat";
				doit("rm -f $base.gpi",1) if -e "$base.gpi";
				doit("rm -f $base.png",1) if -e "$base.png";
			}
			if ($move==1) {
				moveFile($fsound,$$pfile,1);
			}
		}
	}
	return $res;
}

sub prepareVideo {
	my ($fin,$base,$pval) = @_;
	my $res = -1;
	if (`uname -r`>5) {
		my $size = -s $fin;
		my $maxsize = 64*1024*1024*1024; # maximum of 64 gb
		logit("size of $fin is $size");
		my $cmd = FFMPEG." -i $fin 2>&1 |".
			qq[grep "Duration"| cut -d ' ' -f 4 | sed s/,//];
		my $rest=`$cmd`;
		chomp $rest;
		my @parts = split(/:/,$rest);
		my $secs = pop @parts;
		my $min = pop @parts;
		my $hour = pop @parts;
		my $day = pop @parts;
		$secs = $secs+($min*60)+($hour*3600)+($day*86400);
		logit("file $fin has time length: $secs");
		if ($size<=$maxsize) {
		  my $cmd2 = "ffprobe -v error -select_streams v:0 ".
        "-show_entries stream=width,height -of csv=s=x:p=0 $fin";
      my $resxy = `$cmd2`;
			my ($resx,$resy) = split('x',$resxy);
			if ($resy<$resx) {
				$resxy = "1920x1080" if $resx<1980;
				$resxy = "1920x1080" if $resy<1080;
			} else {
				$resxy = "1080x1920" if $resx<1080;
				$resxy = "1080x1920" if $resy<1920;
			}
			chomp $resxy;
			my $step=600; # over 20 hours, all 20 minutes (>120 images)
			if ($secs<60) { # every second (1-60 images)
				$step=1;
			} elsif ($secs<300) { # 1-5 minutes, all 2 seconds (30-150 images)
				$step=2;
			} elsif ($secs<1200) { # 5-20 minutes, all 5 seconds (60-240 images)
				$step=5;
			} elsif ($secs<3600) { # 20-60 minutes, all 15 seconds (80-240 images)
				$step=15;
			} elsif ($secs<7200) { # 1-2 hours, all 30 seconds (120-240 images)
				$step=30;
			} elsif ($secs<14400) { # 2-4 hours, every minute (120-240 images)
				$step=60;
			} elsif ($secs<28800) { # 4-8 hours, all 2 minutes (120-240 images)
				$step=120;
			} elsif ($secs<72000) { # 8-20 hours, all 4 minutes (120-300 images)
				$step=240;
			}
			my $found=checkmaxi(8);
			if ($secs<2) { # file very short, so only get one image
				$cmd2 = FFMPEG." -t 0 ".
					"-i $fin -vframes 1 -s $resxy $base-1.jpg 2>/dev/null";
				$res=doit($cmd2);
			} else {
				$cmd2 = "seq 1 $step $secs | parallel ".
					"--tmpdir /home/data/archivista/tmp -P $found ".FFMPEG." -ss {} ".
					"-i $fin -vframes 1 -s $resxy $base-{}.jpg 2>/dev/null";
				my $slow = $cmd2;
				if ($$pval{offturbo}==0) { # options for fast processing
					$cmd2 = "seq 1 $step $secs | parallel ".
						"--tmpdir /home/data/archivista/tmp -P $found ".
						FFMPEG." -ss {} -skip_frame nokey -vsync vfr -i $fin ".
						"-vframes 1 -s $resxy $base-{}.jpg 2>/dev/null";
				}
				$res=doit($cmd2);
				$res=doit($slow) if !-e "$base-1.jpg"; # file too short, slow handling
				if (-e "$base-1.jpg") { # first image is here, so we accept it
					if ($res>0) { # error from calling (some images not available)
						logit("Warning: error $res reported, not all images processed");
						$res=0; # there is at least one image, so we let it through
					}
					if ($step>1) { # not all seconds are taken, so rename files
						my $c1=2;
						my $secs2 = int $secs;
						for (my $c=1;$c<=$secs2;$c+=$step) {
							if ($c>$c1 && -e "$base-$c.jpg") { # start at 2, check for file
								moveFile("$base-$c.jpg","$base-$c1.jpg",1);
								$c1++;
							}
						}
					}
				}
			}
		} else {
			logit("$fin with $size over maxsize $maxsize");
		}
	}
	return $res;
}



sub doit {
	my ($cmd2,$nolog) = @_;
	my $res=system($cmd2);
	logit("$res=>$cmd2") if $nolog==0;
	return $res;
}
