#!/usr/bin/perl

use strict;
use lib qw(/home/cvs/archivista/jobs);
use AVJobs;
use Encode;

my $db = shift;
my $akte = shift;
my $copyit=0;
my $archfolders="";
my $voskpath = "/home/data/vosk";
my $voskprg = "$voskpath/vosk2txt.py";
my $voskpy = "$voskpath/python3.9/bin/python3.9";
my $fout = "/tmp/vosk-$db-$akte.tmp";
my $fout2 = "/tmp/vosk-$db-$akte.txt";
unlink $fout if -e $fout;
unlink $fout2 if -e $fout2;
if (!-e $voskprg) {
	logit("please install vosk package for $db ($akte)");
	exit 0;
}
my $dbh = MySQLOpen();
if ($dbh) {
  if (HostIsSlave($dbh)==0) {
		my $sql = "use $db";
		$dbh->do($sql);
		$sql = "select Laufnummer,Seiten,Archiviert,Ordner,EDVName from ".
			"archiv where Laufnummer=$akte";
		my @row = $dbh->selectrow_array($sql);
		if ($row[0]==$akte) {
			my $seiten = $row[1];
			my $arch = $row[2];
			my $ordner = $row[3];
			my $edvname = $row[4];
			my $file = "";
			my ($type,$name,$ext) = splitEDVName($edvname);
			if ($type eq "multi") {
				$file = isSourceExternal($db,$akte,$type,$ext) if $type eq "multi";
				if ($file eq "") {
					$copyit=1;;
					$file = exportDbToDisk($dbh,$db,$type,$akte,$seiten,
						$ordner,$arch,$archfolders);
				}
			  my $snr = ($akte*1000)+1;
  			my $sql = "select OCR from $db.archivseiten where Seite=$snr";
				my @res = $dbh->selectrow_array($sql);
				my $lang = $res[0];
				my ($lang1,$detect,$clean,$tables) = 
					OCRDoOpenSourceLang($dbh,$db,$dbh,"",$lang);
				my @langs = split(/\,/,$lang1);
				my $lang2 = $langs[0];
				$lang2 = "English" if $lang2 eq "";
				$lang2 = lc($lang2);
				if (-e "$file") {
					my $cmd = "cd $voskpath;$voskpy $voskprg $lang2 $file >$fout";
					logit("vosk for $db ($akte) started with $lang2 and $file");
					my $res=system($cmd);
					logit("$res=$cmd");
					if ($res==0 && -e $fout) {
						$cmd = "/usr/bin/perl $voskpath/vosk2txt.pl $fout >$fout2";
						$res=system($cmd);
					}
					if ($res==0 && -e $fout2) {
						logit("vosk success for $db ($akte)");
						my $cmd = "ffprobe -v error -show_format -show_streams $file ".
							"| grep 'duration=' | awk -F'=' '{ print \$2 }'";
						my $length = `$cmd`;
						my @lines = split(/\n/,$length);
						foreach my $line (@lines) {
							$length = int $line;
							if ($length>0) {
								chomp $length;
								last;
							}
						}
						my $step = (int(($length/$seiten)*10))/10;
						logit("vosk success with length:$length/$step for $db ($akte)");
						my $ocr = "";
						readFile2($fout2,\$ocr);
						@lines = split(/\r\n/,$ocr);
						my $out = "";
						my @pages = ();
						foreach my $line (@lines) {
							my @parts = split(/:/,$line);
							my $time = shift @parts;
							my $text = join(':',@parts);
							my $curpage = int(int((($time/$step)*10)+1)/10);
							$curpage=1 if $curpage<1;
							$curpage=$seiten if $curpage>$seiten;
							$pages[$curpage] .= "$time: $text\n";
						}
						my $seite = 0;
						foreach my $page (@pages) {
							if ($page ne "") {
								$page = fromUTF8($page);
								my $snr = ($akte*1000)+$seite;
								my $sql = "select Seite,Text from ".
									"$db.archivseiten where Seite=$snr";
								my @row = $dbh->selectrow_array($sql);
								my $pagenr = $row[0];
								my $pageold = "";
								$pageold=$row[1] if $row[1] ne "";
								my $speech = "                    -----speech recognition-----";
								if ($pagenr==$snr) {
									$pageold =~ /(.*^)($speech)(.*$)/s;
									$pageold = $1 if $2 eq $speech && $3 ne "";
									$pageold = "$pageold$speech\n\n$page";
									$sql = "update $db.archivseiten set Text=".
										$dbh->quote($pageold)." where Seite=$snr";
								} else {
									$pageold = "$pageold$speech$page";
									$sql = "insert into $db.archivseiten set ".
										"Text=".$dbh->quote($pageold).",OCR=0,Erfasst=1,".
										"Ausschliessen=0,Seite=$snr";
								}
								$dbh->do($sql);
							}
							$seite++;
						}
					}
				}
			}
			unlink $file if $copyit==1 && -e $file;
			unlink $fout if -e $fout;
			unlink $fout2 if -e $fout2;
		}
	}
}

