
package PL::HTML;
use PL::LoginForm;
use PL::UserAdministration;
use PL::FieldDefinition;
use PL::MaskDefinition;
use PL::Form;
use PL::DatabaseAdministration;
use PL::PublishAdministration;
use PL::ScanDefAdministration;
use PL::BarcodeSettings;
use PL::BarcodeProcessing;
use PL::OCRDefAdministration;
use PL::SQLDefinition;
use constant SPACE => "\r\n";
use strict;

sub _borderTable {
  my ($self) = @_;
  my $class = "TableBorder";
	my $cellpadding = 1;
	my $cgiO = $self->cgi;
  if ($cgiO->param("admdb") == 1) {
		$class = "TableAdminDbBorder";
		$cellpadding = 4;
	}
	my $html = $self->_headerTable();
	return $html;
}

sub _headerTable {
	my ($self) = @_;
	my $cgiO = $self->cgi;	
	my $www = $self->config->get("WWW_DIR");
	my $html = SPACE.$cgiO->start_table({-border => 0,-cellpadding => 0,
		  -cellspacing => 0}).
	  $cgiO->Tr($cgiO->td({-height => 53,-colspan => 2,
			-background => $www.'/img/login_header.png'})).
	  $cgiO->Tr($cgiO->td($self->_loginTable())).
	  $cgiO->end_table.SPACE;
	return $html;
}

sub _loginTable {
  my ($self) = @_;
	my $cgiO = $self->cgi;
	my $www = $self->config->get("WWW_DIR");
	my $html = SPACE.$cgiO->start_table({-border=>0,-cellpadding=>0,
	    -cellspacing=>0}).
    $cgiO->Tr($cgiO->td({-width=>248,-height=>334,
			-background=>$www.'/img/login_left.png'}),
    $cgiO->td({-align=>'center',-valign=>'center',
			-class=>'LoginMask',-width=>500,-height=>334},
			  $self->_loginFormTable())).$cgiO->end_table.SPACE;
  return $html;
}

sub _loginFormTable {
	my ($self) = @_;
	my $cgiO = $self->cgi;
  my $configO	= $self->config;
	my $title = $configO->get("TITLE");
	my $version = `/bin/cat /usr/share/pve-manager/root/vm/version.txt`;
	my $html = SPACE.$cgiO->start_table({-border=>0,-cellspacing=>0,
		-cellpadding=>0,-width=>'100%'}).
		$cgiO->Tr($cgiO->td({-height=>30},'&nbsp;')).
		$cgiO->Tr($cgiO->td({-align=>'right',-class=>'Title'},$title)).
  	$cgiO->Tr($cgiO->td({-align=>'right',-class=>'Subtitle'},
			"Version $version - Powered by",
		$cgiO->a({-href=>'http://www.archivista.ch',-target=>'blank'},
			'Archivista GmbH'))).
  	$cgiO->Tr($cgiO->td({-height=>'40',-colspan=>2},'&nbsp;')).
 		$cgiO->Tr($cgiO->td({-align=>'center',-class=>'LoginMask'},
			$self->_loginForm)).$cgiO->end_table.SPACE;
  return $html;
}

sub _loginForm {
  my ($self) = @_;
	my $frmFieldSize = 20;
	my $frmTdHeight = 22;
	my $layout = "";
	$layout = `cat /etc/lang.conf` if -e "/etc/lang.conf";
	chomp($layout);
	if ($layout eq "") {
		my $kb = lc(keyboard_default());
		$layout = "de" if index($kb,"de")>=0;
		$layout = "fr" if index($kb,"fr")>=0;
		$layout = "it" if index($kb,"it")>=0;
		$layout = "de" if $kb eq "ch";
		$layout = "en" if $layout eq "";
	}
  use lib qw(/home/cvs/archivista/jobs);
  use AVStrings;
	my $str = AVStrings->new($layout);
	my $pw1 = $str->string("web_pwd");
	my $host1 = $str->string("web_host");
	my $db1 = $str->string("web_db");
	my $user1 = $str->string("web_uid");
	my $login1 = $str->string("web_login");
	my $lang1 = $str->string("web_lang");
	my $err1 = $self->{'error'};
	$err1 = $str->string("web_error_login") if  $err1 eq "Error on login!";
	my $cgiO = $self->cgi;
	my $admdb = 0;
	my $loginFrm = PL::LoginForm->new;
  my ($adminDatabases,$submitButton,$chooseLanguage,%langs);
  # Pointer to array of all archivista archives (method called from APCL)
	my $parchives = $loginFrm->archives;
  # Add a null elment at the top
	unshift @$parchives, "";
	my $archives = $cgiO->popup_menu(-name => 'archive',
		-values => $parchives);
	# This are the configured languages
	$langs{'de'} = "Deutsch";
	$langs{'en'} = "English";
	$langs{'fr'} = "Franais";
	$langs{'it'} = "Italiano";
	my @langs = keys %langs;
  my $langSelect = $cgiO->popup_menu(-name => 'lang',
		-values => \@langs,-default => $layout,-labels => \%langs);
	if (defined $cgiO->param("admdb")) {
		$admdb = $cgiO->param("admdb");
	}
	my $displayHostField = $self->config->get("LOGIN_DISPLAY_HOST");
  my $host = $cgiO->param('host');
	my $db = $cgiO->param('db');
	my $uid = $cgiO->param('uid');
	# Display admin databases (create/from)
	if ($admdb == 1) {
	  $uid = "root";
		$adminDatabases =	
		  $cgiO->Tr(
			  $cgiO->td({-height=>$frmTdHeight,-align=>'left'},"Options"),
			  $cgiO->td({-align=>'right'},$cgiO->radio_group(-name=>'options',
					-values=>['create','drop'],-default=>'create',-override=>1,
					-class=>'NoBorder'))
				).SPACE.
			$cgiO->Tr(
			  $cgiO->td({-height=>$frmTdHeight,-align=>'left'},"Settings from"),
				$cgiO->td({-align=>'right'},$archives)).SPACE;
		$submitButton =	
		  $cgiO->Tr(
		    $cgiO->td({-colspan=>'2',-align=>'right'},
			  $cgiO->submit(-name=>'submit',-value=>"Execute"))
			).SPACE;
	} else {
		$host = $self->config->get("DEFAULT_LOGIN_HOST") if (length($host) == 0);
		if (!-e "/etc/cloudsingleuser.conf") {
	    $db = $self->config->get("DEFAULT_LOGIN_DB") if (length($db) == 0);
	    $uid = $self->config->get("DEFAULT_LOGIN_USER");
		}
		$chooseLanguage = $cgiO->Tr(
			$cgiO->td({-height => $frmTdHeight,-align => 'left'},$lang1),
			$cgiO->td({-align=>'right'},$langSelect)
		);
		$submitButton =	$cgiO->Tr(
		  $cgiO->td({-colspan => 2,-align => 'right'},
			  $cgiO->submit(-name => 'submit',-value => $login1))
		).SPACE;
	}
	my $html = SPACE.$cgiO->start_form().
	$cgiO->hidden({-name => 'admdb',-value => 0,-override => 1}).
  $cgiO->hidden({-name => 'ua', -value => 1}).
	SPACE.$cgiO->start_table({-border => 0,-cellspacing => 0,-cellpadding => 0,
		-width => '350'});
	if ($displayHostField == 1) {
		$html .= $cgiO->Tr(
		  $cgiO->td({-height => $frmTdHeight,-align => 'left'},$host1),
      $cgiO->td({-align => 'right'},$cgiO->textfield(-size => $frmFieldSize,
				-name => 'host',-value => $host,-override => 1))
		).SPACE;
	} else {
		$host = 'localhost' if (length($host) == 0);
		$html .= $cgiO->hidden({-name => 'host', -value => $host, -override => 1});
	}
	$html .= 
	  $cgiO->Tr(
	    $cgiO->td({-height => $frmTdHeight,-align => 'left'},$db1),
		  $cgiO->td({-align=>'right'},
	    $cgiO->textfield(-size => $frmFieldSize,-name => 'db',
			  -value => $db,-override => 1))
	    ).SPACE.
 	  $cgiO->Tr(
		  $cgiO->td({-height => $frmTdHeight,-align => 'left'},$user1),
	  	$cgiO->td({-align=>'right'},$cgiO->textfield(-size => $frmFieldSize,
				-name => 'uid',-value => $uid, -override => 1))).
			$cgiO->Tr($cgiO->td({-height => $frmTdHeight,-align => 'left'},$pw1),
			$cgiO->td({-align=>'right'},$cgiO->password_field(-size => $frmFieldSize,
				-name => 'pwd',-override => 1))
			).SPACE.
	  $adminDatabases.$chooseLanguage.$cgiO->Tr($cgiO->td('&nbsp;')).SPACE.
    $submitButton.
    $cgiO->Tr($cgiO->td({-height => 30,-align => 'right',-colspan => 2,
			-class => 'Error'},'&nbsp;'.$err1)).SPACE.
		$cgiO->end_table.SPACE.$cgiO->end_form.SPACE;
  return $html;
}

sub keyboard_default {
	my $layout = "us";
	my $fkey = "/home/archivista/.xkb-layout";
	if (`uname -r`>5) {
		$fkey = "/home/data/archivista/cust/desktop/keycode";
		if (-e "$fkey") {
			$layout = `cat $fkey` if -e "$fkey";
		} else {
			$layout = "ch" if `cat /proc/cmdline | grep 'lang'` eq "";
		}
	} elsif (-e "$fkey") {
		$layout=`cat /home/archivista/.xkb-layout`;
	}
	chomp($layout);
	return $layout;
}

sub _menuItem {
  my ($self,$menuItem) = @_; # Object Archivista::Application::Menu::MenuItem
	my $cgiO = $self->cgi;
  my $perl = $self->config->get("PERL_DIR");
  my $param = $menuItem->param;
	my $label = $menuItem->label;
	my $relativeLevel = $menuItem->relativeLevel;
	my $absoluteLevel = $menuItem->absoluteLevel;
  my $tdClass = "MenuItem";
	my $tdClassLabel = "MenuItem$relativeLevel";
  $param .= "&level=$absoluteLevel";
	return $cgiO->Tr(
	  $cgiO->td({-class => $tdClass},"&rsaquo;"),
		$cgiO->td({-class => $tdClassLabel},
		  $cgiO->a({-href => "$perl/index.pl?$param",-class => 'Menu'},$label)));
}

sub _menuItems {
  my ($self) = @_;
	my $cgiO = $self->cgi;
	my $archiveO = $self->archive;
	my $langO = $self->archive->lang;
	my $level = $cgiO->param("level");
	my $applicationId = $self->config->get("APPLICATION_ID");
	my $menuO = $archiveO->application($applicationId)->menu($level);
	my $db = $cgiO->param('db');
	my $menuItems = $cgiO->start_table;
  $menuItems .= $cgiO->Tr($cgiO->td({-height=>15},"&nbsp;"));
	while (my $menuItem = $menuO->nextItem) {
	  # $menuItem is on object of Archivista::Application::Menu::MenuItem!
		$menuItems .= $self->_menuItem($menuItem).SPACE;
	}
  $menuItems .= $cgiO->end_table.SPACE;
  return $menuItems;
}

sub _menu { 
  my ($self) = @_;
	my $cgiO = $self->cgi;
	my $www = $self->config->get("WWW_DIR");
  return SPACE.$cgiO->start_table({-border=>0,-cellpadding=>0,
			-cellspacing=>0}).
		$cgiO->Tr($cgiO->td({-valign=>'top',-width=>249,-height=>500,
			-background=>$www.'/img/menu_main.png'},$self->_menuItems)).
		$cgiO->end_table.SPACE;
}

sub _header { 
  my ($self) = @_;
	my $cgiO = $self->cgi;
	my $www = $self->config->get("WWW_DIR");
  my $html = $cgiO->start_table({-border=>0,-cellpadding=>0,
			-cellspacing=>0,-width=>'100%'}).
		$cgiO->Tr($cgiO->td({-height=>53,-background=>$www.'/img/header1.png',
			-width=>'249'},"&nbsp;"). 
		$cgiO->td({-height=>53,-background=>$www.'/img/header2.png'},"&nbsp;")).
	$cgiO->end_table;
	$self->{'html'}.=$html;
}

sub _main {
  my ($self) = @_;
	return $self->{'main'};
}

sub _formTitle {
  my ($self,$title) = @_;
	my $cgiO = $self->cgi;
	$title .= " @ ".$self->archive->session->db;	
	$self->{'main'} .= $cgiO->div({-class => 'FormTitle'},$title);
}

sub _fieldTypeToHtml {
  my ($self,$name,$type,$fieldValue,$pafieldValues,$phfieldValues) = @_;
	my $cgiO = $self->cgi;
  my $field;
	if ($type eq "textfield") {
		$field = $cgiO->textfield(-name=>$name,-value=>$fieldValue,-override=>1,
			-style => 'width: 400px');
	} elsif ($type eq "password") {
    $field = $cgiO->password_field(-name=>$name,-override=>1);
	} elsif ($type eq "select") {
		$field = $cgiO->popup_menu(-name=>$name,-values=>$pafieldValues,
			-default=>$fieldValue,-labels=>$phfieldValues,-override=>1);
	} elsif ($type eq "checkbox") {
		$field = $cgiO->checkbox(-name=>$name,-checked=>$fieldValue,-value=>1,
			-label=>'',-override=>1,-class=>'NoBorder');
	} elsif ($type eq "textarea") {
		$field = $cgiO->textarea(-name=>$name,-value=>$fieldValue,-override=>1);
	}
	return $field;
}

sub _displaySelectionForm {
  my ($self,$pselection,$admin) = @_;
	my $tdWidth = 150;
	my $tdHeight = 20;
  my $cgiO = $self->cgi;
	my $langO = $self->archive->lang;
  my $langCode = $langO->code;
  my $level = $cgiO->param("level");
	my $label = $$pselection{'label'};
  my $fieldName = $$pselection{'field_name'};
	my $pafieldValues = $$pselection{'array_values'};
	my $phfieldValues = $$pselection{'hash_values'};
	my $fieldValue = $$pselection{'value'};
	my $selected = $$phfieldValues{$fieldValue};
	my $newSelectionValue = $$pselection{'new_selection_value'};
  my $deleteButton;
	if ($$pselection{'display_delete'} == 1) {
		$deleteButton =	$cgiO->submit(-name=>'submit',
			-value=>$langO->string("DELETE"),
			-onClick=>"return askForDeletion('$langCode')",
			-style=>'width: 100%');
	}
	my $select = $cgiO->popup_menu(-name=>$fieldName,-values=>$pafieldValues,
		-default=>$fieldValue,-labels=>$phfieldValues,-override=>1,
	  -style=>'width: 100%');
	my $h = $cgiO->start_table({-border=>0});
	# Select element
	$h .= SPACE.SPACE.$cgiO->start_form.SPACE;
	$h .= $cgiO->hidden({-name=>$admin,-value=>1,-override=>1});
	$h .= $cgiO->hidden({-name=>'level',-value=>$level,-override=>1});
	$h .= $cgiO->
	  Tr(
	    $cgiO->td({-width=>$tdWidth,-height=>$tdHeight},$label).SPACE,
		  $cgiO->td({-valign=>'top',-width=>'130'},$select).SPACE,
	    $cgiO->td({-width=>'100'},$cgiO->submit(-name=>'submit',
			  -value=>$langO->string("SELECT"),-style=>'width: 100%')).SPACE,
		  $cgiO->td({-valign=>'bottom',-width=>'100'},$deleteButton).SPACE
		).SPACE;														 
	$h .= $cgiO->end_form.SPACE.SPACE;
	
	# Edit element
	if ($$pselection{'display_rename'} == 1) {
		$h .= $cgiO->start_form;
		$h .= $cgiO->hidden({-name=>$admin,-value=>1,-override=>1});
		$h .= $cgiO->hidden({-name=>'level',-value=>$level,-override=>1});
		$h .= $cgiO->hidden({-name=>'edit_selection',-value=>'1'});
		$h .= $cgiO->hidden({-name=>'edit_selection_value',
		  -value=>$fieldValue,-override=>1});
		$h .= $cgiO->
		  Tr(
			  $cgiO->td({},'&nbsp;'),
				$cgiO->td({-valign=>'top',-width=>$tdWidth},
				  $cgiO->textfield({-name=>'edit_selection_name',-value=>$selected,
						-override=>1,-style=>'width: 97%'})),
				$cgiO->td({-width=>'100'},
				  $cgiO->submit(-name=>'submit',-value=>$langO->string("CHANGE"),
						-style=>'width: 100%'))
			);
		$h .= $cgiO->end_form;
	}
	#	 New element
	if ($$pselection{'display_create'} == 1) {
		$h .= $cgiO->start_form;
		$h .= $cgiO->hidden({-name=>$admin,-value=>1,-override=>1});
		$h .= $cgiO->hidden({-name=>'level',-value=>$level,-override=>1});
		$h .= $cgiO->hidden({-name=>'adm',-value =>'edit',-override=>1});
		$h .= $cgiO->hidden({-name=>'new_selection',-value=>'1'});
		$h .= $cgiO->hidden({-name=>'new_selection_value',
		  -value=>$newSelectionValue,-override=>1});
 		$h .= $cgiO->Tr(
		  $cgiO->td({},'&nbsp;'),
			$cgiO->td({-valign=>'top',-width=>$tdWidth},
			  $cgiO->textfield({-name=>'new_selection_name',-override=>1,
				  -style=>'width: 97%'})),
				$cgiO->td({-width=>'100'},
				  $cgiO->submit(-name=>'submit',-value=>$langO->string("CREATE"),
					 -style=>'width: 100%'))
		);
		$h .= $cgiO->end_form;
	}
	if ($$pselection{'message'} ne "") {
	  $h .= $cgiO->Tr(
		  $cgiO->td({-colspan=>4,-align=>'right',
			  -width=>$tdWidth,-height=>$tdHeight},$$pselection{'message'}));
	}
	$h .= $cgiO->end_table;
	$self->{'main'} .= $h.$cgiO->br;
}

sub _displayInputForm {
  my ($self,$pfields,$admin) = @_;
	my $tdWidth = 250;
  my $tdHeight = 20;
	my $cgiO = $self->cgi;
  my $langO = $self->archive->lang;
  my $id = $cgiO->param("id");
	# ======================= unpacking id
	my $id1 = $id;
  $id1 =~ tr/+/ /;
  $id1 =~ s/\\$//;
  $id1 =~ s/%([0-9a-fA-Z]{2})/pack("c",hex($1))/eg;
  $id1 =~ s/\r?\n/\n/g;
	#print STDERR "unpack =============: $id => $id1\n";
	$id=$id1;
	# ======================= unpacking id
	my $level = $cgiO->param("level");
  my $valign = "center";
	my ($back);
  $self->{'main'}.=$cgiO->start_form;
  $self->{'main'}.=$cgiO->start_table;
	$self->{'main'}.=$cgiO->hidden({-name=>$admin,-value=>1,-override=>1});
	$self->{'main'}.=$cgiO->hidden({-name=>'adm',-value=>'save',-override=>1});
	$self->{'main'}.=$cgiO->hidden({-name=>'level',-value=>$level,-override=>1});
	if ($cgiO->param("adm") eq "edit") {
  	$self->{'main'}	.= $cgiO->hidden('id',$id);
	}
  foreach my $key (@{$$pfields{'list'}}) {
	  my $field;
		my $fieldName = $$pfields{$key}{'name'};
		my $fieldType = $$pfields{$key}{'type'};
		my $fieldValue = $$pfields{$key}{'value'};
		my $fieldHiddenValue = $$pfields{$key}{'hidden_value'};
		my $pafieldValues = $$pfields{$key}{'array_values'};
		my $phfieldValues = $$pfields{$key}{'hash_values'};
	  my $fieldUpdate = $$pfields{$key}{'update'};
		if ($fieldUpdate==1 || length($id)==0 || $cgiO->param("adm") ne "edit") {
			# Field is editable (for example host and username in user administration
			# are not editable!
			$field = $self->_fieldTypeToHtml($fieldName,$fieldType,$fieldValue,
			                                 $pafieldValues,$phfieldValues);
	  } else {
			$field = $fieldValue;
			# Set non editable values as hidden fields
			$self->{'main'} .= $cgiO->hidden({-name=>$fieldName,
				-value=>$fieldHiddenValue,-override=>1});
		}
		if ($fieldType eq "hidden") {
			$self->{'main'} .= $cgiO->hidden({-name=>$fieldName,
				-value=>$fieldValue,-override=>1});
		} else {
			$valign = "top" if ($fieldType eq "textarea");
			$self->{'main'} .= $cgiO->
			  Tr(
				  $cgiO->td({-class=>'NoWrap',-valign=>$valign,-width => $tdWidth,
			  	  -height=>$tdHeight},$$pfields{$key}{'label'}),
			    $cgiO->td({-valign => 'top'},$field)
				);
		}
	}
  if ($$pfields{'displayBackFormButton'} == 1) {
  	$back = $cgiO->submit(-name=>'submit',-style=>'width: 80px',
		-value=>$langO->string("BACK"));
  }
  my $submit = $cgiO->submit(-name=>'submit',-style => 'width: 80px',
		-value=>$langO->string("SAVE"));
  $self->{'main'} .= $cgiO->Tr($cgiO->td({-colspan=>2,-align=>'right',
	  -height=>40,-valign=>'bottom'},$back."&nbsp;".$submit));
	$self->{'main'} .= $cgiO->end_table;
	$self->{'main'} .= $cgiO->end_form;
}

sub _displayExistingElements {
  my ($self,$pelements,$admin) = @_;
	my $perl = $self->config->get("PERL_DIR");
  my $langO = $self->archive->lang;
	my $cgiO = $self->cgi;
	my $level = $cgiO->param("level");
	my $nrOfElements = $#{$$pelements{'list'}};
	my $mid = $$pelements{'mask_definition'};
	my $url = "$perl/index.pl?$admin=1&mid=$mid&level=$level";
  my $langCode = $langO->code;
  my ($newLink);
	if ($$pelements{'new'} == 0) {
		$newLink = "&nbsp;";
	} else {
		$newLink = $cgiO->a({-href=>$url."&adm=new",
	  	-class=>'New'},"&rsaquo;".$langO->string("NEW"));
  }
	if ($$pelements{'paste'} == 0) {
	  $newLink .= "&nbsp;";
	} else {
	  $newLink .= '&nbsp;&nbsp;'.$cgiO->a({-href=>$url."&adm=paste",
		             -class=>'New'},"&rsaquo;".$langO->string("PASTE"));
	}
	$self->{'main'}.= SPACE.$cgiO->start_table({-border=>0,
		-cellpadding=>0,-cellspacing=>1,-width=>'80%'});
  my $elementTh = $cgiO->th({-class=>'Element',-width=>140},$newLink);
	if ($nrOfElements >= 0) {
  	foreach my $attribute (@{$$pelements{'attributes'}}) {
			$elementTh .= $cgiO->th({-class=>'Element'},
      $langO->string(uc($attribute)));
		}
		$self->{'main'} .= $cgiO->Tr($elementTh);
		foreach my $id (@{$$pelements{'list'}}) {
			my ($edit,$copy,$delete);
			my $urlParams = $$pelements{$id}{'url_params'};
	    # ======================= packing id
			my $paramId = $id;
      $paramId =~ s/([^a-zA-Z0-9_.-])/sprintf("%%%02x", ord($1))/ge;
			#my $paramId = $cgiO->escape($id);
			#print STDERR "pack ============$id => $paramId\n";
	    # ======================= packing id
			if ($$pelements{$id}{'update'} == 1) {
				$edit = $cgiO->a({-href=>"$url&adm=edit&id=$paramId&$urlParams",
		  		-class=>'Edit'},"&rsaquo;".$langO->string("EDIT"));
				$edit .= "&nbsp;&nbsp;&nbsp;&nbsp;";
			}
			if ($$pelements{$id}{'copy'} == 1) {
			  $copy = $cgiO->a({-href=>"$url&adm=copy&id=$paramId&$urlParams",
					-class=>'Edit'},"&rsaquo;".$langO->string("COPY"));
				$copy .= "&nbsp;&nbsp;&nbsp;&nbsp;";
			}
			if ($$pelements{$id}{'delete'} == 1) {
				$delete = $cgiO->a({-href=>"$url&adm=delete&id=$paramId&$urlParams",
			  	-class=>'Delete',-onClick=>"return askForDeletion('$langCode')"},
					"&rsaquo;".$langO->string("DELETE"));
				$delete .= "&nbsp;&nbsp;&nbsp;&nbsp;";
			}
			my $elementTr = $cgiO->td({-class=>'Element'},$edit.$copy.$delete);
			foreach my $attribute (@{$$pelements{'attributes'}}) {
				$elementTr .= $cgiO->td({-class=>'Element'},
					$$pelements{$id}{$attribute});
			}
			$self->{'main'} .= $cgiO->Tr($elementTr).SPACE;
		}	
	} else {
		$self->{'main'} .= $cgiO->Tr($elementTh);
		$self->{'main'} .= $cgiO->Tr(
			$cgiO->td({-class=>'Element',-colspan=>2},
				$langO->string("NO_ELEMENTS_FOUND"))
		);
	}
	$self->{'main'} .= $cgiO->end_table.SPACE;
}

sub _userAdministration {
  my ($self) = @_;
  my $langO = $self->archive->lang;
	my $cgiO = $self->cgi;
  my $archiveO = $self->archive;
	my $adm = $self->cgi->param("adm");
	my $ua = PL::UserAdministration->new($archiveO);
  if ($cgiO->param("adm") eq "save" && 
		$cgiO->param("submit") ne $langO->string("BACK")) {
		$ua->save($self->cgi);
	} elsif ($self->cgi->param("adm") eq "delete") {
		$ua->delete($self->cgi);
	}
  my $pfields = $ua->fields($self->cgi);
  my $pelements = $ua->elements($self->cgi);
	$self->_formTitle($langO->string("USER_ADMINISTRATION"));
	if ($adm eq "new" or $adm eq "edit") {
		$self->_displayInputForm($pfields,"ua");
  } else {
		$self->_displayExistingElements($pelements,"ua");
	}
}

sub _fieldDefinition {
  my ($self) = @_;
  my $langO = $self->archive->lang;
	my $cgiO = $self->cgi;
  my $archiveO = $self->archive;
	my $adm = $self->cgi->param("adm");
  my $fd = PL::FieldDefinition->new($archiveO);
	if ($cgiO->param("adm") eq "save" &&
	    $cgiO->param("submit") ne $langO->string("BACK")) {
		$fd->save($self->cgi);
	} elsif ($self->cgi->param("adm") eq "delete") {
		$fd->delete($self->cgi);
	}
  my $pfields = $fd->fields($self->cgi);
	my $pelements = $fd->elements($self->cgi);
	$self->_formTitle($langO->string("FIELD_DEFINITION"));
  if ($adm eq "new" or $adm eq "edit") {
		$self->_displayInputForm($pfields,"fd");
	} else {
		$self->_displayExistingElements($pelements,"fd");
	}
}

sub _userExternal {
  my ($self) = @_;
	$self->_formTitle($self->archive->lang->string("USER_EXTERN"));
  my $dbh = $self->archive->db->dbh; # database connection
	my $lang = $self->archive->lang; # languages strings
	my $cgi = $self->cgi;
	my $name = "ue";
	my @fields = qw(ue_mode ue_server ue_port ue_application
	                ue_dom ue_bdn ue_lcuser ue_defuser ue_upload);
	my $pfields = \@fields;
  my $fr = PL::Form->new($dbh,$lang,$cgi,$name,$pfields);
	$fr->process();
	$self->{'main'} .= $fr->display();
}

sub _userGroups {
  my ($self) = @_;
	$self->_formTitle($self->archive->lang->string("USER_GROUPS"));
  my $dbh = $self->archive->db->dbh; # database connection
	my $lang = $self->archive->lang; # languages strings
	my $cgi = $self->cgi;
	my $name = "ug";
	my @fields = qw(ug_group ug_intern ug_note ug_active);
	my $pfields = \@fields;
  my $fr = PL::Form->new($dbh,$lang,$cgi,$name,$pfields);
	$fr->process();
	$self->{'main'} .= $fr->display();
}

sub _userMasks {
  my ($self) = @_;
	$self->_formTitle($self->archive->lang->string("USER_MASKS"));
  my $dbh = $self->archive->db->dbh; # database connection
	my $lang = $self->archive->lang; # languages strings
	my $cgi = $self->cgi;
	my $name = "um";
	my @fields = qw(um_name um_mask um_users um_startdef um_description);
	my $pfields = \@fields;
  my $fr = PL::Form->new($dbh,$lang,$cgi,$name,$pfields);
	$fr->process();
	$self->{'main'} .= $fr->display();
}

sub _exportDocs {
  my ($self) = @_;
	$self->_formTitle($self->archive->lang->string("EXPORT_DOCS"));
  my $dbh = $self->archive->db->dbh; # database connection
	my $lang = $self->archive->lang; # languages strings
	my $cgi = $self->cgi;
	my $name = "ed";
	my @fields = qw(ed_allowed ed_user ed_maxrecords ed_deactivate
		ed_factor ed_compression ed_killpdf ed_killsource);
	my $pfields = \@fields;
  my $fr = PL::Form->new($dbh,$lang,$cgi,$name,$pfields);
	$fr->process();
	$self->{'main'} .= $fr->display();
}

sub _mailArchiving {
  my ($self) = @_;
	$self->_formTitle($self->archive->lang->string("MAILS"));
  my $dbh = $self->archive->db->dbh; # database connection
	my $lang = $self->archive->lang; # languages strings
	my $cgi = $self->cgi;
	my $name = "ml";
	my @fields = qw(ml_name ml_host ml_port ml_user ml_pw ml_ssl ml_folder 
	  ml_from ml_cc ml_to ml_subject ml_owner ml_age ml_delete 
		ml_move ml_restore ml_processing ml_attach ml_inactive ml_filesexclude
		ml_script ml_engine ml_o365_tenant ml_o365_clientid ml_o365_clientsecret
		ml_o365_max);
	my $pfields = \@fields;
  my $fr = PL::Form->new($dbh,$lang,$cgi,$name,$pfields);
	$fr->process();
	$self->{'main'} .= $fr->display();
}

sub _scanDef {
  my ($self) = @_;
	$self->_formTitle($self->archive->lang->string("SCAN_DEFINITIONS"));
  my $dbh = $self->archive->db->dbh; # database connection
	my $lang = $self->archive->lang; # languages strings
	my $cgi = $self->cgi;
	my $name = "sa";
	my @fields = qw(sa_name);
	my $pfields = \@fields;
  my $fr = PL::Form->new($dbh,$lang,$cgi,$name,$pfields);
	$fr->process();
	$self->{'main'} .= $fr->display();
}

sub _ocrLimit {
  my ($self) = @_;
	$self->_formTitle($self->archive->lang->string("OCRLIMIT"));
  my $dbh = $self->archive->db->dbh; # database connection
	my $lang = $self->archive->lang; # languages strings
	my $cgi = $self->cgi;
	my $name = "oc";
	my @fields = qw(oc_limit oc_start oc_stop oc_pdftemp
		oc_host oc_domain oc_folder oc_user oc_password);
	my $pfields = \@fields;
  my $oc = PL::Form->new($dbh,$lang,$cgi,$name,$pfields);
	$oc->process();
	$self->{'main'} .= $oc->display();
}

sub _jobAdmin {
  my ($self) = @_;
	$self->_formTitle($self->archive->lang->string("JOBADMIN"));
  my $dbh = $self->archive->db->dbh; # database connection
	my $lang = $self->archive->lang; # languages strings
	my $cgi = $self->cgi;
	my $name = "ja";
	my @fields = qw(ja_name ja_script ja_boxes ja_code ja_update 
	                ja_actualized ja_user ja_pw);
	my $pfields = \@fields;
  my $oc = PL::Form->new($dbh,$lang,$cgi,$name,$pfields);
	$oc->process();
	$self->{'main'} .= $oc->display();
}

sub _formRecognition {
  my ($self) = @_;
	$self->_formTitle($self->archive->lang->string("FORM_RECOGNITION"));
  my $dbh = $self->archive->db->dbh; # database connection
	my $lang = $self->archive->lang; # languages strings
	my $cgi = $self->cgi;
	my $name = "fr";
	my @fields = qw(fr_object fr_left fr_top fr_width fr_height fr_type
	                fr_from fr_to fr_field fr_start fr_end fr_script fr_test);
	my $pfields = \@fields;
  my $fr = PL::Form->new($dbh,$lang,$cgi,$name,$pfields);
	$fr->process();
	$self->{'main'} .= $fr->display();
}

sub _logoRecognition {
  my ($self) = @_;
	$self->_formTitle($self->archive->lang->string("LOGO_RECOGNITION"));
  my $dbh = $self->archive->db->dbh; # database connection
	my $lang = $self->archive->lang; # languages strings
	my $cgi = $self->cgi;
	my $name = "lr";
	my @fields = qw(lr_name lr_logo lr_logox lr_logoy lr_radius lr_contours 
		lr_tolerance lr_reduction lr_anglemax lr_anglestep lr_score);
	my $pfields = \@fields;
  my $fr = PL::Form->new($dbh,$lang,$cgi,$name,$pfields);
	$fr->process();
	$self->{'main'} .= $fr->display();
}

sub _maskDefinition {
  my ($self) = @_;
	my $langO = $self->archive->lang;
	my $cgiO = $self->cgi;
	my $archiveO = $self->archive;
  my $adm = $self->cgi->param("adm");
  my $md = PL::MaskDefinition->new($archiveO);
  if ($cgiO->param("adm") eq "save" &&
	    $cgiO->param("submit") ne $langO->string("BACK")) {
		$md->save($self->cgi);		
	} elsif ($self->cgi->param("adm") eq "delete") {
		$md->delete($self->cgi);
	}
  my $pfields = $md->fields($self->cgi);
  my $pelements = $md->elements($self->cgi);
	my $pselection = $md->selection($self->cgi);
	$self->_formTitle($langO->string("MASK_DEFINITION"));
 	$self->_displaySelectionForm($pselection,"md");
  if ($adm eq "new" or $adm eq "edit") {
	 	$self->_displayInputForm($pfields,"md");
  } else {
	 	$self->_displayExistingElements($pelements,"md");
  }
}

sub _databaseAdministration {
  my ($self) = @_;
  my $langO = $self->archive->lang;
	my $cgiO = $self->cgi;
  my $archiveO = $self->archive;
  my $da = PL::DatabaseAdministration->new($archiveO);
  if ($cgiO->param("adm") eq "save" &&
	    $cgiO->param("submit") ne $langO->string("BACK")) {
		$da->save($cgiO,$archiveO);
	}
	my $pfields = $da->fields($cgiO);
	$self->_formTitle($langO->string("DATABASE_ADMINISTRATION"));
	$self->_displayInputForm($pfields,"da");
}

sub _scanDefinitionAdministration {
  my ($self) = @_;
	my $langO = $self->archive->lang;
	my $cgiO = $self->cgi;
  my $archiveO = $self->archive;
	my $adm = $self->cgi->param("adm");
	my $sa = PL::ScanDefAdministration->new($archiveO);
  if ($cgiO->param("adm") eq "save" &&
	    $cgiO->param("submit") ne $langO->string("BACK")) {
		$sa->save($self->cgi);
	} elsif ($self->cgi->param("adm") eq "delete") {
		$sa->delete($self->cgi);
	} elsif ( $self->cgi->param("adm") eq "copy") {
	  $sa->copy($self->cgi);
	} elsif ( $self->cgi->param("adm") eq "paste") {
	  $sa->paste($self->cgi);
	}
  my $pfields = $sa->fields($self->cgi);
  my $pelements = $sa->elements($self->cgi);
	$self->_formTitle($langO->string("SCAN_DEFINITIONS"));
	if ($adm eq "new" or $adm eq "edit") {
		$self->_displayInputForm($pfields,"sa");
  } else {
		$self->_displayExistingElements($pelements,"sa");
	}
}

sub _ocrDefinitionAdministration {
  my ($self) = @_;
  my $langO = $self->archive->lang;
  my $cgiO = $self->cgi;
  my $archiveO = $self->archive;
  my $adm = $self->cgi->param("adm");
  my $sa = PL::OCRDefAdministration->new($archiveO);
  if ($cgiO->param("adm") eq "save" &&
			$cgiO->param("submit") ne $langO->string("BACK")) {
  	$sa->save($self->cgi);
  } elsif ($self->cgi->param("adm") eq "delete") {
  	$sa->delete($self->cgi);
	} elsif ( $self->cgi->param("adm") eq "copy") {
	  $sa->copy($self->cgi);
	} elsif ( $self->cgi->param("adm") eq "paste") {
	  $sa->paste($self->cgi);
  }
  my $pfields = $sa->fields($self->cgi);
  my $pelements = $sa->elements($self->cgi);
  $self->_formTitle($langO->string("OCRDEFINITIONS"));
  if ($adm eq "new" or $adm eq "edit") {
    $self->_displayInputForm($pfields,"ld");
  } else {
    $self->_displayExistingElements($pelements,"ld");
  }
}

sub _sqlDefinition {
  my ($self) = @_;
  my $langO = $self->archive->lang;
  my $cgiO = $self->cgi;
  my $archiveO = $self->archive;
  my $adm = $self->cgi->param("adm");
  my $sq = PL::SQLDefinition->new($archiveO);
  if ($cgiO->param("adm") eq "save" &&
			$cgiO->param("submit") ne $langO->string("BACK")) {
  	$sq->save($self->cgi);
  } elsif ($self->cgi->param("adm") eq "delete") {
  	$sq->delete($self->cgi);
	} elsif ( $self->cgi->param("adm") eq "copy") {
	  $sq->copy($self->cgi);
	} elsif ( $self->cgi->param("adm") eq "paste") {
	  $sq->paste($self->cgi);
  }
  my $pfields = $sq->fields($self->cgi);
  my $pelements = $sq->elements($self->cgi);
  $self->_formTitle($langO->string("SQLDEFINITIONS"));
  if ($adm eq "new" or $adm eq "edit") {
    $self->_displayInputForm($pfields,"sq");
  } else {
    $self->_displayExistingElements($pelements,"sq");
  }
}

sub _barcodeSettings {
  my ($self) = @_;
	my $langO = $self->archive->lang;
	my $cgiO = $self->cgi;
	my $archiveO = $self->archive;
	my $adm = $self->cgi->param("adm");
	my $bs = PL::BarcodeSettings->new($archiveO);
	if ($cgiO->param("adm") eq "save" &&
	    $cgiO->param("submit") ne $langO->string("BACK")) {
		$bs->save($self->cgi);
	} elsif ($self->cgi->param("adm") eq "delete") {
		$bs->delete($self->cgi);
	}
	my $pfields = $bs->fields($self->cgi);
	my $pelements = $bs->elements($self->cgi);
	$self->_formTitle($langO->string("BARCODE_RECOGNITION"));
	if ($adm eq "new" or $adm eq "edit") {
		$self->_displayInputForm($pfields,"bs");
	} else {
		$self->_displayExistingElements($pelements,"bs");
	}
}

sub _barcodeProcessing {
  my ($self) = @_;
	my $langO = $self->archive->lang;
	my $cgiO = $self->cgi;
	my $archiveO = $self->archive;
	my $adm = $self->cgi->param("adm");
	my $bp = PL::BarcodeProcessing->new($archiveO);
	if ($cgiO->param("adm") eq "save" &&
			$cgiO->param("submit") ne $langO->string("BACK")) {
		$bp->save($self->cgi);
	} elsif ($cgiO->param("adm") eq "delete") {
		$bp->delete($self->cgi);
	}
  my $pselection = $bp->selection($self->cgi);
  my $pfields = $bp->fields($self->cgi);
	my $pelements = $bp->elements($self->cgi);
	$self->_formTitle($langO->string("BARCODE_PROCESSING"));
 	$self->_displaySelectionForm($pselection,"bp");
	if ($adm eq "new" or $adm eq "edit") {
		$self->_displayInputForm($pfields,"bp");
	} else {
		$self->_displayExistingElements($pelements,"bp");
	}
}

sub new {
  my ($cls,$mainO) = @_; # Object of PL::Main
	my $self = {};
  bless $self, $cls;
	$self->{'cgiO'} = $mainO->cgi;
  $self->{'archiveO'} = $mainO->archive;
  $self->{'configO'} = $mainO->config;
  $self->{'error'} = $mainO->error;
	return $self;
}

sub main {
  my ($self) = @_;
  my $cgiO = $self->cgi;
  if ($self->cgi->param("ua") == 1) {
		$self->_userAdministration;
	} elsif ($self->cgi->param("ue") == 1) {
		$self->_userExternal;
	} elsif ($self->cgi->param("ug") == 1) {
		$self->_userGroups;
	} elsif ($self->cgi->param("um") == 1) {
		$self->_userMasks;
	} elsif ($self->cgi->param("fd") == 1) {
		$self->_fieldDefinition;
	} elsif ($self->cgi->param("md") == 1) {
		$self->_maskDefinition;
	} elsif ($self->cgi->param("fr") == 1) {
		$self->_formRecognition;
	} elsif ($self->cgi->param("lr") == 1) {
		$self->_logoRecognition;
	} elsif ($self->cgi->param("da") == 1) {
		$self->_databaseAdministration;
	} elsif ($self->cgi->param("sa") == 1) {
		$self->_scanDefinitionAdministration;
  } elsif ($self->cgi->param("ld") == 1) {
      $self->_ocrDefinitionAdministration;
	} elsif ($self->cgi->param("bs") == 1) {
		$self->_barcodeSettings;
	} elsif ($self->cgi->param("bp") == 1) {
		$self->_barcodeProcessing;
	} elsif ($self->cgi->param("sq") == 1) {
		$self->_sqlDefinition;
	} elsif ($self->cgi->param("ed") == 1) {
		$self->_exportDocs;
	} elsif ($self->cgi->param("ml") == 1) {
		$self->_mailArchiving;
	} elsif ($self->cgi->param("ja") == 1) {
		$self->_jobAdmin;
	} elsif ($self->cgi->param("oc") == 1) {
		$self->_ocrLimit;
	}
  $self->_header;
  $self->{'html'} .= $cgiO->start_table({-border=>0,-cellspacing=>0,
		-cellpadding=>0,-width=>'100%'});
	$self->{'html'} .= $cgiO->Tr($cgiO->td({-valign=>'top',-width=>249},
		$self->_menu),$cgiO->td({-width=>30},"&nbsp;"),
		$cgiO->td({-valign=>'top'},$self->_main));
  $self->{'html'} .= $cgiO->end_table;
	return $self->{'html'};
}

sub header {
  my ($self,$cookie) = @_;
  my ($html);
	my $www = $self->config->get("WWW_DIR");
	my $styles = $www . $self->config->get("STYLES");
	my $fr = qq|<style type="text/css">#centered { position:absolute; |.
	         qq|top:50%; left:50%; width:64em; height:36.2em; |.
					 qq|margin-left:-32em; margin-top:-18.1em; border:1px |.
           qq|solid #888; padding:0em; }</style>|;
	my $javascript = $www . "/js/functions.js";
  if (defined $cookie) {
		$html = $self->cgi->header(-cookie => $cookie);
	} else {
		$html = $self->cgi->header;
	}
	$html .= $self->cgi->start_html(-title => 'Archivista WebAdmin',
		-author => 'Urs Pfister upfister@archivista.ch',
		-style => {-src => $styles},-head => $fr,
		-script => {-src => $javascript});
  return $html;
}

sub login {
  my ($self) = @_;
	my $cgiO = $self->cgi;
	my $print = "";
	if (!-e '/etc/nologinext.conf') {
	  $print .= "<p>";
	  $print .= qq|<a href="/perl/avclient/index.pl">WebDMS</a>\n|;
	  $print .= " - ";
		if (-e '/etc/erp.conf') {
		  if (!-e "/etc/cloudsingleuser.conf") {
	      $print .= qq|<a href="/erp">WebERP</a>\n|;
	      $print .= " - ";
			}
		}
	  $print .= qq|<a href="/cgi-bin/webadmin/index.pl">WebAdmin</a>\n|;
		if (!-e "/etc/cloudsingleuser.conf") {
	    $print .= " - ";
	    $print .= qq|<a href="/perl/webconfig/index.pl">WebConfig</a>\n|;
	    $print .= " - ";
		  my $man1 = $self->getManual("en");
		  my $man2 = $self->getManual("de");
	    $print .= qq|<a href="$man1">Manual</a>\n|;
	    $print .= " - ";
	    $print .= qq|<a href="$man2">Handbuch</a>\n|;
		}
	  $print .= "<p>\n\n";
	}
  my $html = $print.qq|<div id="centered">|.$self->_borderTable().qq|</div>|;
  return $html;
}

sub footer {
  my ($self) = @_;
  return $self->cgi->end_html;
}

sub cgi {
  my ($self) = @_;
	return $self->{'cgiO'};
}

sub archive {
  my ($self) = @_;
	return $self->{'archiveO'};
}

sub config {
  my ($self) = @_;
	return $self->{'configO'};
}

sub getManual {
  my ($self,$lang) = @_;
  my $href = "/manual.pdf";
  $href = "/handbuch.pdf" if $lang eq "de";
	my $path = "/var/opt/apache/lib/htdocs";
	$path = "/usr/share/pve-manager/root" if $self->check64bit()!=0;
  my $size = -s "$path/$href";
	$size = int $size;
	if ($size==0) {
	  my $lang1 = "e2";
		$lang1 = "d2" if $lang eq "de";
	  $href = "http://www.archivista.ch/$lang1/help";
	}
	return $href;
}

sub check64bit {
  my ($self) = @_;
	my $var = $ENV{MOD_PERL};
  my $val = 0;
	$val=1 if $ENV{MOD_PERL} ne "mod_perl/2.0.1";
	return $val;
}

1;

