
package PL::Main;
use strict;
use CGI;
use Archivista;
use ASConfig;
use PL::HTML;

sub _init {
  my ($self) = @_;
  $self->{'configO'} = ASConfig->new;
  $self->{'cgiO'} = CGI->new;
  my $options = $self->cgi->param('options');
	$options = $self->_checkit($options);
	my $archive = $self->cgi->param('archive');
	$archive = $self->_checkit($archive);
	my $host = $self->cgi->param('host');
	$host = $self->_checkit($host);
	my $db = $self->cgi->param('db');
	$db = $self->_checkit($db);
	my $uid = $self->cgi->param('uid');
	$uid = $self->_checkit($uid);
	my $pwd = $self->cgi->param('pwd');
	$pwd = $self->_checkit($pwd);
  my $logout = $self->cgi->param('logout');
	$logout = $self->_checkit($logout);
	my $lang = $self->cgi->param('lang');
	$lang = $self->_checkit($lang);
	my $sessionid = $self->cgi->cookie('sessionid');
	$sessionid = $self->_checkit($sessionid);
  my $logged = 0;
	my $loginParamCheck = 0;
	my ($cookie);
  if (length($host) > 0 && length($db) > 0 && length($uid) > 0) {
		$loginParamCheck = 1;
	}
	if (defined $options && $options ne "login" && $loginParamCheck == 1) {
		if ($options eq "create") {
	  	if (length($archive) > 0) {
				Archivista->create($db,$archive,$host,$uid,$pwd);
  		} else {
				Archivista->create($db,undef,$host,$uid,$pwd);
			}
		} elsif ($options eq "drop") {
			Archivista->drop($db,$host,$uid,$pwd);
		}	
	} elsif ($logout == 1 && length($self->cgi->cookie("sessionid")) > 0) {
		# Request for logout
		eval {
			$self->{'archiveO'} = Archivista->archive($sessionid);
			$self->{'archiveO'}->session->delete;
	  };
		$cookie = $self->cgi->cookie(-name=>'sessionid',-value=>'');
	} elsif ($loginParamCheck == 1) {
		# Require to login
		$self->{'archiveO'} = Archivista->archive($db,$host,$uid,$pwd,$lang);
		if (defined $self->{'archiveO'}->db 
			&& $self->{'archiveO'}->hostIsSlave() == 0) {
			# Check if user has 255 level
			my $user = $self->{'archiveO'}->user($host,$uid);
			my $level = $user->attribute("Level")->value;
 			if ($level == 255) {
				$sessionid = $self->archive->session->id;
				$cookie = $self->cgi->cookie(-name=>'sessionid',-value=>$sessionid);
				$logged = 1;
			}
		} else {
			$self->{'error'} = "Error on login!";
		}
	} elsif (length($sessionid) > 0) {
	  # There is an active session id yet
		$self->{'archiveO'} = Archivista->archive($sessionid);
		if (defined $self->{'archiveO'}) {
			$logged = 1;
		}
	}
	$self->{'htmlO'} = PL::HTML->new($self);
	$self->{'html'} = $self->html->header($cookie);
	if ($logged == 1) {
		$self->{'html'} .= $self->html->main;
	} else {
		$self->{'html'} .= $self->html->login;
	}
}

sub _checkit {
  my ($self,$value) = @_;
	$value =~ s/\&/&amp;/g;
	$value =~ s/\</&lt;/g;
	$value =~ s/\>/&gt;/g;
	$value =~ s/\"/&quot;/g;
	$value =~ s/\'/&apos;/g;
	$value =~ s/\//&sol;/g;
	$value =~ s/\\/&bsol;/g;
	return $value;
}

sub new {
  my ($cls) = @_;
  my $self = {};
  bless $self, $cls;
  $self->_init;
  return $self;
}

sub print {
  my ($self) = @_;
  if (defined $self->archive) {
  	$self->archive->disconnect if (defined $self->archive->db);
  }
	$self->{'html'} .= $self->html->footer;
  print $self->{'html'};
}

sub cgi {
  my ($self) = @_;
  return $self->{'cgiO'};
}

sub archive {
	my ($self) = @_;
	return $self->{'archiveO'};
}

sub html {
  my ($self) = @_;
	return $self->{'htmlO'};
}

sub config {
  my ($self) = @_;
	return $self->{'configO'};
}

sub error {
  my ($self) = @_;
	return $self->{'error'};
}

1;

