
package PL::MaskDefinition;
use strict;

sub new {
  my ($cls,$archiveO) = @_; # Object of Archivista::BL::Archive (APCL)
  my $self = {};
  bless $self, $cls;
  my @fields = ("mask_definition","mask_definition_name","field_name",
    "field_type","field_parent","field_label","field_position",
    "field_width","user_add","user_locked");
  $self->{'archiveO'} = $archiveO;
  $self->{'field_list'} = \@fields;
  return $self;
}

sub selection {
  my ($self,$cgiO) = @_;
  my $archiveO = $self->archive;
  my $langO = $self->archive->lang;
  my $maskDefinition = $cgiO->param('mask_definition');
	my ($message);
  my $maskNextDefinition = $archiveO->maskNextDefinition;
  my $phmaskDefinitions = $archiveO->maskDefinitions;
  my @maskDefinitions = sort keys %$phmaskDefinitions;
  my $value = "00";
  $value = $maskDefinition if (length($maskDefinition) > 0);
  # Check if user deleted a mask definition
	my $nr = $#maskDefinitions;
  if ($cgiO->param('submit') eq $langO->string("DELETE")) {
	  if ($maskDefinition eq "00") {
      $message = $langO->string('MASK_KILLFIRST');
    } elsif ($maskDefinition ne $maskDefinitions[$nr]) {
		  $message = $langO->string('MASK_KILLNOTLAST');
		} else {
      $archiveO->mask_parameter("FelderObj".$maskDefinition)->delete;
      $archiveO->mask_parameter("FelderTab".$maskDefinition)->delete;
      $maskDefinition="00";
	    $maskNextDefinition = $archiveO->maskNextDefinition;
      $phmaskDefinitions = $archiveO->maskDefinitions;
      @maskDefinitions = sort keys %$phmaskDefinitions;
      $value = "00";
      $value = $maskDefinition if (length($maskDefinition) > 0);
		}
	}
  if ($cgiO->param('edit_selection') == 1) {
    # Check if we must change a mask definition name
    my $editMaskDefinitionName = $cgiO->param('edit_selection_name');
    my $editMaskDefinitionValue = $cgiO->param('edit_selection_value');
    $$phmaskDefinitions{$editMaskDefinitionValue} = 
		  $editMaskDefinitionName;
    $value = $editMaskDefinitionValue;
    # Update value on database
    $archiveO->mask_parameter("FelderObj".$value)
		  ->maskDefinitionName($editMaskDefinitionName);
  } elsif ($cgiO->param('new_selection') == 1) {
     # Define the name for the new mask definition
    my $maskDefinitionName = $cgiO->param('new_selection_name');
    my $maskDefinitionValue = $cgiO->param('new_selection_value');
    $$phmaskDefinitions{$maskDefinitionValue} = 
		  $maskDefinitionName; # Values like Felddefinition 1
    push @maskDefinitions, $maskDefinitionValue; # Values like 00,01,02
    $value = $maskDefinitionValue;
  } elsif (length($cgiO->param('mid')) > 0) {
    $value = $cgiO->param('mid');
  }
  my %selection;
  $selection{'label'} = $langO->string("MASK");
  $selection{'field_name'} = "mask_definition";
  $selection{'array_values'} = \@maskDefinitions;
  $selection{'hash_values'} = $phmaskDefinitions;
  $selection{'value'} = $value;
  $selection{'new_selection_value'} = $maskNextDefinition;
  $selection{'display_rename'} = 1;
  $selection{'display_delete'} = 1;
  $selection{'display_create'} = 1;
	$selection{'message'} = $message;
  return \%selection; 
}

sub fields {
  my ($self,$cgiO) = @_;
  my $archiveO = $self->archive;
  my $langO = $self->archive->lang;
  my ($maskDefinition,$maskDefinitionName);
  # Retrieve or set the field definition value to work with
  if (length($cgiO->param('mask_definition')) > 0 
      && $cgiO->param('submit') ne $langO->string("DELETE")) {
    $maskDefinition = $cgiO->param('mask_definition');
  } elsif (length($cgiO->param('mid')) > 0) {
    $maskDefinition = $cgiO->param('mid');
  }
  if ($cgiO->param('edit_selection') == 1) {
    $maskDefinition = $cgiO->param('edit_selection_value');
  }
  # Define the name for the new mask definition
  if ($cgiO->param('new_selection') == 1) {
    $maskDefinitionName = $cgiO->param('new_selection_name');
    $maskDefinition = $cgiO->param('new_selection_value');
  }
  my $pauserDefinedAttributes = $self->archive->
	  userDefinedAttributes;
  my $phfieldTypes = $self->archive->maskFieldTypes;
  my @fieldTypes = sort keys %$phfieldTypes;
  my $pafieldParents = $self->archive->
	  mask_parameter("FelderObj".$maskDefinition)->
		 maskParentFields("ARRAY");
  my $phfieldParents = $self->archive->
	  mask_parameter("FelderObj".$maskDefinition)->
		  maskParentFields("HASH");
  # Add a NULL entry to the parents dropdown
  unshift @$pafieldParents, "";
  my $idx = 0;
  my (@position,%position,%fields);
  foreach my $attribute (@$pauserDefinedAttributes) {
    push @position, $idx;
    $position{$idx} = $attribute;
    $idx++;
  }
  $fields{'list'} = $self->{'field_list'};
  $fields{'mask_definition'}{'name'} = "mask_definition";
  $fields{'mask_definition'}{'type'} = "hidden";
  $fields{'mask_definition'}{'value'} = $maskDefinition;
  $fields{'mask_definition'}{'update'} = 1;
  $fields{'mask_definition_name'}{'name'} = "mask_definition_name";
  $fields{'mask_definition_name'}{'type'} = "hidden";
  $fields{'mask_definition_name'}{'value'} = $maskDefinitionName;
  $fields{'mask_definition_name'}{'update'} = 1;
  $fields{'field_name'}{'label'} = $langO->string("FIELD_NAME");
  $fields{'field_name'}{'name'} = "field_name";
  $fields{'field_name'}{'type'} = "select";
  $fields{'field_name'}{'array_values'} = $pauserDefinedAttributes;
  $fields{'field_name'}{'update'} = 1;
  $fields{'field_label'}{'label'} = $langO->string("LABEL");
  $fields{'field_label'}{'name'} = "field_label";
  $fields{'field_label'}{'type'} = "textfield";
  $fields{'field_label'}{'update'} = 1;
  $fields{'field_type'}{'label'} = $langO->string("FIELD_TYPE");
  $fields{'field_type'}{'name'} = "field_type";
  $fields{'field_type'}{'type'} = "select";
  $fields{'field_type'}{'array_values'} = \@fieldTypes;
  $fields{'field_type'}{'hash_values'} = $phfieldTypes;
  $fields{'field_type'}{'update'} = 1;
  $fields{'field_parent'}{'label'} = $langO->string("FIELD_PARENT");
  $fields{'field_parent'}{'name'} = "field_parent";
  $fields{'field_parent'}{'type'} = "select";
  $fields{'field_parent'}{'array_values'} = $pafieldParents;
  $fields{'field_parent'}{'hash_values'} = $phfieldParents;
  $fields{'field_parent'}{'update'} = 1;
  $fields{'field_position'}{'label'} = $langO->string("POSITION");
  $fields{'field_position'}{'name'} = "field_position";
  $fields{'field_position'}{'type'} = "textfield";
  $fields{'field_position'}{'update'} = 1;
  $fields{'field_width'}{'label'} = $langO->string("WIDTH");
  $fields{'field_width'}{'name'} = "field_width";
  $fields{'field_width'}{'type'} = "textfield";
  $fields{'field_width'}{'update'} = 1;
  $fields{'user_add'}{'label'} = $langO->string("NEW_ENTRIES_ONLY_FOR_USER");
  $fields{'user_add'}{'name'} = "user_add";
  $fields{'user_add'}{'type'} = "textfield";
  $fields{'user_add'}{'update'} = 1;
  $fields{'user_locked'}{'label'} = $langO->string("INPUT_ONLY_FOR_USER");
  $fields{'user_locked'}{'name'} = "user_locked";
  $fields{'user_locked'}{'type'} = "textfield";
  $fields{'user_locked'}{'update'} = 1;
  if ($cgiO->param("adm") eq "edit") {
    my $id = $cgiO->param("id"); # field id -> field name
    my $mid = $cgiO->param("mid"); # mask ID -> FelderObjXY
    if (defined $id) {
      my $fieldObj = $archiveO->mask_parameter("FelderObj".$mid)
			  ->attribute("Inhalt")->field($id);
      my $fieldTab = $archiveO->mask_parameter("FelderTab".$mid)
			  ->attribute("Inhalt")->field($id);
      $fields{'field_name'}{'value'} = $fieldObj->name;
      $fields{'field_type'}{'value'} = $fieldObj->type;
      $fields{'field_parent'}{'value'} = $fieldObj->parent;
      $fields{'field_position'}{'value'} = $fieldTab->position;
      $fields{'field_width'}{'value'} = $fieldTab->width;
      $fields{'field_label'}{'value'} = $fieldTab->caption;
      $fields{'user_add'}{'value'} = $fieldObj->userAdd;
      $fields{'user_locked'}{'value'} = $fieldObj->userLocked;
    }
  }
  $fields{'displayBackFormButton'} = 1;
  return \%fields;
}

sub save {
  my ($self,$cgiO) = @_; # Object of CGI.pm
  my $archiveO = $self->archive;
	my $dbh = $archiveO->db->dbh;
  my $id = $cgiO->param("id");
  my ($user);
  my $maskDefinition = $cgiO->param("mask_definition");
  my $maskDefinitionName = $cgiO->param("mask_definition_name");
  my $fieldNameNew = $cgiO->param("field_name");
  my $fieldLabel = $cgiO->param("field_label");
  my $fieldType = $cgiO->param("field_type");
  my $fieldParent = $cgiO->param("field_parent");
  my $fieldPosition = $cgiO->param("field_position");
  my $fieldWidth = $cgiO->param("field_width");
  my $userAdd = $cgiO->param("user_add");
  my $userLocked = $cgiO->param("user_locked");
	my $doublette = 0; # field not twice in mask
	my $def = $self->loadDef($maskDefinition);
	my @fields = ();
	if ($def ne "") {
		my @lines = split(/\r\n/,$def);
		foreach my $line (@lines) {
			my @parts = split(';',$line);
			if ($parts[4]==0) { # it is not an label (def from RichClient)
				my $field = $parts[18]; # field name
				push @fields,$field if $field ne "";
			}
		}
	}
	my $fieldold = $id; # old field (if not new entry)
	my $fieldnew = $fieldNameNew; # new field
	if (($fieldold eq "" && $fieldnew ne "") ||
		($fieldold ne "" && $fieldold ne $fieldnew)) {
		foreach my $field (@fields) {
			$doublette=1 if $field eq $fieldnew; # field twice in mask => no go
		}
	}
  if ($cgiO->param("submit") eq $self->archive->lang->string("SAVE") &&
		$doublette==0) {
    if ($id ne "") {
			# Update the form element
      my $fieldName = $id;
      my $updateField = $archiveO->mask_parameter("FelderObj".$maskDefinition)
				->attribute("Inhalt")->field($fieldName);
      $updateField->type($fieldType);
      $updateField->parent($fieldParent);
      $updateField->userAdd($userAdd);
      $updateField->userLocked($userLocked);
      $updateField->namenew($fieldNameNew);
      $updateField->update;
	  	my $cont = "$fieldNameNew;$fieldLabel;$fieldPosition;$fieldWidth;";
			$self->updateTab($maskDefinition,$cont,$fieldName)
    } else {
			# New element
      my $fieldName = $cgiO->param("field_name");
			if ($fieldName ne "") {
				$archiveO->mask_name($maskDefinitionName); # needed before newField
        my $newField = $archiveO->mask_parameter("FelderObj".$maskDefinition)
					->attribute("Inhalt")->field;
        $newField->name($fieldName);
        $newField->type($fieldType);
        $newField->parent($fieldParent);
        $newField->userAdd($userAdd);
        $newField->userLocked($userLocked);
        $newField->add;
			}
	  	my $cont = "$fieldName;$fieldLabel;$fieldPosition;$fieldWidth;";
			$self->updateTab($maskDefinition,$cont,$fieldName)
		}
  }
}

sub elements {
  my ($self,$cgiO) = @_;
  my $archiveO = $self->archive;
	my $dbh = $archiveO->db->dbh;
  my $langO = $archiveO->lang;
  my $maskDefinition = "00"; # always select the first definition
  if (length($cgiO->param('mask_definition')) > 0
      && $cgiO->param('submit') ne $langO->string("DELETE")) {
    # We selected an existing mask definition
    $maskDefinition = $cgiO->param('mask_definition');
  } elsif ($cgiO->param('edit_selection') == 1) {
    $maskDefinition = $cgiO->param('edit_selection_value');
  } elsif ($cgiO->param('new_selection') == 1) {
    # We define a new mask, set this one for the table (empty table!)
    $maskDefinition = $cgiO->param('new_selection_value');
  } elsif (length($cgiO->param('mid')) > 0) {
    $maskDefinition = $cgiO->param('mid');
  }
  my (@list,%fields,$field,@row,$sql,@el,@el1,$inc,@attributes);
  # Attributes to display on table
  @attributes = ("field_name");
	my $def = $self->loadDef($maskDefinition);
	if ($def ne "") {
	  @el = split("\r\n",$def);
		my $delok=1;
		if ($el[1] eq "") { $delok=0; }
		foreach (@el) {
		  @el1 = split(";",$_);
		  if ($el1[4] == 0) {
			  # take only field elements
				$field = $el1[18];
				my $store = 1; # check for existing fields, only use 1 field 1 time
				foreach my $cfield (@list) {
					$store=0 if $cfield eq $field;
				}
				if ($store==1) {
			  	push @list, $field;
					$fields{$field}{'field_name'} = $field;
  	      $fields{$field}{'update'} = 1;
    	    $fields{$field}{'delete'} = $delok;
				}
      }
		}
	}
  $fields{'new'} = 1;
  $fields{'mask_definition'} = $maskDefinition;
  $fields{'attributes'} = \@attributes;
  $fields{'list'} = \@list;
  return \%fields;
}

sub delete {
  my ($self,$cgiO) = @_;
  my $archiveO = $self->archive;
  my $id = $cgiO->param("id");
  if (defined $id) {
    my $maskDefinition = $cgiO->param('mid');
    $archiveO->mask_parameter("FelderObj".$maskDefinition)
			->attribute("Inhalt")->field($id)->remove;
		my $tab = $self->loadDef($maskDefinition,"Tab");
		my @lines = split(/\r\n/,$tab);
		my @new = ();
		foreach my $line (@lines) {
			my @parts = split(';',$line);
			if ($parts[0] ne $id) { push @new,$line; }
		}
		my $new = join("\r\n",@new);
		$self->saveDef($maskDefinition,"Tab",$new);
	}
}

sub archive {
  my ($self) = @_;
  return $self->{'archiveO'};
}

sub loadDef {
	my ($self,$defnr,$type) = @_;
  my $archiveO = $self->archive;
	my $dbh = $archiveO->db->dbh;
	$type = "Obj" if $type ne "Tab";
	my $cont = "";
	my $sql = "select Inhalt from parameter where ".
		"Name='Felder$type$defnr' and Tabelle='archiv' limit 1";
	my @row = $dbh->selectrow_array($sql);
	if ($row[0] ne "") { $cont=$row[0]; }
	return $cont;
}

sub saveDef {
	my ($self,$masknr,$type,$cont,$defname) = @_;
  my $archiveO = $self->archive;
	my $dbh = $archiveO->db->dbh;
	$type = "Obj" if $type ne "Tab";
	my $id = "Felder$type$masknr";
	if ($defname eq "") { $defname=$id; }
	my $sql = "select Laufnummer from parameter where Name=".$dbh->quote($id).
		" and Art=".$dbh->quote($defname)." limit 1";
	my @row = $dbh->selectrow_array($sql);
	my $lnr = $row[0];
	my $sql = "insert into parameter";
	if ($lnr>0) { $sql = "update parameter"; }
	$sql .= " set Tabelle='archiv',Art=".$dbh->quote($defname).
		",Name=".$dbh->quote($id).",Inhalt=".$dbh->quote($cont);
	if ($lnr>0) { $sql.=" where Tabelle='archiv' and Name=".$dbh->quote($id); }
	$dbh->do($sql);
}

sub updateTab {
	my ($self,$maskDefinition,$cont,$field) = @_;
	my $tab = $self->loadDef($maskDefinition,"Tab");
	my @lines = split(/\r\n/,$tab);
	my $c=0;
	my $found=0;
	foreach my $line (@lines) {
		my @parts = split(';',$line);
		my $name = $parts[0];
		if ($name eq $field) {
			$lines[$c]=$cont;
			$found=1;
			last;
		}
		$c++;
	}
	if ($found==0) { push @lines,$cont; }
	my $new = join("\r\n",@lines);
	$self->saveDef($maskDefinition,"Tab",$new);
}

1;

