
package PL::SQLDefinition;
use strict;

sub new {
  my ($cls,$archiveO) = @_; # Object of Archivista::BL::Archive (APCL)
  my $self = {};
  bless $self, $cls;
  my @fields = ("def_id","def_name","def_desc","def_user","def_val");
  $self->{'archiveO'} = $archiveO;
  $self->{'field_list'} = \@fields;
  return $self;
}

sub fields {
  my ($self,$cgiO) = @_;
  my $archiveO = $self->archive;
  my $langO = $self->archive->lang;
	my $dbh = $archiveO->db->dbh;
  my (%fields); 
  $fields{'list'} = $self->{'field_list'};
  $fields{'def_id'}{'label'} = $langO->string("SQLID");
  $fields{'def_id'}{'name'} = "def_id";
  $fields{'def_id'}{'type'} = "hidden";
  $fields{'def_id'}{'update'} = 0;
  $fields{'list'} = $self->{'field_list'};
  $fields{'def_name'}{'label'} = $langO->string("NAME");
  $fields{'def_name'}{'name'} = "def_name";
  $fields{'def_name'}{'type'} = "textfield";
  $fields{'def_name'}{'update'} = 1;
  $fields{'list'} = $self->{'field_list'};
  $fields{'def_desc'}{'label'} = $langO->string("COMMENT");
  $fields{'def_desc'}{'name'} = "def_desc";
  $fields{'def_desc'}{'type'} = "textfield";
  $fields{'def_desc'}{'update'} = 1;
  $fields{'list'} = $self->{'field_list'};
  $fields{'def_user'}{'label'} = $langO->string("USER");
  $fields{'def_user'}{'name'} = "def_user";
  $fields{'def_user'}{'type'} = "textfield";
  $fields{'def_user'}{'update'} = 1;
  $fields{'list'} = $self->{'field_list'};
  $fields{'def_val'}{'label'} = $langO->string("SQLDEF");
  $fields{'def_val'}{'name'} = "def_val";
  $fields{'def_val'}{'type'} = "textfield";
  $fields{'def_val'}{'update'} = 1;
  if ($cgiO->param("adm") eq "edit") {
    my $id = $cgiO->param("id");
    if (defined $id) {
		  my $sql = "select Name,Beschreibung,User,Inhalt " .
			          "from parameter where Laufnummer=$id";
			my @row = $dbh->selectrow_array($sql);
	    $fields{'def_id'}{'value'} = $id;
	    $fields{'def_name'}{'value'} = $row[0];
	    $fields{'def_desc'}{'value'} = $row[1];
	    $fields{'def_user'}{'value'} = $row[2];
	    $fields{'def_val'}{'value'} = $row[3];
		}
	} else {
    $fields{'def_name'}{'value'} = "New Selection";
    $fields{'def_desc'}{'value'} = "";
    $fields{'def_user'}{'value'} = "";
    $fields{'def_val'}{'value'} = "";
    $fields{'def_id'}{'value'} = 0;
  }
  $fields{'displayBackFormButton'} = 1;
  return \%fields;
}

sub save {
  my ($self,$cgiO) = @_; # Object of CGI.pm
  my $archiveO = $self->archive;
  my $dbh = $archiveO->db->dbh;
  my $id = $cgiO->param("id");
  my $name = $cgiO->param("def_name");
	my $desc = $cgiO->param("def_desc");
	my $user = $cgiO->param("def_user");
	my $val = $cgiO->param("def_val");
  # Set Space because DB is not really designed.
	# you can't save NULL as description.
	# It was made in the default SQLDef -.-
  $desc = ' ' if ($desc eq '');
	# Same with user -.-
	$user = ' ' if ($user eq '');
  if ($cgiO->param("submit") eq $self->archive->lang->string("SAVE")) {
	  my $sql = "Art='SQL',Tabelle='archiv'";
	  $sql .= ",Name=".$dbh->quote($name);
		$sql .= ",Beschreibung=".$dbh->quote($desc);
		$sql .= ",User=".$dbh->quote($user);
		$sql .= ",Inhalt=".$dbh->quote($val);
    if (defined $id) {
		  $sql = "update parameter set ".$sql." where Laufnummer=$id";
		} else {
		  $sql = "insert into parameter set ".$sql;
		}
		print STDERR "SQLSQL:::".$sql.":::LQSLQS";
		$dbh->do($sql);
  }
}

sub copy {
  my ($self,$cgi) = @_;
  my $id = $cgi->param('id');
  my $search = "Name,Beschreibung,User,Inhalt";
  my $sql = "select $search from parameter where Laufnummer = $id";
	my @result = $self->archive->db->dbh->selectrow_array($sql);
  my $name = "Copy of ".$result[0];
	my $desc = $result[1];
	my $user = $result[2];
	my $val = $result[3];
  my $txt = "def_name=$name;\n";
    $txt .= "def_desc=$desc;\n";
    $txt .= "def_user=$user;\n";
    $txt .= "def_val=$val;\n";
	my $file = $self->_getFileName();
	open(FOUT,">",$file);
	binmode(FOUT);
	print FOUT $txt;
	close(FOUT);
}

sub paste {
  my ($self,$cgi) = @_;
	my ($file,$txt); 
  $file = $self->_getFileName();
	open(FIN,"<",$file);
	binmode(FIN);
	while(<FIN>) {
	  $txt .= $_;
	}
	close(FIN);
  # &id=value;&id2=value2;...
	my @lines = split(";\n",$txt);
	foreach my $line (@lines) {
		$line =~ /^(\w+)=(.+)?$/;
		print STDERR "$line\n";
		my $id = $1;
		my $value = $2;
		# Set CGI Param
		print STDERR "$id -> $value\n";
		$cgi->param(-name=>$id,-value=>$value);
	}
	# Save needs submit to be $lang->string("SAVE");
	# Else it does not do anything
	my $value = $self->archive->lang->string("SAVE");
	$cgi->param(-name=>'submit',-value=>$value);
	$self->save($cgi);
	# delete file after pasting
	unlink $file;
}

sub _getFileName {
  my ($self) = @_;
  my $file;
	$file = "/tmp/".$self->archive->session->user();
	$file .= "-".$self->archive->session->host().".sqldef";
	return $file;
}

sub elements {
  my ($self) = @_;
  my $archiveO = $self->archive;
  my $langO = $archiveO->lang;
	my $dbh = $archiveO->db->dbh;
  my (%scanDefs,@list,@attributes);
	@attributes = ("Name");
  my $query = "SELECT Laufnummer,Name FROM parameter ";
  $query .= "WHERE Art = 'SQL' AND Tabelle = 'archiv'";
  my $sth = $dbh->prepare($query);
  $sth->execute;
	my $first=1;
  while (my @row = $sth->fetchrow_array()) {
		my $def = $row[0];
		push @list, $def;
    $scanDefs{$def}{'Name'} = $row[1];
		if ($first==1) {
      $scanDefs{$def}{'delete'} = 0;
			$first=0;
		} else {
      $scanDefs{$def}{'delete'} = 1;
		}
		$scanDefs{$def}{'copy'} = 1;
    $scanDefs{$def}{'update'} = 1;
  }
  $scanDefs{'new'} = 1;
	$scanDefs{'paste'} = 1;
  $scanDefs{'attributes'} = \@attributes;
  $scanDefs{'list'} = \@list;
  return \%scanDefs;
}

sub delete {
  my ($self,$cgiO) = @_;
  my $archiveO = $self->archive;
	my $dbh = $archiveO->db->dbh;
  my $id = $cgiO->param("id");
  if (defined $id) {
	  my $sql = "delete from parameter where Laufnummer=$id";
		$dbh->do($sql);
	}
}

sub archive {
  my ($self) = @_;
  return $self->{'archiveO'};
}

1;

