
package PL::ScanDefAdministration;
use strict;

sub new {
  my ($cls,$archiveO) = @_; # Object of Archivista::BL::Archive (APCL)
  my $self = {};
  bless $self, $cls;
  my @fields = ("def_name","def_key","def_notactive","def_scan_type","def_dpi",
	  "def_brightness","def_contrast","def_threshold", "def_emptypages",
		"def_deskew","def_autocrop","def_bwopt_on","def_bwopt_radius",
		"def_bwopt_threshold","def_bwopt_outputdpi","def_jpeg_compr",
		"def_double_feed","def_x","def_y","def_left","def_top","def_auto_fields",
		"def_box_bc","def_form_rec","def_rotation","def_split","def_adf",
	  "def_nr_of_pages","def_wait_seconds","def_sleep","def_ocr","def_new_docs",
		"def_new_pages","def_ocrwait","def_addlastdoc","def_call_convert");
  $self->{'archiveO'} = $archiveO;
  $self->{'field_list'} = \@fields;
  return $self;
}

sub fields {
  my ($self,$cgiO) = @_;
  my $archiveO = $self->archive;
  my $langO = $self->archive->lang;
  my $pascanTypes = $archiveO->scanTypes("ARRAY");
  my $phscanTypes = $archiveO->scanTypes("HASH");
  my $pabcTypes = $archiveO->barcodeSelectData("ARRAY");
  my $phbcTypes = $archiveO->barcodeSelectData("HASH");
  my $paocrTypes = $archiveO->ocrSelectData("ARRAY");
  my $phocrTypes = $archiveO->ocrSelectData("HASH");
  my $pascanRotations = $archiveO->scanRotations("ARRAY");
  my $phscanRotations = $archiveO->scanRotations("HASH");
  my $paADFTypes = $archiveO->adfTypes("ARRAY");
  my $phADFTypes = $archiveO->adfTypes("HASH");
	my $paFormRec = $self->formRec("ARRAY");
	my $phFormRec = $self->formRec("HASH");
  my $paDoublefeedTypes = $archiveO->doublefeedTypes("ARRAY");
  my $phDoublefeedTypes = $archiveO->doublefeedTypes("HASH");
  # Add an empty item to adf types
  unshift @$paADFTypes, "0";
  $$phADFTypes{'0'} = $langO->string("NO");
  # Add auto pilot as adf type
  push @$paADFTypes, "2";
  $$phADFTypes{'2'} = $langO->string("AUTO_PILOT");
  my (%fields);  
  $fields{'list'} = $self->{'field_list'};
  $fields{'def_name'}{'label'} = $langO->string("NAME");
  $fields{'def_name'}{'name'} = "def_name";
  $fields{'def_name'}{'type'} = "textfield";
  $fields{'def_name'}{'update'} = 1;
  $fields{'list'} = $self->{'field_list'};
  $fields{'def_key'}{'label'} = $langO->string("CODE");
  $fields{'def_key'}{'name'} = "def_key";
  $fields{'def_key'}{'type'} = "textfield";
  $fields{'def_key'}{'update'} = 1;
	$fields{'def_notactive'}{'label'} = $langO->string("NOTACTIVE");
  $fields{'def_notactive'}{'name'} = "def_notactive";
  $fields{'def_notactive'}{'type'} = "checkbox";
  $fields{'def_notactive'}{'update'} = 1;
  $fields{'def_scan_type'}{'label'} = $langO->string("SCAN_TYPE");
  $fields{'def_scan_type'}{'name'} = "def_scan_type";
  $fields{'def_scan_type'}{'type'} = "select";
  $fields{'def_scan_type'}{'array_values'} = $pascanTypes;
  $fields{'def_scan_type'}{'hash_values'} = $phscanTypes;
  $fields{'def_scan_type'}{'update'} = 1;
  $fields{'def_dpi'}{'label'} = $langO->string("RESOLUTION")." (dpi)";
  $fields{'def_dpi'}{'name'} = "def_dpi";
  $fields{'def_dpi'}{'type'} = "textfield";
  $fields{'def_dpi'}{'update'} = 1;
  $fields{'def_brightness'}{'label'} = $langO->string("BRIGHTNESS");
  $fields{'def_brightness'}{'name'} = "def_brightness";
  $fields{'def_brightness'}{'type'} = "textfield";
  $fields{'def_brightness'}{'update'} = 1;
  $fields{'def_contrast'}{'label'} = $langO->string("CONTRAST");
  $fields{'def_contrast'}{'name'} = "def_contrast";
  $fields{'def_contrast'}{'type'} = "textfield";
  $fields{'def_contrast'}{'update'} = 1;
  $fields{'def_threshold'}{'label'} = $langO->string("GAMMA");
  $fields{'def_threshold'}{'name'} = "def_threshold";
  $fields{'def_threshold'}{'type'} = "textfield";
  $fields{'def_threshold'}{'update'} = 1;
  $fields{'def_emptypages'}{'label'} = $langO->string("EMPTYPAGES");
  $fields{'def_emptypages'}{'name'} = "def_emptypages";
  $fields{'def_emptypages'}{'type'} = "textfield";
  $fields{'def_emptypages'}{'update'} = 1;
  $fields{'def_deskew'}{'label'} = $langO->string("SCAN_DESKEW");
  $fields{'def_deskew'}{'name'} = "def_deskew";
  $fields{'def_deskew'}{'type'} = "checkbox";
  $fields{'def_deskew'}{'update'} = 1;
  $fields{'def_autocrop'}{'label'} = $langO->string("SCAN_AUTOCROP");
  $fields{'def_autocrop'}{'name'} = "def_autocrop";
  $fields{'def_autocrop'}{'type'} = "checkbox";
  $fields{'def_autocrop'}{'update'} = 1;
  $fields{'def_bwopt_on'}{'label'} = $langO->string("SCANBW_OPTON");
  $fields{'def_bwopt_on'}{'name'} = "def_bwopt_on";
  $fields{'def_bwopt_on'}{'type'} = "checkbox";
  $fields{'def_bwopt_on'}{'update'} = 1;
  $fields{'def_bwopt_radius'}{'label'} = $langO->string("SCANBW_RADIUS");
  $fields{'def_bwopt_radius'}{'name'} = "def_bwopt_radius";
  $fields{'def_bwopt_radius'}{'type'} = "textfield";
  $fields{'def_bwopt_radius'}{'update'} = 1;
  $fields{'def_bwopt_threshold'}{'label'} = $langO->string("SCANBW_THRESHOLD");
  $fields{'def_bwopt_threshold'}{'name'} = "def_bwopt_threshold";
  $fields{'def_bwopt_threshold'}{'type'} = "textfield";
  $fields{'def_bwopt_threshold'}{'update'} = 1;
  $fields{'def_bwopt_outputdpi'}{'label'} = $langO->string("SCANBW_OUTPUTDPI");
  $fields{'def_bwopt_outputdpi'}{'name'} = "def_bwopt_outputdpi";
  $fields{'def_bwopt_outputdpi'}{'type'} = "textfield";
  $fields{'def_bwopt_outputdpi'}{'update'} = 1;
  $fields{'def_jpeg_compr'}{'label'} = $langO->string("SCAN_JPEG");
  $fields{'def_jpeg_compr'}{'name'} = "def_jpeg_compr";
  $fields{'def_jpeg_compr'}{'type'} = "textfield";
  $fields{'def_jpeg_compr'}{'update'} = 1;
	$fields{'def_double_feed'}{'label'} = $langO->string("SCAN_DOUBLEFEED");
  $fields{'def_double_feed'}{'type'} = "select";
  $fields{'def_double_feed'}{'name'} = "def_double_feed";
  $fields{'def_double_feed'}{'array_values'} = $paDoublefeedTypes;
  $fields{'def_double_feed'}{'hash_values'} = $phDoublefeedTypes;
  $fields{'def_double_feed'}{'update'} = 1;
  $fields{'def_x'}{'label'} = $langO->string("SCAN_WIDTH")." (mm)";
  $fields{'def_x'}{'name'} = "def_x";
  $fields{'def_x'}{'type'} = "textfield";
  $fields{'def_x'}{'update'} = 1;
  $fields{'def_y'}{'label'} = $langO->string("SCAN_HEIGHT")." (mm)";
  $fields{'def_y'}{'name'} = "def_y";
  $fields{'def_y'}{'type'} = "textfield";
  $fields{'def_y'}{'update'} = 1;
  $fields{'def_left'}{'label'}=$langO->string("POSITION_LEFT_BORDER")." (mm)";
  $fields{'def_left'}{'name'} = "def_left";
  $fields{'def_left'}{'type'} = "textfield";
  $fields{'def_left'}{'update'} = 1;
  $fields{'def_top'}{'label'} = $langO->string("POSITION_TOP_BORDER")." (mm)";
  $fields{'def_top'}{'name'} = "def_top";
  $fields{'def_top'}{'type'} = "textfield";
  $fields{'def_top'}{'update'} = 1;
  $fields{'def_auto_fields'}{'label'} = $langO->string("AUTO_FIELDS");
  $fields{'def_auto_fields'}{'name'} = "def_auto_fields";
  $fields{'def_auto_fields'}{'type'} = "textfield";
  $fields{'def_auto_fields'}{'update'} = 1;
  $fields{'def_box_bc'}{'label'} = $langO->string("BOX_BARCODEDEF");
  $fields{'def_box_bc'}{'name'} = "def_box_bc";
  $fields{'def_box_bc'}{'type'} = "select";
  $fields{'def_box_bc'}{'array_values'} = $pabcTypes;
  $fields{'def_box_bc'}{'hash_values'} = $phbcTypes;
  $fields{'def_box_bc'}{'update'} = 1;
  $fields{'def_form_rec'}{'label'} = $langO->string("FORM_RECOGNITION");
  $fields{'def_form_rec'}{'name'} = "def_form_rec";
  $fields{'def_form_rec'}{'type'} = "select";
  $fields{'def_form_rec'}{'array_values'} = $paFormRec;
  $fields{'def_form_rec'}{'hash_values'} = $phFormRec;
  $fields{'def_form_rec'}{'update'} = 1;
  $fields{'def_rotation'}{'label'} = $langO->string("ROTATION");
  $fields{'def_rotation'}{'name'} = "def_rotation";
  $fields{'def_rotation'}{'type'} = "select";
  $fields{'def_rotation'}{'array_values'} = $pascanRotations;
  $fields{'def_rotation'}{'hash_values'} = $phscanRotations;
  $fields{'def_rotation'}{'update'} = 1;
	$fields{'def_split'}{'label'} = $langO->string("SPLIT_PAGE");
  $fields{'def_split'}{'name'} = "def_split";
  $fields{'def_split'}{'type'} = "checkbox";
  $fields{'def_split'}{'update'} = 1;
  $fields{'def_adf'}{'label'} = $langO->string("MORE_PAGES");
  $fields{'def_adf'}{'name'} = "def_adf";
  $fields{'def_adf'}{'type'} = "select";
  $fields{'def_adf'}{'array_values'} = $paADFTypes;
  $fields{'def_adf'}{'hash_values'} = $phADFTypes;
  $fields{'def_adf'}{'update'} = 1;
  $fields{'def_nr_of_pages'}{'label'} = $langO->string("NR_PAGES_AUTO_PILOT");
  $fields{'def_nr_of_pages'}{'name'} = "def_nr_of_pages";
  $fields{'def_nr_of_pages'}{'type'} = "textfield";
  $fields{'def_nr_of_pages'}{'update'} = 1;
  $fields{'def_wait_seconds'}{'label'} = $langO->string("BREAK_AUTO_PILOT");
  $fields{'def_wait_seconds'}{'name'} = "def_wait_seconds";
  $fields{'def_wait_seconds'}{'type'} = "textfield";
  $fields{'def_wait_seconds'}{'update'} = 1;
  $fields{'def_sleep'}{'label'} = $langO->string("BREAK_BEFOR_SCAN");
  $fields{'def_sleep'}{'name'} = "def_sleep";
  $fields{'def_sleep'}{'type'} = "textfield";
  $fields{'def_sleep'}{'update'} = 1;
  $fields{'def_scanner_address'}{'label'} = $langO->string("SCANNER_ADDRESS");
  $fields{'def_scanner_address'}{'name'} = "def_scanner_address";
  $fields{'def_scanner_address'}{'type'} = "textfield";
  $fields{'def_scanner_address'}{'update'} = 1;
  $fields{'def_ocr'}{'label'} = $langO->string("BOX_OCRDEF");
  $fields{'def_ocr'}{'name'} = "def_ocr";
  $fields{'def_ocr'}{'type'} = "select";
  $fields{'def_ocr'}{'array_values'} = $paocrTypes;
  $fields{'def_ocr'}{'hash_values'} = $phocrTypes;
  $fields{'def_ocr'}{'update'} = 1;
	$fields{'def_new_docs'}{'label'} = $langO->string("OPEN_NEW_DOCUMENTS");
  $fields{'def_new_docs'}{'name'} = "def_new_docs";
  $fields{'def_new_docs'}{'type'} = "checkbox";
  $fields{'def_new_docs'}{'update'} = 1;
  $fields{'def_new_pages'}{'label'} = $langO->string("OPEN_NEW_PAGES");
  $fields{'def_new_pages'}{'name'} = "def_new_pages";
  $fields{'def_new_pages'}{'type'} = "textfield";
  $fields{'def_new_pages'}{'update'} = 1;
  $fields{'def_ocrwait'}{'label'} = $langO->string("OCRWAIT");
  $fields{'def_ocrwait'}{'name'} = "def_ocrwait";
  $fields{'def_ocrwait'}{'type'} = "textfield";
  $fields{'def_ocrwait'}{'update'} = 1;
	$fields{'def_addlastdoc'}{'label'} = $langO->string("ADDLASTDOC");
  $fields{'def_addlastdoc'}{'name'} = "def_addlastdoc";
  $fields{'def_addlastdoc'}{'type'} = "checkbox";
  $fields{'def_addlastdoc'}{'update'} = 1;
  $fields{'def_call_convert'}{'label'} = $langO->string("CALL_CONVERT");
  $fields{'def_call_convert'}{'name'} = "def_call_convert";
  $fields{'def_call_convert'}{'type'} = "textfield";
  $fields{'def_call_convert'}{'update'} = 1;
  if ($cgiO->param("adm") eq "edit") {
    my $id = $cgiO->param("id");
    if (defined $id) {
	    my $def = $archiveO->parameter("ScannenDefinitionen")
				->attribute("Inhalt")->scan($id);
	    $fields{'def_name'}{'value'} = $def->name;
	    $fields{'def_key'}{'value'} = $def->key;
	    $fields{'def_notactive'}{'value'} = $def->notactive;
    	$fields{'def_scan_type'}{'value'} = $def->scanType;
    	$fields{'def_dpi'}{'value'} = $def->dpi;
     	$fields{'def_brightness'}{'value'} = $def->brightness;
     	$fields{'def_contrast'}{'value'} = $def->contrast;
     	$fields{'def_threshold'}{'value'} = $def->gamma;
     	$fields{'def_emptypages'}{'value'} = $def->emptyPages;
			$fields{'def_deskew'}{'value'} = $def->adjust;
			$fields{'def_autocrop'}{'value'} = $def->truncate;
     	$fields{'def_bwopt_on'}{'value'} = $def->optimizeOn;
     	$fields{'def_bwopt_radius'}{'value'} = $def->optimizeRadius;
     	$fields{'def_bwopt_threshold'}{'value'} = $def->optimizeThreshold;
     	$fields{'def_bwopt_outputdpi'}{'value'} = $def->optimizeOutputDPI;
     	$fields{'def_jpeg_compr'}{'value'} = $def->jpegCompression;
     	$fields{'def_double_feed'}{'value'} = $def->detectDoubleFeed;
     	$fields{'def_x'}{'value'} = $def->x;
     	$fields{'def_y'}{'value'} = $def->y;
     	$fields{'def_left'}{'value'} = $def->left;
     	$fields{'def_top'}{'value'} = $def->top;
     	if ($def->autoFields ne "") {
     	  $fields{'def_auto_fields'}{'value'} = $def->autoFields;
     	}
     	if ($def->callConvert ne "") {
     	  $fields{'def_call_convert'}{'value'} = $def->callConvert;
     	}
     	$fields{'def_box_bc'}{'value'} = $def->boxBarcodeDef;
     	$fields{'def_form_rec'}{'value'} = $def->formRecognition;
     	$fields{'def_rotation'}{'value'} = $def->rotation;
			$fields{'def_split'}{'value'} = $def->splitPage;
     	$fields{'def_adf'}{'value'} = $def->adf;
     	$fields{'def_nr_of_pages'}{'value'} = $def->numberOfPages;
     	$fields{'def_wait_seconds'}{'value'} = $def->waitSeconds;
     	$fields{'def_sleep'}{'value'} = $def->sleep;
     	$fields{'def_ocr'}{'value'} = $def->ocr;
			$fields{'def_new_pages'}{'value'} = $def->newDocAfterPages;
			$fields{'def_new_docs'}{'value'} = $def->newDocument; 
			$fields{'def_ocrwait'}{'value'} = $def->ocrWait;
			$fields{'def_addlastdoc'}{'value'} = $def->addLastDoc; 
    }
  } else {
    $fields{'def_key'}{'value'} = 999;
    $fields{'def_notactive'}{'value'} = 0;
    $fields{'def_scan_type'}{'value'} = 1;
    $fields{'def_dpi'}{'value'} = 150;
    $fields{'def_brightness'}{'value'} = 0;
    $fields{'def_contrast'}{'value'} = 0;
    $fields{'def_threshold'}{'value'} = 0;
    $fields{'def_emptypages'}{'value'} = 0;
		$fields{'def_deskew'}{'value'} = 1;
		$fields{'def_autocrop'}{'value'} = 0;
    $fields{'def_bwopt_on'}{'value'} = 0;
    $fields{'def_bwopt_radius'}{'value'} = 3;
    $fields{'def_bwopt_threshold'}{'value'} = 190;
    $fields{'def_bwopt_outputdpi'}{'value'} = 300;
    $fields{'def_jpeg_compression'}{'value'} = '';
    $fields{'def_double_feed'}{'value'} = 0;
    $fields{'def_x'}{'value'} = 210;
    $fields{'def_y'}{'value'} = 297;
    $fields{'def_left'}{'value'} = 0;
    $fields{'def_top'}{'value'} = 0;
		$fields{'def_split'}{'value'} = 0;
    $fields{'def_auto_fields'}{'value'}="";
    $fields{'def_call_convert'}{'value'}="";
    $fields{'def_box_bc'}{'value'}="-1";
    $fields{'def_form_rec'}{'value'}="0";
    $fields{'def_sleep'}{'value'} = 0;
    $fields{'def_ocr'}{'value'}="0";
	  $fields{'def_new_pages'}{'value'} = 0;
		$fields{'def_new_docs'}{'value'} = 0; 
	  $fields{'def_ocrwait'}{'value'} = 0;
		$fields{'def_addlastdoc'}{'value'} = 0; 
  }
  $fields{'displayBackFormButton'} = 1;
  return \%fields;
}

sub save {
  my ($self,$cgiO) = @_;
  my $archiveO = $self->archive;
  my $id = $cgiO->param("id");
  my ($scanDef);
  my $name = $cgiO->param("def_name");
  my $key = $cgiO->param("def_key");
	$key = $key - (2*$key);
  my $notactive = $cgiO->param("def_notactive");
  $notactive=0 if ($notactive != 1);
  my $scanType = $cgiO->param("def_scan_type");
  my $dpi = $cgiO->param("def_dpi");
  my $brightness = $cgiO->param("def_brightness");
  my $contrast = $cgiO->param("def_contrast");
	my $threshold = $cgiO->param("def_threshold");
  my $emptypages = $cgiO->param("def_emptypages");
  my $deskew = $cgiO->param("def_deskew");
  $deskew=0 if ($deskew != 1);
  my $autocrop = $cgiO->param("def_autocrop");
  $autocrop=0 if ($autocrop != 1);
  my $optimizeon = $cgiO->param("def_bwopt_on");
  $optimizeon=0 if ($optimizeon != 1);
  my $optimizeradius = $cgiO->param("def_bwopt_radius");
	my $optimizethreshold = $cgiO->param("def_bwopt_threshold");
  my $optimizeoutputdpi = $cgiO->param("def_bwopt_outputdpi");
  my $jpeg_compr = $cgiO->param("def_jpeg_compr");
  my $double_feed = $cgiO->param("def_double_feed");
  my $x = $cgiO->param("def_x");
  my $y = $cgiO->param("def_y");
  my $left = $cgiO->param("def_left");
  my $top = $cgiO->param("def_top");
  my $autofields = $cgiO->param("def_auto_fields");
  my $callconvert = $cgiO->param("def_call_convert");
  my $boxbc = $cgiO->param("def_box_bc");
  my $formrec = $cgiO->param("def_form_rec");
  my $rotation = $cgiO->param("def_rotation");
	my $split = $cgiO->param("def_split");
  $split=0 if ($split != 1);
  my $adf = $cgiO->param("def_adf");
  my $nrOfPages = $cgiO->param("def_nr_of_pages");
  my $waitSeconds = $cgiO->param("def_wait_seconds");
  my $sleep = $cgiO->param("def_sleep");
  my $ocr = $cgiO->param("def_ocr");
  my $open_new_documents = $cgiO->param("def_new_docs");
	$open_new_documents=0 if $open_new_documents!=1;
	my $open_new_pages = $cgiO->param("def_new_pages");
  my $ocrwait = $cgiO->param("def_ocrwait");
  $ocrwait=0 if ($ocrwait <0 || $ocrwait>60);
  my $addlastdoc = $cgiO->param("def_addlastdoc");
  $addlastdoc=0 if ($addlastdoc != 1);
  if ($cgiO->param("submit") eq $self->archive->lang->string("SAVE")) {
    if (defined $id) {
	    # Update the scan definition
	    $scanDef = $archiveO->parameter("ScannenDefinitionen")
		    ->attribute("Inhalt")->scan($id);
    } else {
	    $scanDef = $archiveO->parameter("ScannenDefinitionen")
				->attribute("Inhalt")->scan;
    }
    $scanDef->name($name);
    $scanDef->key($key);
    $scanDef->notactive($notactive);
    $scanDef->scanType($scanType);
    $scanDef->dpi($dpi);
    $scanDef->brightness($brightness);
    $scanDef->contrast($contrast);
		$scanDef->gamma($threshold);
    $scanDef->emptyPages($emptypages);
		$scanDef->adjust($deskew);
		$scanDef->truncate($autocrop);
    $scanDef->optimizeOn($optimizeon);
    $scanDef->optimizeRadius($optimizeradius);
    $scanDef->optimizeThreshold($optimizethreshold);
    $scanDef->optimizeOutputDPI($optimizeoutputdpi);
    $scanDef->jpegCompression($jpeg_compr);
    $scanDef->detectDoubleFeed($double_feed);
    $scanDef->x($x);
    $scanDef->y($y);
    $scanDef->left($left);
    $scanDef->top($top);
    $scanDef->autoFields($autofields);
    $scanDef->boxBarcodeDef($boxbc);
		$scanDef->formRecognition($formrec);
		$scanDef->splitPage($split);
    $scanDef->rotation($rotation);
    $scanDef->adf($adf);
    $scanDef->numberOfPages($nrOfPages);
    $scanDef->waitSeconds($waitSeconds);
    $scanDef->sleep($sleep);
    $scanDef->ocr($ocr);
		$scanDef->newDocument($open_new_documents);
		$scanDef->newDocAfterPages($open_new_pages);
		$scanDef->ocrWait($ocrwait);
		$scanDef->addLastDoc($addlastdoc);
    $scanDef->callConvert($callconvert);
    if (defined $id) {
	    $scanDef->update;
    } else {
	    $scanDef->add;
    }
  }
}

sub copy {
  my ($self,$cgi) = @_;
  my $scanObj = $self->archive->scanDefinitions("HASH")->{$cgi->param('id')};
	my $scanname = $scanObj->name();
	my $sql = "select Inhalt from parameter where Name='ScannenDefinitionen' ".
	          "and Art LIKE 'parameter' and Tabelle LIKE 'parameter' limit 1";
	my @row = $self->archive->db->dbh->selectrow_array($sql);
	my @scandefs = split("\r\n",$row[0]);
	my $out = "";
	foreach (@scandefs) {
	  my $scandef = $_;
	  my @scan1 = split(";",$scandef);
		if ($scan1[0] eq $scanname) {
		  $out = $scandef;
			last;
		}
	}
	my $file = $self->_getFileName("scandef");
	open(FOUT,">",$file);
	binmode(FOUT);
	print FOUT $out;
	close(FOUT);
}

sub paste {
  my ($self,$cgi) = @_;
	my ($file,$txt); 
  $file = $self->_getFileName("scandef");
	open(FIN,"<",$file);
	binmode(FIN);
	$txt = <FIN>;
	close(FIN);
	if ($txt ne "") {
	  my @vals = split(";",$txt);
	  my $newname = $vals[0];
	  my $sql = "select Inhalt,Laufnummer from parameter ".
	          "where Name='ScannenDefinitionen' ".
	          "and Art LIKE 'parameter' and Tabelle LIKE 'parameter' limit 1";
	  my @row = $self->archive->db->dbh->selectrow_array($sql);
	  my @scandefs = split("\r\n",$row[0]);
	  while ($newname ne "") {
	    my $found=0;
	    foreach (@scandefs) {
	      my $scandef = $_;
	      my @scan1 = split(";",$scandef);
		    if ($scan1[0] eq $newname) {
			    $found=1;
				  $newname = "Copy of ".$newname;
				  next;
			  }
		  }
		  if ($found==0) {
		    $vals[0] = $newname;
			  $newname="";
		  }
	  }
		my $lastnr = @scandefs;
		if ($lastnr>0) {
		  $lastnr--;
		  my $lastdef = $scandefs[$lastnr];
		  my @vals1 = split(";",$lastdef);
		  my $lastnr1 = $vals1[22];
		  $lastnr1++;
		  $vals[22] = $lastnr1;
		}
		my $old = $row[0];
		$old =~ s/\r+$//g;
		$old =~ s/\n+$//g;
	  $txt = join(";",@vals);
	  my $scandefs = $old."\r\n".$txt;
	  my $scanquote = $self->archive->db->dbh->quote($scandefs);
	  $sql = "update parameter set Inhalt=$scanquote ".
	         "where Laufnummer=$row[1]";
	  $self->archive->db->dbh->do($sql);
	  # delete file after pasting
	  unlink $file;
	}
}

sub _getFileName {
  my ($self,$type) = @_;
  my $file;
	$file = "/tmp/".$self->archive->session->user();
	$file .= "-".$self->archive->session->host().".$type";
	if (!-e $file) {
	  my @files = </tmp/*$type>;
		foreach (@files) {
		  my $file1 = $_;
			if (-e $file1) {
			  $file = $file1;
				last;
			}
		}
	}
	return $file;
}

sub elements {
  my ($self) = @_;
  my $pascanDefs = $self->archive->scanDefinitions("ARRAY");
  my (%scanDefs,@list);
  # Attributes to display on table
	my @attributes = ("Code","Name","NotActive");
  my $sql = "select Inhalt from parameter where Name='ScannenDefinitionen' ".
	          "and Art LIKE 'parameter' and Tabelle LIKE 'parameter' limit 1";
	my @row = $self->archive->db->dbh->selectrow_array($sql);
	my @scandefs = split("\r\n",$row[0]);
	my $c=0;
  foreach my $def (@$pascanDefs) {
	  push @list,$def;
    $scanDefs{$def}{'Name'} = $def;
		my $def1 = $scandefs[$c];
		my @vals2 = split(";",$def1);
    $scanDefs{$def}{'Code'} = $vals2[22];
		my $notactive = $vals2[18];
    $notactive = "" if $notactive != 1;		
    $scanDefs{$def}{'NotActive'} = $notactive;
		if ($c>0) {
      $scanDefs{$def}{'delete'}=1;
		} else {
			$scanDefs{$def}{'delete'}=0;
		}
		$scanDefs{$def}{'copy'} = 1;
		$scanDefs{$def}{'update'} = 1;
		$c++;
  }
	$scanDefs{'paste'} = 1;
  $scanDefs{'new'} = 1;
	$scanDefs{'list'}=\@list;
	$scanDefs{'attributes'} = \@attributes;
  return \%scanDefs;
}

sub delete {
  my ($self,$cgiO) = @_;
  my $archiveO = $self->archive;
  my $id = $cgiO->param("id");
  if (defined $id) {
    $archiveO->parameter("ScannenDefinitionen")
			->attribute("Inhalt")->scan($id)->remove;
  }
}

sub archive {
  my ($self) = @_;
  return $self->{'archiveO'};
}

sub formRec {
  my ($self,$art) = @_;
	my $sql = "select Art,Name,Inhalt from parameter where ".
	          "Art LIKE 'FormRecognition__' and Tabelle='archiv' order by Art";
	my $prows = $self->archive->db->dbh->selectall_arrayref($sql);
	my (@nrs,@names,%hash);
	push @nrs,"FormRecognition00";
	push @names,$self->archive->lang->{'NO2'};
	foreach my $prow (@$prows) {
	  push @nrs, $$prow[0];
	  push @names, $$prow[1];
	}
	if ($art eq "ARRAY") {
	  return \@nrs;
	} else {
		my $c=0;
	  foreach (@nrs) {
		  $hash{$_}=$names[$c];
			$c++;
		}
		return \%hash;
	}
}

1;

