
package PL::UserAdministration;
use strict;

sub new {
	my ($cls,$archiveO) = @_; # Object of Archivista::BL::Archive (APCL)
	my $self = {};
	bless $self, $cls;
	my @fields = ("host","username","new_password","password","clear_password",
		"level","new_documents","new_documents_owner","group","avform","avstart",
		"email","annex","notes");
  $self->{'archiveO'} = $archiveO;
	$self->{'field_list'} = \@fields;
  return $self;
}

sub fields {
  my ($self,$cgiO) = @_;
	my $archiveO = $self->archive;
  my $langO = $self->archive->lang;
  my $papasswordTypes = $archiveO->passwordTypes("ARRAY");
	my $phpasswordTypes = $archiveO->passwordTypes("HASH");
  my $phuserLevels = $archiveO->userLevelsByHash;
	my $pauserLevels = $archiveO->userLevelsByArray;
	my $panewDocumentOwners = $archiveO->documentOwners;
	my $phnewDocumentOwners = $archiveO->documentOwners("HASH");
	my $phmaskDefinitions = $archiveO->maskDefinitions;
	my @maskDefinitions = sort keys %$phmaskDefinitions;
  my $phuserSqlDefinitions = $archiveO->userSqlDefinitions;
	my @userSqlDefinitions = sort keys %$phuserSqlDefinitions;
  # Add an empty item to sql definitions
	unshift @userSqlDefinitions, "";
  # Drop 0 value!
	shift @$papasswordTypes;
	my (%fields);	
  $fields{'list'} = $self->{'field_list'};
  $fields{'host'}{'label'} = $langO->string("HOST");
	$fields{'host'}{'name'} = "user_host";
	$fields{'host'}{'type'} = "textfield";
	$fields{'host'}{'update'} = 0;
	$fields{'username'}{'label'} = $langO->string("USERNAME");
	$fields{'username'}{'name'} = "user_name";
	$fields{'username'}{'type'} = "textfield";
	$fields{'username'}{'update'} = 0;
  $fields{'new_password'}{'label'} = $langO->string("PASSWORD");
	$fields{'new_password'}{'name'} = "user_new_password";
	$fields{'new_password'}{'type'} = "password";
	$fields{'new_password'}{'update'} = 1;
	$fields{'password'}{'label'} = $langO->string("web_login");
	$fields{'password'}{'name'} = "user_passwordtype";
	$fields{'password'}{'type'} = "select";
	$fields{'password'}{'array_values'} = $papasswordTypes;
	$fields{'password'}{'hash_values'} = $phpasswordTypes;
	$fields{'password'}{'update'} = 1;
	$fields{'clear_password'}{'label'} = $langO->string("CLEAR_PASSWORD");
	$fields{'clear_password'}{'name'} = "user_clear_password";
	$fields{'clear_password'}{'type'} = "checkbox";
	$fields{'clear_password'}{'update'} = 1;
	$fields{'level'}{'label'} = $langO->string("LEVEL");
	$fields{'level'}{'name'} = "user_level";
	$fields{'level'}{'type'} = "select";
	$fields{'level'}{'array_values'} = $pauserLevels;
	$fields{'level'}{'hash_values'} = $phuserLevels;
	$fields{'level'}{'update'} = 1;
	$fields{'new_documents'}{'label'} = $langO->string("OPEN_NEW_DOCUMENTS");
	$fields{'new_documents'}{'name'} = "user_new_documents";
	$fields{'new_documents'}{'type'} = "checkbox";
	$fields{'new_documents'}{'update'} = 1;
	$fields{'new_documents_owner'}{'label'}=$langO->string("NEW_DOCUMENTS_OWNER");
	$fields{'new_documents_owner'}{'name'} = "new_documents_owner";
	$fields{'new_documents_owner'}{'type'} = "select";
	$fields{'new_documents_owner'}{'array_values'} = $panewDocumentOwners;
	$fields{'new_documents_owner'}{'hash_values'} = $phnewDocumentOwners;
	$fields{'new_documents_owner'}{'update'} = 1;
	$fields{'group'}{'label'} = $langO->string("GROUPS");
	$fields{'group'}{'name'} = "user_group";
	$fields{'group'}{'type'} = "textfield";
	$fields{'group'}{'update'} = 1;
	$fields{'avform'}{'label'} = $langO->string("FORM_DEFINITION");
	$fields{'avform'}{'name'} = "user_avform";
	$fields{'avform'}{'type'} = "select";
  $fields{'avform'}{'array_values'} = \@maskDefinitions;
	$fields{'avform'}{'hash_values'} = $phmaskDefinitions;
	$fields{'avform'}{'update'} = 1;
	$fields{'avstart'}{'label'} = $langO->string("SQL_DEFINITION");
	$fields{'avstart'}{'name'} = "user_avstart";
	$fields{'avstart'}{'type'} = "select";
	$fields{'avstart'}{'array_values'} = \@userSqlDefinitions;
	$fields{'avstart'}{'hash_values'} = $phuserSqlDefinitions;
	$fields{'avstart'}{'update'} = 1;
	$fields{'email'}{'label'} = $langO->string("EMAIL_ACCOUNT");
	$fields{'email'}{'name'} = "user_email";
	$fields{'email'}{'type'} = "textfield";
	$fields{'email'}{'update'} = 1;
	$fields{'annex'}{'label'} = $langO->string("ANNEX");
	$fields{'annex'}{'name'} = "user_annex";
  $fields{'annex'}{'type'} = "textfield";
	$fields{'annex'}{'update'} = 1;
	$fields{'notes'}{'label'} = $langO->string("NOTES");
	$fields{'notes'}{'name'} = "user_notes";
	$fields{'notes'}{'type'} = "textarea";
	$fields{'notes'}{'update'} = 1;
  if ($cgiO->param("adm") eq "edit") {
		my $id = $cgiO->param("id");
		if (defined $id) {
			my $user = $archiveO->user($id);
			my $newPwdOnLogin = 0;
			$newPwdOnLogin = 1 if ($user->attribute("PWArt")->value == 2);
			$fields{'host'}{'value'} = $user->attribute("Host")->value;
			$fields{'username'}{'value'} = $user->attribute("User")->value;
			$fields{'password'}{'valme'} = $user->attribute("PWArt")->value;
			$fields{'level'}{'value'} = $user->attribute("Level")->value;
			$fields{'new_documents'}{'value'} = $user->attribute("AddOn")->value;
			$fields{'new_documents_owner'}{'value'} = 
				$user->attribute("AddNew")->value;
		  $fields{'numberof'}{'value'} = 1000;
		  $fields{'internal_pages'}{'value'} = 1;
		  $fields{'web'}{'value'} = 1;
		  $fields{'workflow'}{'value'} = 0;
			$fields{'avform'}{'value'} = 
				sprintf "%02d", $user->attribute("AVForm")->value; 
				# Display 01,02,03 not 1,2,3
			$fields{'avstart'}{'value'} = $user->attribute("AVStart")->value;
			$fields{'group'}{'value'} = $user->attribute("Alias")->value;
		  $fields{'email'}{'value'} = $user->attribute("EMail")->value;
			$fields{'annex'}{'value'} = $user->attribute("Zusatz")->value;
			$fields{'notes'}{'value'} = $user->attribute("Bemerkungen")->value;
		}
	} else {
		$fields{'host'}{'value'} = "localhost";
		$fields{'password'}{'value'} = "3";
		$fields{'numberof'}{'value'} = 1000;
		$fields{'internal_pages'}{'value'} = 1;
		$fields{'web'}{'value'} = 1;
		$fields{'workflow'}{'value'} = 0;
		$fields{'new_documents'}{'value'} = 1;
		$fields{'level'}{'value'} = 1;
	}
  $fields{'displayBackFormButton'} = 1;
  return \%fields;
}

sub save {
  my ($self,$cgiO) = @_;
	my $archiveO = $self->archive;
  my $id = $cgiO->param("id");
  my ($user);
  my $host = $cgiO->param("user_host");
  my $uid = $cgiO->param("user_name");
	my $pwd = $cgiO->param("user_new_password");
	my $clearPwd = $cgiO->param("user_clear_password");
	my $passwordType = $cgiO->param("user_passwordtype");
	my $level = $cgiO->param("user_level");
	my $newDocuments = $cgiO->param("user_new_documents");
	my $newDocumentsOwner = $cgiO->param("new_documents_owner");
	my $group = $cgiO->param("user_group");
  my $internalPages = 1;
	my $web = 1;
	my $workflow = 0;
	my $numberof = 1000;
  my $avform = int $cgiO->param("user_avform"); # Saving 1,2,3 not 01,02,03
	my $avstart = int $cgiO->param("user_avstart");
	my $email = $cgiO->param("user_email");
	my $annex = $cgiO->param("user_annex");
	my $notes = $cgiO->param("user_notes");
	$web = 0 if (! defined $web);
	$internalPages = 0 if (! defined $internalPages);
	$workflow = 0 if (! defined $workflow);
	$newDocuments = 0 if (! defined $newDocuments);
	$numberof = 1000 if (! defined $numberof);
  if ((length($uid) > 0 or $id > 0) && lc($uid) ne "root") {
		if (defined $id) {
			$user = $archiveO->user($id);
			#$user->attribute("Host")->value($host);
			#$user->attribute("User")->value($uid);
			if (length($pwd) > 0) {
				$user->attribute("Password")->value($pwd);
			} elsif ($clearPwd == 1) {
				$user->attribute("Password")->value("");
			}
			$user->attribute("Level")->value($level);
		} else {
			my $userId = $archiveO->user($host,$uid,$pwd,$level)->id;
			$user = $archiveO->user($userId);
		}
    $user->attribute("PWArt")->value($passwordType);
		$user->attribute("AddOn")->value($newDocuments);
		$user->attribute("AddNew")->value($newDocumentsOwner);
		$user->attribute("ZugriffIntern")->value($internalPages);
		$user->attribute("ZugriffWeb")->value($web);
		$user->attribute("Workflow")->value($workflow);
		$user->attribute("Anzahl")->value($numberof);
		$user->attribute("AVForm")->value($avform);
		$user->attribute("AVStart")->value($avstart);
		$user->attribute("Alias")->value($group);
		$user->attribute("EMail")->value($email);
		$user->attribute("Zusatz")->value($annex);
		$user->attribute("Bemerkungen")->value($notes);
		$user->update;
	}
}

sub elements {
  my ($self) = @_;
	my $archiveO = $self->archive;
  my $langO = $archiveO->lang;
	my $pusers = $archiveO->users;
	my (@list,%users);
	# Attributes to display on table
	my @attributes = ("host","username","level");
	foreach my $user (@$pusers) {
		my $id = $$user[3];
		push @list, $id;
		$users{$id}{'host'} = $$user[0];
		$users{$id}{'username'} = $$user[1];
		$users{$id}{'level'} = $langO->string("LEVEL_".$$user[2]);
	  $users{$id}{'delete'} = $$user[4];
		$users{$id}{'update'} = $$user[5];
	}
  $users{'new'} = 1;
  $users{'attributes'} = \@attributes;
  $users{'list'} = \@list;
	return \%users;
}

sub delete {
  my ($self,$cgiO) = @_;
	my $archiveO = $self->archive;
	my $id = $cgiO->param("id");
	if (defined $id) { $archiveO->user($id)->delete; }
}

sub archive {
  my ($self) = @_;
	return $self->{'archiveO'};
}

1;

